import{Worker as t,Settings as e,ResourceType as o}from"../common/common.js";import{ArrayUtilities as r,StringUtilities as n}from"../platform/platform.js";import{ContentProviderBasedProject as i,DebuggerWorkspaceBinding as a,NetworkProject as s,CSSWorkspaceBinding as c}from"../bindings/bindings.js";import{DebuggerModel as u,CSSModel as l}from"../sdk/sdk.js";import{StaticContentProvider as d,TextRange as p}from"../text_utils/text_utils.js";import{Workspace as m}from"../workspace/workspace.js";const h=Math.min(2,navigator.hardwareConcurrency-1);let g;class _{constructor(){this._taskQueue=[],this._workerTasks=new Map}static instance(){return g||(g=new _),g}_createWorker(){const e=t.WorkerWrapper.fromURL(new URL("../formatter_worker/formatter_worker-entrypoint.js",import.meta.url));return e.onmessage=this._onWorkerMessage.bind(this,e),e.onerror=this._onWorkerError.bind(this,e),e}_processNextTask(){if(!this._taskQueue.length)return;let t=[...this._workerTasks.keys()].find((t=>!this._workerTasks.get(t)));if(!t&&this._workerTasks.size<h&&(t=this._createWorker()),!t)return;const e=this._taskQueue.shift();e&&(this._workerTasks.set(t,e),t.postMessage({method:e.method,params:e.params}))}_onWorkerMessage(t,e){const o=this._workerTasks.get(t);o&&(o.isChunked&&e.data&&!e.data.isLastChunk?o.callback(e.data):(this._workerTasks.set(t,null),this._processNextTask(),o.callback(e.data?e.data:null)))}_onWorkerError(t,e){console.error(e);const o=this._workerTasks.get(t);t.terminate(),this._workerTasks.delete(t);const r=this._createWorker();this._workerTasks.set(r,null),this._processNextTask(),o&&o.callback(null)}_runChunkedTask(t,e,o){const r=new f(t,e,(function(t){if(!t)return void o(!0,null);const e="isLastChunk"in t&&Boolean(t.isLastChunk),r="chunk"in t&&t.chunk;o(e,r)}),!0);this._taskQueue.push(r),this._processNextTask()}_runTask(t,e){return new Promise((o=>{const r=new f(t,e,o,!1);this._taskQueue.push(r),this._processNextTask()}))}format(t,e,o){const r={mimeType:t,content:e,indentString:o};return this._runTask("format",r)}javaScriptIdentifiers(t){return this._runTask("javaScriptIdentifiers",{content:t}).then((t=>t||[]))}evaluatableJavaScriptSubstring(t){return this._runTask("evaluatableJavaScriptSubstring",{content:t}).then((t=>t||""))}parseCSS(t,e){this._runChunkedTask("parseCSS",{content:t},(function(t,o){e(t,o||[])}))}javaScriptOutline(t,e){this._runChunkedTask("javaScriptOutline",{content:t},(function(t,o){e(t,o||[])}))}outlineForMimetype(t,e,o){switch(e){case"text/html":case"text/javascript":return this.javaScriptOutline(t,(function(t,e){o(t,e.map((t=>({line:t.line,column:t.column,title:t.name,subtitle:t.arguments}))))})),!0;case"text/css":return this.parseCSS(t,(function(t,e){o(t,e.map((t=>{const e="selectorText"in t?t.selectorText:t.atRule;return{line:t.lineNumber,subtitle:void 0,column:t.columnNumber,title:e}})))})),!0}return!1}findLastExpression(t){return this._runTask("findLastExpression",{content:t})}findLastFunctionCall(t){return this._runTask("findLastFunctionCall",{content:t})}argumentsList(t){return this._runTask("argumentsList",{content:t})}}class f{constructor(t,e,o,r){this.method=t,this.params=e,this.callback=o,this.isChunked=r}}function S(){return _.instance()}var k=Object.freeze({__proto__:null,FormatterWorkerPool:_,FormatResult:class{constructor(){this.content,this.mapping}},formatterWorkerPool:S,OutlineItem:undefined,FormatMapping:undefined,CSSStyleRule:undefined,CSSAtRule:undefined,CSSRule:undefined,TextRange:undefined});class C{}C.format=function(t,e,o,r){t.isDocumentOrScriptOrStyleSheet()?new T(e,o,r):new w(e,o,r)},C.locationToPosition=function(t,e,o){return(e?t[e-1]+1:0)+o},C.positionToLocation=function(t,e){const o=r.upperBound(t,e-1,r.DEFAULT_COMPARATOR);let n;return n=o?e-t[o-1]-1:e,[o,n]};class T{constructor(t,e,o){this._mimeType=t,this._originalContent=e.replace(/\r\n?|[\n\u2028\u2029]/g,"\n").replace(/^\uFEFF/,""),this._callback=o,this._initialize()}async _initialize(){const t=S(),o=e.Settings.instance().moduleSetting("textEditorIndent").get(),r=await t.format(this._mimeType,this._originalContent,o);r?this._didFormatContent(r):this._callback(this._originalContent,new L)}_didFormatContent(t){const e=n.findLineEndingIndexes(this._originalContent),o=n.findLineEndingIndexes(t.content),r=new F(e,o,t.mapping);this._callback(t.content,r)}}class w{constructor(t,e,o){o(e,new L)}}class L{originalToFormatted(t,e){return[t,e||0]}formattedToOriginal(t,e){return[t,e||0]}}class F{constructor(t,e,o){this._originalLineEndings=t,this._formattedLineEndings=e,this._mapping=o}originalToFormatted(t,e){const o=C.locationToPosition(this._originalLineEndings,t,e||0),r=this._convertPosition(this._mapping.original,this._mapping.formatted,o||0);return C.positionToLocation(this._formattedLineEndings,r)}formattedToOriginal(t,e){const o=C.locationToPosition(this._formattedLineEndings,t,e||0),r=this._convertPosition(this._mapping.formatted,this._mapping.original,o);return C.positionToLocation(this._originalLineEndings,r||0)}_convertPosition(t,e,o){const n=r.upperBound(t,o,r.DEFAULT_COMPARATOR)-1;let i=e[n]+o-t[n];return n<e.length-1&&i>e[n+1]&&(i=e[n+1]),i}}var y=Object.freeze({__proto__:null,FormatterInterface:C,ScriptFormatter:T,FormatterSourceMapping:class{originalToFormatted(t,e){throw new Error("Not implemented yet.")}formattedToOriginal(t,e){throw new Error("Not implemented yet.")}}});const b=new WeakMap;class v{constructor(t,e,o){this.originalSourceCode=t,this.formattedSourceCode=e,this.mapping=o}originalPath(){return this.originalSourceCode.project().id()+":"+this.originalSourceCode.url()}static _for(t){return b.get(t)||null}}let I=null;class M{constructor(){this._projectId="formatter:",this._project=new i.ContentProviderBasedProject(m.WorkspaceImpl.instance(),this._projectId,m.projectTypes.Formatter,"formatter",!0),this._formattedSourceCodes=new Map,this._scriptMapping=new R,this._styleMapping=new j,m.WorkspaceImpl.instance().addEventListener(m.Events.UISourceCodeRemoved,(t=>{this._onUISourceCodeRemoved(t)}),this)}static instance(){return I||(I=new M),I}async _onUISourceCodeRemoved(t){const e=t.data,o=this._formattedSourceCodes.get(e);o&&o.formatData&&await this._discardFormatData(o.formatData),this._formattedSourceCodes.delete(e)}async discardFormattedUISourceCode(t){const e=v._for(t);return e?(await this._discardFormatData(e),this._formattedSourceCodes.delete(e.originalSourceCode),e.originalSourceCode):null}async _discardFormatData(t){b.delete(t.formattedSourceCode),await this._scriptMapping._setSourceMappingEnabled(t,!1),this._styleMapping._setSourceMappingEnabled(t,!1),this._project.removeFile(t.formattedSourceCode.url())}hasFormatted(t){return this._formattedSourceCodes.has(t)}getOriginalUISourceCode(t){const e=b.get(t);return e?e.originalSourceCode:t}async format(t){const e=this._formattedSourceCodes.get(t);if(e)return e.promise;const o=new Promise((async e=>{const{content:r}=await t.requestContent();C.format(t.contentType(),t.mimeType(),r||"",(async(r,n)=>{const i=this._formattedSourceCodes.get(t);if(!i||i.promise!==o)return;let a,s=0,c="";do{a=`${t.url()}:formatted${c}`,c=":"+s++}while(this._project.uiSourceCodeForURL(a));const u=d.StaticContentProvider.fromString(a,t.contentType(),r),l=this._project.createUISourceCode(a,u.contentType()),m=new v(t,l,n);b.set(l,m),this._project.addUISourceCodeWithProvider(l,u,null,t.mimeType()),await this._scriptMapping._setSourceMappingEnabled(m,!0),await this._styleMapping._setSourceMappingEnabled(m,!0),i.formatData=m;for(const e of t.allDecorations()){const t=e.range(),o=n.originalToFormatted(t.startLine,t.startColumn),r=n.originalToFormatted(t.endLine,t.endColumn);l.addDecoration(new p.TextRange(o[0],o[1],r[0],r[1]),e.type(),e.data())}e(m)}))}));return this._formattedSourceCodes.set(t,{promise:o,formatData:null}),o}}class R{constructor(){a.DebuggerWorkspaceBinding.instance().addSourceMapping(this)}rawLocationToUILocation(t){const e=t.script(),o=e&&v._for(e);if(!o||!e)return null;if(e.isInlineScriptWithSourceURL()){const[r,n]=e.toRelativeLocation(t),[i,a]=o.mapping.originalToFormatted(r,n);return o.formattedSourceCode.uiLocation(i,a)}const[r,n]=o.mapping.originalToFormatted(t.lineNumber,t.columnNumber||0);return o.formattedSourceCode.uiLocation(r,n)}uiLocationToRawLocations(t,e,r){const n=v._for(t);if(!n)return[];const[i,c]=n.mapping.formattedToOriginal(e,r);if(n.originalSourceCode.contentType().isScript()){const t=a.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(n.originalSourceCode,i,c);return console.assert(t.every((t=>t&&Boolean(t.script())))),t}if(n.originalSourceCode.contentType()===o.resourceTypes.Document){const t=s.NetworkProject.targetForUISourceCode(n.originalSourceCode),e=t&&t.model(u.DebuggerModel);if(e){const t=e.scriptsForSourceURL(n.originalSourceCode.url()).filter((t=>t.isInlineScript()&&!t.hasSourceURL)).map((t=>t.rawLocation(i,c))).filter((t=>Boolean(t)));return console.assert(t.every((t=>t&&Boolean(t.script())))),t}}return[]}async _setSourceMappingEnabled(t,e){const o=this._scriptsForUISourceCode(t.originalSourceCode);if(!o.length)return;if(e)for(const e of o)b.set(e,t);else for(const t of o)b.delete(t);const r=o.map((t=>a.DebuggerWorkspaceBinding.instance().updateLocations(t)));await Promise.all(r)}_scriptsForUISourceCode(t){if(t.contentType()===o.resourceTypes.Document){const e=s.NetworkProject.targetForUISourceCode(t),o=e&&e.model(u.DebuggerModel);if(o){return o.scriptsForSourceURL(t.url()).filter((t=>t.isInlineScript()&&!t.hasSourceURL))}}if(t.contentType().isScript()){console.assert(!b.has(t));return a.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(t,0,0).map((t=>t.script())).filter((t=>Boolean(t)))}return[]}}const U=new WeakMap;class j{constructor(){c.CSSWorkspaceBinding.instance().addSourceMapping(this),this._headersSymbol=Symbol("Formatter.SourceFormatter.StyleMapping._headersSymbol")}rawLocationToUILocation(t){const e=t.header(),o=e&&v._for(e);if(!o)return null;const r=o.mapping.originalToFormatted(t.lineNumber,t.columnNumber||0);return o.formattedSourceCode.uiLocation(r[0],r[1])}uiLocationToRawLocations(t){const e=v._for(t.uiSourceCode);if(!e)return[];const[o,r]=e.mapping.formattedToOriginal(t.lineNumber,t.columnNumber),n=U.get(e.originalSourceCode);if(!n)return[];return n.filter((t=>t.containsLocation(o,r))).map((t=>new l.CSSLocation(t,o,r)))}async _setSourceMappingEnabled(t,e){const o=t.originalSourceCode,r=this._headersForUISourceCode(o);e?(U.set(o,r),r.forEach((e=>{b.set(e,t)}))):(U.delete(o),r.forEach((t=>{b.delete(t)})));const n=r.map((t=>c.CSSWorkspaceBinding.instance().updateLocations(t)));await Promise.all(n)}_headersForUISourceCode(t){if(t.contentType()===o.resourceTypes.Document){const e=s.NetworkProject.targetForUISourceCode(t),o=e&&e.model(l.CSSModel);if(o)return o.headersForSourceURL(t.url()).filter((t=>t.isInline&&!t.hasSourceURL))}else if(t.contentType().isStyleSheet()){return c.CSSWorkspaceBinding.instance().uiLocationToRawLocations(t.uiLocation(0,0)).map((t=>t.header())).filter((t=>Boolean(t)))}return[]}}var E=Object.freeze({__proto__:null,SourceFormatData:v,SourceFormatter:M});export{k as FormatterWorkerPool,y as ScriptFormatter,E as SourceFormatter};
