import{StringUtilities as t,ArrayUtilities as e}from"../platform/platform.js";import{Runtime as i}from"../root/root.js";import{tokenizer as s,tokTypes as r,parse as n}from"../third_party/acorn/acorn.js";import{TextCursor as a}from"../text_utils/text_utils.js";class o{constructor(e){this._content=e,this._comments=[],this._tokenizer=s(this._content,{onComment:this._comments,ecmaVersion:h,allowHashBang:!0});const i=t.findLineEndingIndexes(this._content);this._textCursor=new a.TextCursor(i),this._tokenLineStart=0,this._tokenLineEnd=0,this._tokenColumnStart=0,0===this._comments.length&&this._nextTokenInternal(),this._bufferedToken}static punctuator(t,e){return t.type!==r.num&&t.type!==r.regexp&&t.type!==r.string&&t.type!==r.name&&!t.type.keyword&&(!e||1===t.type.label.length&&-1!==e.indexOf(t.type.label))}static keyword(t,e){return Boolean(t.type.keyword)&&t.type!==r._true&&t.type!==r._false&&t.type!==r._null&&(!e||t.type.keyword===e)}static identifier(t,e){return t.type===r.name&&(!e||t.value===e)}static lineComment(t){return"Line"===t.type}static blockComment(t){return"Block"===t.type}_nextTokenInternal(){if(this._comments.length){const t=this._comments.shift();return this._bufferedToken||0!==this._comments.length||(this._bufferedToken=this._tokenizer.getToken()),t}const t=this._bufferedToken;return this._bufferedToken=this._tokenizer.getToken(),t}nextToken(){const t=this._nextTokenInternal();return t&&t.type!==r.eof?(this._textCursor.advance(t.start),this._tokenLineStart=this._textCursor.lineNumber(),this._tokenColumnStart=this._textCursor.columnNumber(),this._textCursor.advance(t.end),this._tokenLineEnd=this._textCursor.lineNumber(),t):null}peekToken(){return this._comments.length?this._comments[0]:this._bufferedToken&&this._bufferedToken.type!==r.eof?this._bufferedToken:null}tokenLineStart(){return this._tokenLineStart}tokenLineEnd(){return this._tokenLineEnd}tokenColumnStart(){return this._tokenColumnStart}}const h=2021,p={};class c{constructor(t,e){this._beforeVisit=t,this._afterVisit=e||new Function,this._walkNulls=!1}static get SkipSubtree(){return p}setWalkNulls(t){this._walkNulls=t}walk(t){this._innerWalk(t,null)}_innerWalk(t,e){if(!t&&e&&this._walkNulls){const e={raw:"null",value:null,parent:null,type:"Literal"};t=e}if(!t)return;if(t.parent=e,this._beforeVisit.call(null,t)===c.SkipSubtree)return void this._afterVisit.call(null,t);const i=l[t.type];if(i){if("TemplateLiteral"===t.type){const e=t,i=e.expressions.length;for(let t=0;t<i;++t)this._innerWalk(e.quasis[t],e),this._innerWalk(e.expressions[t],e);this._innerWalk(e.quasis[i],e)}else for(let e=0;e<i.length;++e){const s=t[i[e]];Array.isArray(s)?this._walkArray(s,t):this._innerWalk(s,t)}this._afterVisit.call(null,t)}else console.error("Walk order not defined for "+t.type)}_walkArray(t,e){for(let i=0;i<t.length;++i)this._innerWalk(t[i],e)}}const l={AwaitExpression:["argument"],ArrayExpression:["elements"],ArrayPattern:["elements"],ArrowFunctionExpression:["params","body"],AssignmentExpression:["left","right"],AssignmentPattern:["left","right"],BinaryExpression:["left","right"],BlockStatement:["body"],BreakStatement:["label"],CallExpression:["callee","arguments"],CatchClause:["param","body"],ClassBody:["body"],ClassDeclaration:["id","superClass","body"],ClassExpression:["id","superClass","body"],ChainExpression:["expression"],ConditionalExpression:["test","consequent","alternate"],ContinueStatement:["label"],DebuggerStatement:[],DoWhileStatement:["body","test"],EmptyStatement:[],ExpressionStatement:["expression"],ForInStatement:["left","right","body"],ForOfStatement:["left","right","body"],ForStatement:["init","test","update","body"],FunctionDeclaration:["id","params","body"],FunctionExpression:["id","params","body"],Identifier:[],ImportDeclaration:["specifiers","source"],ImportDefaultSpecifier:["local"],ImportNamespaceSpecifier:["local"],ImportSpecifier:["imported","local"],ImportExpression:["source"],ExportAllDeclaration:["source"],ExportDefaultDeclaration:["declaration"],ExportNamedDeclaration:["specifiers","source","declaration"],ExportSpecifier:["exported","local"],IfStatement:["test","consequent","alternate"],LabeledStatement:["label","body"],Literal:[],LogicalExpression:["left","right"],MemberExpression:["object","property"],MetaProperty:["meta","property"],MethodDefinition:["key","value"],NewExpression:["callee","arguments"],ObjectExpression:["properties"],ObjectPattern:["properties"],ParenthesizedExpression:["expression"],Program:["body"],Property:["key","value"],RestElement:["argument"],ReturnStatement:["argument"],SequenceExpression:["expressions"],SpreadElement:["argument"],Super:[],SwitchCase:["test","consequent"],SwitchStatement:["discriminant","cases"],TaggedTemplateExpression:["tag","quasi"],TemplateElement:[],TemplateLiteral:["quasis","expressions"],ThisExpression:[],ThrowStatement:["argument"],TryStatement:["block","handler","finalizer"],UnaryExpression:["argument"],UpdateExpression:["argument"],VariableDeclaration:["declarations"],VariableDeclarator:["id","init"],WhileStatement:["test","body"],WithStatement:["object","body"],YieldExpression:["argument"]};class u{constructor(t){this.indentString=t,this.lastOriginalPosition=0,this.formattedContent=[],this.formattedContentLength=0,this.lastFormattedPosition=0,this.nestingLevel=0,this.newLines=0,this.enforceSpaceBetweenWords=!0,this.softSpace=!1,this.hardSpaces=0,this.cachedIndents=new Map,this.mapping={original:[0],formatted:[0]}}setEnforceSpaceBetweenWords(t){const e=this.enforceSpaceBetweenWords;return this.enforceSpaceBetweenWords=t,e}addToken(t,e){const i=this.formattedContent[this.formattedContent.length-1];this.enforceSpaceBetweenWords&&i&&/\w/.test(i[i.length-1])&&/\w/.test(t)&&this.addSoftSpace(),this.appendFormatting(),this.addMappingIfNeeded(e),this.addText(t)}addSoftSpace(){this.hardSpaces||(this.softSpace=!0)}addHardSpace(){this.softSpace=!1,++this.hardSpaces}addNewLine(t){this.formattedContentLength&&(t?++this.newLines:this.newLines=this.newLines||1)}increaseNestingLevel(){this.nestingLevel+=1}decreaseNestingLevel(){this.nestingLevel>0&&(this.nestingLevel-=1)}content(){return this.formattedContent.join("")+(this.newLines?"\n":"")}appendFormatting(){if(this.newLines){for(let t=0;t<this.newLines;++t)this.addText("\n");this.addText(this.indent())}else this.softSpace&&this.addText(" ");if(this.hardSpaces)for(let t=0;t<this.hardSpaces;++t)this.addText(" ");this.newLines=0,this.softSpace=!1,this.hardSpaces=0}indent(){const t=this.cachedIndents.get(this.nestingLevel);if(t)return t;let e="";for(let t=0;t<this.nestingLevel;++t)e+=this.indentString;return this.nestingLevel<=20&&this.cachedIndents.set(this.nestingLevel,e),e}addText(t){this.formattedContent.push(t),this.formattedContentLength+=t.length}addMappingIfNeeded(t){t-this.lastOriginalPosition!=this.formattedContentLength-this.lastFormattedPosition&&(this.mapping.original.push(t),this.lastOriginalPosition=t,this.mapping.formatted.push(this.formattedContentLength),this.lastFormattedPosition=this.formattedContentLength)}}var d=Object.freeze({__proto__:null,FormattedContentBuilder:u});class f{constructor(t){this._builder=t,this._tokenizer,this._content,this._fromOffset,this._lastLineNumber}format(t,e,i,s){this._fromOffset=i,this._toOffset=s,this._content=t.substring(this._fromOffset,this._toOffset),this._lastLineNumber=0,this._tokenizer=new o(this._content);const r=n(this._content,{ranges:!1,preserveParens:!0,allowImportExportEverywhere:!0,ecmaVersion:h,allowHashBang:!0});new c(this._beforeVisit.bind(this),this._afterVisit.bind(this)).walk(r)}_push(t,e){for(let i=0;i<e.length;++i)"s"===e[i]?this._builder.addSoftSpace():"S"===e[i]?this._builder.addHardSpace():"n"===e[i]?this._builder.addNewLine():">"===e[i]?this._builder.increaseNestingLevel():"<"===e[i]?this._builder.decreaseNestingLevel():"t"===e[i]&&(this._tokenizer.tokenLineStart()-this._lastLineNumber>1&&this._builder.addNewLine(!0),this._lastLineNumber=this._tokenizer.tokenLineEnd(),t&&this._builder.addToken(this._content.substring(t.start,t.end),this._fromOffset+t.start))}_beforeVisit(t){if(!t.parent)return;let e;for(;(e=this._tokenizer.peekToken())&&e.start<t.start;){const e=this._tokenizer.nextToken(),i=this._formatToken(t.parent,e);this._push(e,i)}}_afterVisit(t){let e;for(;(e=this._tokenizer.peekToken())&&e.start<t.end;){const e=this._tokenizer.nextToken(),i=this._formatToken(t,e);this._push(e,i)}this._push(null,this._finishNode(t))}_inForLoopHeader(t){const e=t.parent;if(!e)return!1;if("ForStatement"===e.type){const i=e;return t===i.init||t===i.test||t===i.update}if("ForInStatement"===e.type||"ForOfStatement"===e.type){const i=e;return t===i.left||t===i.right}return!1}_formatToken(t,e){const i=o;if(i.lineComment(e))return"tn";if(i.blockComment(e))return"tn";const s=e;if("ContinueStatement"===t.type||"BreakStatement"===t.type)return t.label&&i.keyword(s)?"ts":"t";if("Identifier"===t.type)return"t";if("ReturnStatement"===t.type)return i.punctuator(s,";")?"t":t.argument?"ts":"t";if("AwaitExpression"===t.type)return i.punctuator(s,";")?"t":t.argument?"ts":"t";if("Property"===t.type)return i.punctuator(s,":")?"ts":"t";if("ArrayExpression"===t.type)return i.punctuator(s,",")?"ts":"t";if("LabeledStatement"===t.type){if(i.punctuator(s,":"))return"ts"}else if("LogicalExpression"===t.type||"AssignmentExpression"===t.type||"BinaryExpression"===t.type){if(i.punctuator(s)&&!i.punctuator(s,"()"))return"sts"}else if("ConditionalExpression"===t.type){if(i.punctuator(s,"?:"))return"sts"}else if("VariableDeclarator"===t.type){if(i.punctuator(s,"="))return"sts"}else if("ObjectPattern"===t.type){if(t.parent&&"VariableDeclarator"===t.parent.type&&i.punctuator(s,"{"))return"st";if(i.punctuator(s,","))return"ts"}else if("FunctionDeclaration"===t.type){if(i.punctuator(s,",)"))return"ts"}else if("FunctionExpression"===t.type){if(i.punctuator(s,",)"))return"ts";if(i.keyword(s,"function"))return t.id?"ts":"t"}else if("WithStatement"===t.type){if(i.punctuator(s,")"))return t.body&&"BlockStatement"===t.body.type?"ts":"tn>"}else if("SwitchStatement"===t.type){if(i.punctuator(s,"{"))return"tn>";if(i.punctuator(s,"}"))return"n<tn";if(i.punctuator(s,")"))return"ts"}else if("SwitchCase"===t.type){if(i.keyword(s,"case"))return"n<ts";if(i.keyword(s,"default"))return"n<t";if(i.punctuator(s,":"))return"tn>"}else if("VariableDeclaration"===t.type){if(i.punctuator(s,",")){let e=!0;const i=t.declarations;for(let t=0;t<i.length;++t)e=e&&Boolean(i[t].init);return!this._inForLoopHeader(t)&&e?"nSSts":"ts"}}else if("BlockStatement"===t.type){if(i.punctuator(s,"{"))return t.body.length?"tn>":"t";if(i.punctuator(s,"}"))return t.body.length?"n<t":"t"}else if("CatchClause"===t.type){if(i.punctuator(s,")"))return"ts"}else if("ObjectExpression"===t.type){if(!t.properties.length)return"t";if(i.punctuator(s,"{"))return"tn>";if(i.punctuator(s,"}"))return"n<t";if(i.punctuator(s,","))return"tn"}else if("IfStatement"===t.type){if(i.punctuator(s,")"))return t.consequent&&"BlockStatement"===t.consequent.type?"ts":"tn>";if(i.keyword(s,"else")){const e=t.consequent&&"BlockStatement"===t.consequent.type?"st":"n<t";let i="n>";return!t.alternate||"BlockStatement"!==t.alternate.type&&"IfStatement"!==t.alternate.type||(i="s"),e+i}}else if("CallExpression"===t.type){if(i.punctuator(s,","))return"ts"}else{if("SequenceExpression"===t.type&&i.punctuator(s,","))return t.parent&&"SwitchCase"===t.parent.type?"ts":"tn";if("ForStatement"===t.type||"ForOfStatement"===t.type||"ForInStatement"===t.type){if(i.punctuator(s,";"))return"ts";if(i.keyword(s,"in")||i.identifier(s,"of"))return"sts";if(i.punctuator(s,")"))return t.body&&"BlockStatement"===t.body.type?"ts":"tn>"}else if("WhileStatement"===t.type){if(i.punctuator(s,")"))return t.body&&"BlockStatement"===t.body.type?"ts":"tn>"}else if("DoWhileStatement"===t.type){const e=t.body&&"BlockStatement"===t.body.type;if(i.keyword(s,"do"))return e?"ts":"tn>";if(i.keyword(s,"while"))return e?"sts":"n<ts";if(i.punctuator(s,";"))return"tn"}else{if("ClassBody"===t.type)return i.punctuator(s,"{")?"stn>":i.punctuator(s,"}")?"<ntn":"t";if("YieldExpression"===t.type)return"t";if("Super"===t.type)return"t";if("ImportExpression"===t.type)return"t";if("ExportAllDeclaration"===t.type)return i.punctuator(s,"*")?"sts":"t";if("ExportNamedDeclaration"===t.type||"ImportDeclaration"===t.type)return i.punctuator(s,"{")?"st":i.punctuator(s,",")?"ts":i.punctuator(s,"}")?t.source?"ts":"t":i.punctuator(s,"*")?"sts":"t"}}return i.keyword(s)&&!i.keyword(s,"this")?"ts":"t"}_finishNode(t){if("WithStatement"===t.type){if(t.body&&"BlockStatement"!==t.body.type)return"n<"}else if("VariableDeclaration"===t.type){if(!this._inForLoopHeader(t))return"n"}else if("ForStatement"===t.type||"ForOfStatement"===t.type||"ForInStatement"===t.type){if(t.body&&"BlockStatement"!==t.body.type)return"n<"}else{if("BlockStatement"===t.type){if(t.parent&&"IfStatement"===t.parent.type){const e=t.parent;if(e.alternate&&e.consequent===t)return""}if(t.parent&&"FunctionExpression"===t.parent.type&&t.parent.parent&&"Property"===t.parent.parent.type)return"";if(t.parent&&"FunctionExpression"===t.parent.type&&t.parent.parent&&"VariableDeclarator"===t.parent.parent.type)return"";if(t.parent&&"FunctionExpression"===t.parent.type&&t.parent.parent&&"CallExpression"===t.parent.parent.type)return"";if(t.parent&&"DoWhileStatement"===t.parent.type)return"";if(t.parent&&"TryStatement"===t.parent.type){if(t.parent.block===t)return"s"}if(t.parent&&"CatchClause"===t.parent.type){const e=t.parent;if(e.parent&&e.parent.finalizer)return"s"}return"n"}if("WhileStatement"===t.type){if(t.body&&"BlockStatement"!==t.body.type)return"n<"}else if("IfStatement"===t.type){if(t.alternate){if("BlockStatement"!==t.alternate.type&&"IfStatement"!==t.alternate.type)return"<"}else if(t.consequent&&"BlockStatement"!==t.consequent.type)return"<"}else{if("BreakStatement"===t.type||"ContinueStatement"===t.type||"ThrowStatement"===t.type||"ReturnStatement"===t.type||"ExpressionStatement"===t.type)return"n";if("ImportDeclaration"===t.type||"ExportAllDeclaration"===t.type||"ExportDefaultDeclaration"===t.type||"ExportNamedDeclaration"===t.type)return"n"}}return""}}var m=Object.freeze({__proto__:null,JavaScriptFormatter:f});class g{constructor(t){this._builder=t,this._jsFormatter=new f(t),this._cssFormatter=new T(t)}format(t,e){this._text=t,this._lineEndings=e,this._model=new x(t),this._walk(this._model.document())}_formatTokensTill(t,e){if(!this._model)return;let i=this._model.peekToken();for(;i&&i.startOffset<e;){const e=this._model.nextToken();this._formatToken(t,e),i=this._model.peekToken()}}_walk(t){if(!t.openTag||!t.closeTag)throw new Error("Element is missing open or close tag");t.parent&&this._formatTokensTill(t.parent,t.openTag.startOffset),this._beforeOpenTag(t),this._formatTokensTill(t,t.openTag.endOffset),this._afterOpenTag(t);for(let e=0;e<t.children.length;++e)this._walk(t.children[e]);this._formatTokensTill(t,t.closeTag.startOffset),this._beforeCloseTag(t),this._formatTokensTill(t,t.closeTag.endOffset),this._afterCloseTag(t)}_beforeOpenTag(t){this._model&&t.children.length&&t!==this._model.document()&&this._builder.addNewLine()}_afterOpenTag(t){this._model&&t.children.length&&t!==this._model.document()&&(this._builder.increaseNestingLevel(),this._builder.addNewLine())}_beforeCloseTag(t){this._model&&t.children.length&&t!==this._model.document()&&(this._builder.decreaseNestingLevel(),this._builder.addNewLine())}_afterCloseTag(t){this._builder.addNewLine()}_formatToken(e,i){if(t.isWhitespace(i.value))return;if(y(i.type,"comment")||y(i.type,"meta"))return this._builder.addNewLine(),this._builder.addToken(i.value.trim(),i.startOffset),void this._builder.addNewLine();if(!e.openTag||!e.closeTag)return;const s=e.openTag.endOffset<=i.startOffset&&i.startOffset<e.closeTag.startOffset;return s&&"style"===e.name?(this._builder.addNewLine(),this._builder.increaseNestingLevel(),this._cssFormatter.format(this._text||"",this._lineEndings||[],i.startOffset,i.endOffset),void this._builder.decreaseNestingLevel()):s&&"script"===e.name?(this._builder.addNewLine(),this._builder.increaseNestingLevel(),this._scriptTagIsJavaScript(e)?this._jsFormatter.format(this._text||"",this._lineEndings||[],i.startOffset,i.endOffset):(this._builder.addToken(i.value,i.startOffset),this._builder.addNewLine()),void this._builder.decreaseNestingLevel()):(!s&&y(i.type,"attribute")&&this._builder.addSoftSpace(),void this._builder.addToken(i.value,i.startOffset))}_scriptTagIsJavaScript(t){if(!t.openTag)return!0;if(!t.openTag.attributes.has("type"))return!0;let e=t.openTag.attributes.get("type");if(!e)return!0;e=e.toLowerCase();const i=/^(["\'])(.*)\1$/.exec(e.trim());return i&&(e=i[2]),g.SupportedJavaScriptMimeTypes.has(e.trim())}}function y(t,e){return t.has(e)||t.has("xml-"+e)}g.SupportedJavaScriptMimeTypes=new Set(["application/ecmascript","application/javascript","application/x-ecmascript","application/x-javascript","text/ecmascript","text/javascript","text/javascript1.0","text/javascript1.1","text/javascript1.2","text/javascript1.3","text/javascript1.4","text/javascript1.5","text/jscript","text/livescript","text/x-ecmascript","text/x-javascript"]);class x{constructor(t){this._state=b.Initial,this._document=new w("document"),this._document.openTag=new S("document",0,0,new Map,!0,!1),this._document.closeTag=new S("document",t.length,t.length,new Map,!1,!1),this._stack=[this._document],this._tokens=[],this._tokenIndex=0,this._build(t),this._attributes=new Map,this._attributeName="",this._tagName="",this._isOpenTag=!1}_build(t){const e=I("text/html");let i=0;const s=t.toLowerCase();for(;e(t.substring(i),r.bind(this,i)),!(i>=t.length);){const e=this._stack[this._stack.length-1];if(!e)break;if(i=s.indexOf("</"+e.name,i),-1===i&&(i=t.length),!e.openTag)break;const r=e.openTag.endOffset,n=i,a=t.substring(r,n);this._tokens.push(new v(a,new Set,r,n))}for(;this._stack.length>1;){const e=this._stack[this._stack.length-1];if(!e)break;this._popElement(new S(e.name,t.length,t.length,new Map,!1,!1))}function r(t,e,s,r,n){r+=t,i=n+=t;const a=s?new Set(s.split(" ")):new Set,o=new v(e,a,r,n);this._tokens.push(o),this._updateDOM(o);const h=this._stack[this._stack.length-1];if(h&&("script"===h.name||"style"===h.name)&&h.openTag&&h.openTag.endOffset===i)return A}}_updateDOM(t){const e=b,i=t.value,s=t.type;switch(this._state){case e.Initial:return void(!y(s,"bracket")||"<"!==i&&"</"!==i||(this._onStartTag(t),this._state=e.Tag));case e.Tag:return void(y(s,"tag")&&!y(s,"bracket")?this._tagName=i.trim().toLowerCase():y(s,"attribute")?(this._attributeName=i.trim().toLowerCase(),this._attributes.set(this._attributeName,""),this._state=e.AttributeName):!y(s,"bracket")||">"!==i&&"/>"!==i||(this._onEndTag(t),this._state=e.Initial));case e.AttributeName:return void(s.size||"="!==i?!y(s,"bracket")||">"!==i&&"/>"!==i||(this._onEndTag(t),this._state=e.Initial):this._state=e.AttributeValue);case e.AttributeValue:return void(y(s,"string")?(this._attributes.set(this._attributeName,i),this._state=e.Tag):!y(s,"bracket")||">"!==i&&"/>"!==i||(this._onEndTag(t),this._state=e.Initial))}}_onStartTag(t){this._tagName="",this._tagStartOffset=t.startOffset,this._tagEndOffset=null,this._attributes=new Map,this._attributeName="",this._isOpenTag="<"===t.value}_onEndTag(t){this._tagEndOffset=t.endOffset;const e="/>"===t.value||k.has(this._tagName),i=new S(this._tagName,this._tagStartOffset||0,this._tagEndOffset,this._attributes,this._isOpenTag,e);this._onTagComplete(i)}_onTagComplete(t){if(t.isOpenTag){const e=this._stack[this._stack.length-1];if(e){const s=_.get(e.name);e!==this._document&&e.openTag&&e.openTag.selfClosingTag?this._popElement(i(e,e.openTag.endOffset)):s&&s.has(t.name)&&this._popElement(i(e,t.startOffset)),this._pushElement(t)}return}let e=this._stack[this._stack.length-1];for(;this._stack.length>1&&e&&e.name!==t.name;)this._popElement(i(e,t.startOffset)),e=this._stack[this._stack.length-1];function i(t,e){return new S(t.name,e,e,new Map,!1,!1)}1!==this._stack.length&&this._popElement(t)}_popElement(t){const e=this._stack.pop();e&&(e.closeTag=t)}_pushElement(t){const e=this._stack[this._stack.length-1],i=new w(t.name);e&&(i.parent=e,e.children.push(i)),i.openTag=t,this._stack.push(i)}peekToken(){return this._tokenIndex<this._tokens.length?this._tokens[this._tokenIndex]:null}nextToken(){return this._tokens[this._tokenIndex++]}document(){return this._document}}const k=new Set(["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"]),_=new Map([["head",new Set(["body"])],["li",new Set(["li"])],["dt",new Set(["dt","dd"])],["dd",new Set(["dt","dd"])],["p",new Set(["address","article","aside","blockquote","div","dl","fieldset","footer","form","h1","h2","h3","h4","h5","h6","header","hgroup","hr","main","nav","ol","p","pre","section","table","ul"])],["rb",new Set(["rb","rt","rtc","rp"])],["rt",new Set(["rb","rt","rtc","rp"])],["rtc",new Set(["rb","rtc","rp"])],["rp",new Set(["rb","rt","rtc","rp"])],["optgroup",new Set(["optgroup"])],["option",new Set(["option","optgroup"])],["colgroup",new Set(["colgroup"])],["thead",new Set(["tbody","tfoot"])],["tbody",new Set(["tbody","tfoot"])],["tfoot",new Set(["tbody"])],["tr",new Set(["tr"])],["td",new Set(["td","th"])],["th",new Set(["td","th"])]]),b={Initial:"Initial",Tag:"Tag",AttributeName:"AttributeName",AttributeValue:"AttributeValue"},v=class{constructor(t,e,i,s){this.value=t,this.type=e,this.startOffset=i,this.endOffset=s}},S=class{constructor(t,e,i,s,r,n){this.name=t,this.startOffset=e,this.endOffset=i,this.attributes=s,this.isOpenTag=r,this.selfClosingTag=n}},w=class{constructor(t){this.name=t,this.children=[],this.parent=null,this.openTag=null,this.closeTag=null}};var C=Object.freeze({__proto__:null,HTMLFormatter:g,HTMLModel:x});class E{constructor(t){this.builder=t}format(t,e,i,s){const r=t.substring(i,s);this.builder.addToken(r,i)}}function I(t){const e=CodeMirror.getMode({indentUnit:2},t),i=CodeMirror.startState(e);if(!e||"null"===e.name)throw new Error("Could not find CodeMirror mode for MimeType: "+t);if(!e.token)throw new Error("Could not find CodeMirror mode with token method: "+t);return(t,s)=>{const r=new CodeMirror.StringStream(t);for(;!r.eol();){const t=e.token(r,i),n=r.current();if(s(n,t,r.start,r.start+n.length)===A)return;r.start=r.pos}}}const A={};function N(t,e,i){let s=null,r="";for(let i=0;i<t.length;i++)try{r="{"===t[i]?`(${t.substring(i)})${e}`:`${t.substring(i)}${e}`,s=n(r,{ecmaVersion:h});break}catch(t){}if(!s)return null;const a=s.end;let o=null;if(new c((t=>{if(o||t.end<a)return c.SkipSubtree;i.has(t.type)&&(o=t)})).walk(s),!o)return null;let p=r.substring(o.start,r.length-e.length);return p.startsWith("{")&&(p=`(${p})`),{baseNode:o,baseExpression:p}}i.Runtime.queryParam("test")&&(console.error=()=>{});var L=Object.freeze({__proto__:null,createTokenizer:I,AbortTokenization:A,evaluatableJavaScriptSubstring:function(t){const e=s(t,{ecmaVersion:h});let i="";try{let s=e.getToken();for(;s.type!==r.eof&&o.punctuator(s);)s=e.getToken();const n=s.start;let a=s.end,h=0;for(;s.type!==r.eof;){const t=o.identifier(s),i=o.keyword(s,"this"),n=s.type===r.string;if(!i&&!t&&!n)break;for(a=s.end,s=e.getToken();o.punctuator(s,".[]");)o.punctuator(s,"[")&&h++,o.punctuator(s,"]")&&(a=h>0?s.end:a,h--),s=e.getToken()}i=t.substring(n,a)}catch(t){console.error(t)}return i},javaScriptIdentifiers:function(t){let e=null;try{e=n(t,{ecmaVersion:h,ranges:!1})}catch(t){}const i=[],s=new c((function(t){if(r(t))return t.id&&i.push(t.id),c.SkipSubtree;if("Identifier"!==t.type)return;if(t.parent&&"MemberExpression"===t.parent.type){const e=t.parent;if(e.property===t&&!e.computed)return}return void i.push(t)}));function r(t){return"FunctionDeclaration"===t.type||"FunctionExpression"===t.type||"ArrowFunctionExpression"===t.type}if(!e||"Program"!==e.type||1!==e.body.length||!r(e.body[0]))return[];const a=e.body[0];for(const t of a.params)s.walk(t);return s.walk(a.body),i.map((t=>({name:"name"in t&&t.name||void 0,offset:t.start})))},format:function(e,i,s){const r={},n=new u(s=s||"    "),a=t.findLineEndingIndexes(i);try{switch(e){case"text/html":new g(n).format(i,a);break;case"text/css":new T(n).format(i,a,0,i.length);break;case"text/javascript":case"application/javascript":new f(n).format(i,a,0,i.length);break;default:new E(n).format(i,a,0,i.length)}r.mapping=n.mapping,r.content=n.content()}catch(t){console.error(t),r.mapping={original:[0],formatted:[0]},r.content=i}return r},findLastFunctionCall:function(t){if(t.length>1e4)return null;try{const e=s(t,{ecmaVersion:h});for(;e.getToken().type!==r.eof;);}catch(t){return null}const e=N(t,"000)",new Set(["CallExpression","NewExpression"]));if(!e)return null;if("CallExpression"!==e.baseNode.type&&"NewExpression"!==e.baseNode.type)return null;const i=e.baseNode.callee;let n="";const a="Identifier"===i.type?i:i.property;a&&("Identifier"===a.type?n=a.name:"Literal"===a.type&&(n=a.value));const o=e.baseNode.arguments.length-1,p=`(${e.baseExpression.substring(i.start-e.baseNode.start,i.end-e.baseNode.start)})`;let c="(function(){return this})()";if("MemberExpression"===i.type){const t=i.object;c=e.baseExpression.substring(t.start-e.baseNode.start,t.end-e.baseNode.start)}return{baseExpression:p,receiver:c,argumentIndex:o,functionName:n}},argumentsList:function(t){if(t.length>1e4)return[];let e=null;try{e=n(`(${t})`,{ecmaVersion:h})}catch(t){}if(!e)try{e=n(`({${t}})`,{ecmaVersion:h})}catch(t){}if(!(e&&"body"in e&&Array.isArray(e.body)&&e.body[0]&&"expression"in e.body[0]))return[];const i=e.body[0].expression;let s=null;switch(i.type){case"ClassExpression":{if(!i.body.body)break;const t=i.body.body.find((t=>"constructor"===t.kind));t&&(s=t.value.params);break}case"ObjectExpression":if(!i.properties[0]||!("value"in i.properties[0])||!("params"in i.properties[0].value))break;s=i.properties[0].value.params;break;case"FunctionExpression":case"ArrowFunctionExpression":s=i.params}return s?s.map((function t(e){switch(e.type){case"Identifier":return e.name;case"AssignmentPattern":return"?"+t(e.left);case"ObjectPattern":return"obj";case"ArrayPattern":return"arr";case"RestElement":return"..."+t(e.argument)}return"?"})):[]},findLastExpression:function(t){if(t.length>1e4)return null;try{const e=s(t,{ecmaVersion:h});for(;e.getToken().type!==r.eof;);}catch(t){return null}const e=".DEVTOOLS";try{n(t+e,{ecmaVersion:h})}catch(e){if(e.message.startsWith("Unexpected token")&&e.pos===t.length)return null}const i=N(t,e,new Set(["MemberExpression","Identifier"]));return i?i.baseExpression:null},_lastCompleteExpression:N});class T{constructor(t){this._builder=t,this._toOffset,this._fromOffset,this._lineEndings,this._lastLine=-1,this._state={eatWhitespace:void 0,seenProperty:void 0,inPropertyValue:void 0,afterClosingBrace:void 0}}format(t,e,i,s){this._lineEndings=e,this._fromOffset=i,this._toOffset=s,this._state={eatWhitespace:void 0,seenProperty:void 0,inPropertyValue:void 0,afterClosingBrace:void 0},this._lastLine=-1;const r=I("text/css"),n=this._builder.setEnforceSpaceBetweenWords(!1);r(t.substring(this._fromOffset,this._toOffset),this._tokenCallback.bind(this)),this._builder.setEnforceSpaceBetweenWords(n)}_tokenCallback(t,i,s){s+=this._fromOffset;const r=e.lowerBound(this._lineEndings,s,e.DEFAULT_COMPARATOR);r!==this._lastLine&&(this._state.eatWhitespace=!0),i&&(/^(css-)?property/.test(i)||/^(css-)?variable-2/.test(i))&&!this._state.inPropertyValue&&(this._state.seenProperty=!0),this._lastLine=r;if(/^\s+$/.test(t))this._state.eatWhitespace||this._builder.addSoftSpace();else if(this._state.eatWhitespace=!1,"\n"!==t){if("}"!==t&&(this._state.afterClosingBrace&&this._builder.addNewLine(!0),this._state.afterClosingBrace=!1),"}"===t)this._state.inPropertyValue&&this._builder.addNewLine(),this._builder.decreaseNestingLevel(),this._state.afterClosingBrace=!0,this._state.inPropertyValue=!1;else{if(":"===t&&!this._state.inPropertyValue&&this._state.seenProperty)return this._builder.addToken(t,s),this._builder.addSoftSpace(),this._state.eatWhitespace=!0,this._state.inPropertyValue=!0,void(this._state.seenProperty=!1);if("{"===t)return this._builder.addSoftSpace(),this._builder.addToken(t,s),this._builder.addNewLine(),void this._builder.increaseNestingLevel()}this._builder.addToken(t,s),"comment"!==i||this._state.inPropertyValue||this._state.seenProperty||this._builder.addNewLine(),";"===t&&this._state.inPropertyValue?(this._state.inPropertyValue=!1,this._builder.addNewLine()):"}"===t&&this._builder.addNewLine()}}}var P=Object.freeze({__proto__:null,CSSFormatter:T});const V={Initial:"Initial",Selector:"Selector",Style:"Style",PropertyName:"PropertyName",PropertyValue:"PropertyValue",AtRule:"AtRule"};var R=Object.freeze({__proto__:null,CSSParserStates:V,parseCSS:function t(e,i){const s=e.split("\n");let r,n,a=[],o=0,h=V.Initial;const p=new Set;let c=[];function l(t){c=c.concat(t.chunk)}function u(e,s,u,d){const g=s?new Set(s.split(" ")):p;switch(h){case V.Initial:g.has("qualifier")||g.has("builtin")||g.has("tag")?(r={selectorText:e,lineNumber:f,columnNumber:u,properties:[]},h=V.Selector):g.has("def")&&(r={atRule:e,lineNumber:f,columnNumber:u},h=V.AtRule);break;case V.Selector:"{"===e&&g===p?(r.selectorText=r.selectorText.trim(),r.styleRange=m(f,d),h=V.Style):r.selectorText+=e;break;case V.AtRule:";"!==e&&"{"!==e||g!==p?r.atRule+=e:(r.atRule=r.atRule.trim(),a.push(r),h=V.Initial);break;case V.Style:if(g.has("meta")||g.has("property"))n={name:e,value:"",range:m(f,u),nameRange:m(f,u)},h=V.PropertyName;else if("}"===e&&g===p)r.styleRange.endLine=f,r.styleRange.endColumn=u,a.push(r),h=V.Initial;else if(g.has("comment")){if("/*"!==e.substring(0,2)||"*/"!==e.substring(e.length-2))break;const i=e.substring(2,e.length-2);if(c=[],t("a{\n"+i+"}",l),1===c.length&&1===c[0].properties.length){const t=c[0].properties[0];t.disabled=!0,t.range=m(f,u),t.range.endColumn=d;const e=f-1,i=u+2;t.nameRange.startLine+=e,t.nameRange.startColumn+=i,t.nameRange.endLine+=e,t.nameRange.endColumn+=i,t.valueRange.startLine+=e,t.valueRange.startColumn+=i,t.valueRange.endLine+=e,t.valueRange.endColumn+=i,r.properties.push(t)}}break;case V.PropertyName:":"===e&&g===p?(n.name=n.name,n.nameRange.endLine=f,n.nameRange.endColumn=u,n.valueRange=m(f,d),h=V.PropertyValue):g.has("property")&&(n.name+=e);break;case V.PropertyValue:";"!==e&&"}"!==e||g!==p?g.has("comment")||(n.value+=e):(n.value=n.value,n.valueRange.endLine=f,n.valueRange.endColumn=u,n.range.endLine=f,n.range.endColumn=";"===e?d:u,r.properties.push(n),"}"===e?(r.styleRange.endLine=f,r.styleRange.endColumn=u,a.push(r),h=V.Initial):h=V.Style);break;default:console.assert(!1,"Unknown CSS parser state.")}o+=d-u,o>1e5&&(i({chunk:a,isLastChunk:!1}),a=[],o=0)}const d=I("text/css");let f;for(f=0;f<s.length;++f){const t=s[f];d(t,u),u("\n",null,t.length,t.length+1)}function m(t,e){return{startLine:t,startColumn:e,endLine:t,endColumn:e}}i({chunk:a,isLastChunk:!0})}}),O={3:"abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",5:"class enum extends super const export import",6:"enum",strict:"implements interface let package private protected public static yield",strictBind:"eval arguments"},M="break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this",D={5:M,"5module":M+" export import",6:M+" const class extends export import super"},B=/^in(stanceof)?$/,F="ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࢠ-ࢴࢶ-ࣇऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜌᜎ-ᜑᜠ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭋᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-Ⱞⰰ-ⱞⱠ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-鿼ꀀ-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꞿꟂ-ꟊꟵ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ",U="‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࣓-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-ໍ໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜔ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠐-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿᫀᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷹᷻-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿",j=new RegExp("["+F+"]"),W=new RegExp("["+F+U+"]");F=U=null;var q=[0,11,2,25,2,18,2,1,2,14,3,13,35,122,70,52,268,28,4,48,48,31,14,29,6,37,11,29,3,35,5,7,2,4,43,157,19,35,5,35,5,39,9,51,157,310,10,21,11,7,153,5,3,0,2,43,2,1,4,0,3,22,11,22,10,30,66,18,2,1,11,21,11,25,71,55,7,1,65,0,16,3,2,2,2,28,43,28,4,28,36,7,2,27,28,53,11,21,11,18,14,17,111,72,56,50,14,50,14,35,349,41,7,1,79,28,11,0,9,21,107,20,28,22,13,52,76,44,33,24,27,35,30,0,3,0,9,34,4,0,13,47,15,3,22,0,2,0,36,17,2,24,85,6,2,0,2,3,2,14,2,9,8,46,39,7,3,1,3,21,2,6,2,1,2,4,4,0,19,0,13,4,159,52,19,3,21,2,31,47,21,1,2,0,185,46,42,3,37,47,21,0,60,42,14,0,72,26,230,43,117,63,32,7,3,0,3,7,2,1,2,23,16,0,2,0,95,7,3,38,17,0,2,0,29,0,11,39,8,0,22,0,12,45,20,0,35,56,264,8,2,36,18,0,50,29,113,6,2,1,2,37,22,0,26,5,2,1,2,31,15,0,328,18,190,0,80,921,103,110,18,195,2749,1070,4050,582,8634,568,8,30,114,29,19,47,17,3,32,20,6,18,689,63,129,74,6,0,67,12,65,1,2,0,29,6135,9,1237,43,8,8952,286,50,2,18,3,9,395,2309,106,6,12,4,8,8,9,5991,84,2,70,2,1,3,0,3,1,3,3,2,11,2,0,2,6,2,64,2,3,3,7,2,6,2,27,2,3,2,4,2,0,4,6,2,339,3,24,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,7,2357,44,11,6,17,0,370,43,1301,196,60,67,8,0,1205,3,2,26,2,1,2,0,3,0,2,9,2,3,2,0,2,0,7,0,5,0,2,0,2,0,2,2,2,1,2,0,3,0,2,0,2,0,2,0,2,0,2,1,2,0,3,3,2,6,2,3,2,3,2,0,2,9,2,16,6,2,2,4,2,16,4421,42717,35,4148,12,221,3,5761,15,7472,3104,541,1507,4938],H=[509,0,227,0,150,4,294,9,1368,2,2,1,6,3,41,2,5,0,166,1,574,3,9,9,370,1,154,10,176,2,54,14,32,9,16,3,46,10,54,9,7,2,37,13,2,9,6,1,45,0,13,2,49,13,9,3,2,11,83,11,7,0,161,11,6,9,7,3,56,1,2,6,3,1,3,2,10,0,11,1,3,6,4,4,193,17,10,9,5,0,82,19,13,9,214,6,3,8,28,1,83,16,16,9,82,12,9,9,84,14,5,9,243,14,166,9,71,5,2,1,3,3,2,0,2,1,13,9,120,6,3,6,4,0,29,9,41,6,2,3,9,0,10,10,47,15,406,7,2,7,17,9,57,21,2,13,123,5,4,0,2,1,2,6,2,0,9,9,49,4,2,1,2,4,9,9,330,3,19306,9,135,4,60,6,26,9,1014,0,2,54,8,3,82,0,12,1,19628,1,5319,4,4,5,9,7,3,6,31,3,149,2,1418,49,513,54,5,49,9,0,15,0,23,4,2,14,1361,6,2,16,3,6,2,1,2,4,262,6,10,9,419,13,1495,6,110,6,6,9,4759,9,787719,239];function z(t,e){for(var i=65536,s=0;s<e.length;s+=2){if((i+=e[s])>t)return!1;if((i+=e[s+1])>=t)return!0}}function G(t,e){return t<65?36===t:t<91||(t<97?95===t:t<123||(t<=65535?t>=170&&j.test(String.fromCharCode(t)):!1!==e&&z(t,q)))}function K(t,e){return t<48?36===t:t<58||!(t<65)&&(t<91||(t<97?95===t:t<123||(t<=65535?t>=170&&W.test(String.fromCharCode(t)):!1!==e&&(z(t,q)||z(t,H)))))}var Q=function(t,e){void 0===e&&(e={}),this.label=t,this.keyword=e.keyword,this.beforeExpr=!!e.beforeExpr,this.startsExpr=!!e.startsExpr,this.isLoop=!!e.isLoop,this.isAssign=!!e.isAssign,this.prefix=!!e.prefix,this.postfix=!!e.postfix,this.binop=e.binop||null,this.updateContext=null};function X(t,e){return new Q(t,{beforeExpr:!0,binop:e})}var Y={beforeExpr:!0},$={startsExpr:!0},J={};function Z(t,e){return void 0===e&&(e={}),e.keyword=t,J[t]=new Q(t,e)}var tt={num:new Q("num",$),regexp:new Q("regexp",$),string:new Q("string",$),name:new Q("name",$),eof:new Q("eof"),bracketL:new Q("[",{beforeExpr:!0,startsExpr:!0}),bracketR:new Q("]"),braceL:new Q("{",{beforeExpr:!0,startsExpr:!0}),braceR:new Q("}"),parenL:new Q("(",{beforeExpr:!0,startsExpr:!0}),parenR:new Q(")"),comma:new Q(",",Y),semi:new Q(";",Y),colon:new Q(":",Y),dot:new Q("."),question:new Q("?",Y),questionDot:new Q("?."),arrow:new Q("=>",Y),template:new Q("template"),invalidTemplate:new Q("invalidTemplate"),ellipsis:new Q("...",Y),backQuote:new Q("`",$),dollarBraceL:new Q("${",{beforeExpr:!0,startsExpr:!0}),eq:new Q("=",{beforeExpr:!0,isAssign:!0}),assign:new Q("_=",{beforeExpr:!0,isAssign:!0}),incDec:new Q("++/--",{prefix:!0,postfix:!0,startsExpr:!0}),prefix:new Q("!/~",{beforeExpr:!0,prefix:!0,startsExpr:!0}),logicalOR:X("||",1),logicalAND:X("&&",2),bitwiseOR:X("|",3),bitwiseXOR:X("^",4),bitwiseAND:X("&",5),equality:X("==/!=/===/!==",6),relational:X("</>/<=/>=",7),bitShift:X("<</>>/>>>",8),plusMin:new Q("+/-",{beforeExpr:!0,binop:9,prefix:!0,startsExpr:!0}),modulo:X("%",10),star:X("*",10),slash:X("/",10),starstar:new Q("**",{beforeExpr:!0}),coalesce:X("??",1),_break:Z("break"),_case:Z("case",Y),_catch:Z("catch"),_continue:Z("continue"),_debugger:Z("debugger"),_default:Z("default",Y),_do:Z("do",{isLoop:!0,beforeExpr:!0}),_else:Z("else",Y),_finally:Z("finally"),_for:Z("for",{isLoop:!0}),_function:Z("function",$),_if:Z("if"),_return:Z("return",Y),_switch:Z("switch"),_throw:Z("throw",Y),_try:Z("try"),_var:Z("var"),_const:Z("const"),_while:Z("while",{isLoop:!0}),_with:Z("with"),_new:Z("new",{beforeExpr:!0,startsExpr:!0}),_this:Z("this",$),_super:Z("super",$),_class:Z("class",$),_extends:Z("extends",Y),_export:Z("export"),_import:Z("import",$),_null:Z("null",$),_true:Z("true",$),_false:Z("false",$),_in:Z("in",{beforeExpr:!0,binop:7}),_instanceof:Z("instanceof",{beforeExpr:!0,binop:7}),_typeof:Z("typeof",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_void:Z("void",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_delete:Z("delete",{beforeExpr:!0,prefix:!0,startsExpr:!0})},et=/\r\n?|\n|\u2028|\u2029/,it=new RegExp(et.source,"g");function st(t,e){return 10===t||13===t||!e&&(8232===t||8233===t)}var rt=/[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/,nt=/(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g,at=Object.prototype,ot=at.hasOwnProperty,ht=at.toString;function pt(t,e){return ot.call(t,e)}var ct=Array.isArray||function(t){return"[object Array]"===ht.call(t)};function lt(t){return new RegExp("^(?:"+t.replace(/ /g,"|")+")$")}var ut=function(t,e){this.line=t,this.column=e};ut.prototype.offset=function(t){return new ut(this.line,this.column+t)};var dt=function(t,e,i){this.start=e,this.end=i,null!==t.sourceFile&&(this.source=t.sourceFile)};function ft(t,e){for(var i=1,s=0;;){it.lastIndex=s;var r=it.exec(t);if(!(r&&r.index<e))return new ut(i,e-s);++i,s=r.index+r[0].length}}var mt={ecmaVersion:null,sourceType:"script",onInsertedSemicolon:null,onTrailingComma:null,allowReserved:null,allowReturnOutsideFunction:!1,allowImportExportEverywhere:!1,allowAwaitOutsideFunction:!1,allowHashBang:!1,locations:!1,onToken:null,onComment:null,ranges:!1,program:null,sourceFile:null,directSourceFile:null,preserveParens:!1},gt=!1;function yt(t){var e={};for(var i in mt)e[i]=t&&pt(t,i)?t[i]:mt[i];if("latest"===e.ecmaVersion?e.ecmaVersion=1e8:null==e.ecmaVersion?(!gt&&"object"==typeof console&&console.warn&&(gt=!0,console.warn("Since Acorn 8.0.0, options.ecmaVersion is required.\nDefaulting to 2020, but this will stop working in the future.")),e.ecmaVersion=11):e.ecmaVersion>=2015&&(e.ecmaVersion-=2009),null==e.allowReserved&&(e.allowReserved=e.ecmaVersion<5),ct(e.onToken)){var s=e.onToken;e.onToken=function(t){return s.push(t)}}return ct(e.onComment)&&(e.onComment=function(t,e){return function(i,s,r,n,a,o){var h={type:i?"Block":"Line",value:s,start:r,end:n};t.locations&&(h.loc=new dt(this,a,o)),t.ranges&&(h.range=[r,n]),e.push(h)}}(e,e.onComment)),e}function xt(t,e){return 2|(t?4:0)|(e?8:0)}var kt=function(t,e,i){this.options=t=yt(t),this.sourceFile=t.sourceFile,this.keywords=lt(D[t.ecmaVersion>=6?6:"module"===t.sourceType?"5module":5]);var s="";!0!==t.allowReserved&&(s=O[t.ecmaVersion>=6?6:5===t.ecmaVersion?5:3],"module"===t.sourceType&&(s+=" await")),this.reservedWords=lt(s);var r=(s?s+" ":"")+O.strict;this.reservedWordsStrict=lt(r),this.reservedWordsStrictBind=lt(r+" "+O.strictBind),this.input=String(e),this.containsEsc=!1,i?(this.pos=i,this.lineStart=this.input.lastIndexOf("\n",i-1)+1,this.curLine=this.input.slice(0,this.lineStart).split(et).length):(this.pos=this.lineStart=0,this.curLine=1),this.type=tt.eof,this.value=null,this.start=this.end=this.pos,this.startLoc=this.endLoc=this.curPosition(),this.lastTokEndLoc=this.lastTokStartLoc=null,this.lastTokStart=this.lastTokEnd=this.pos,this.context=this.initialContext(),this.exprAllowed=!0,this.inModule="module"===t.sourceType,this.strict=this.inModule||this.strictDirective(this.pos),this.potentialArrowAt=-1,this.yieldPos=this.awaitPos=this.awaitIdentPos=0,this.labels=[],this.undefinedExports={},0===this.pos&&t.allowHashBang&&"#!"===this.input.slice(0,2)&&this.skipLineComment(2),this.scopeStack=[],this.enterScope(1),this.regexpState=null},_t={inFunction:{configurable:!0},inGenerator:{configurable:!0},inAsync:{configurable:!0},allowSuper:{configurable:!0},allowDirectSuper:{configurable:!0},treatFunctionsAsVar:{configurable:!0},inNonArrowFunction:{configurable:!0}};kt.prototype.parse=function(){var t=this.options.program||this.startNode();return this.nextToken(),this.parseTopLevel(t)},_t.inFunction.get=function(){return(2&this.currentVarScope().flags)>0},_t.inGenerator.get=function(){return(8&this.currentVarScope().flags)>0},_t.inAsync.get=function(){return(4&this.currentVarScope().flags)>0},_t.allowSuper.get=function(){return(64&this.currentThisScope().flags)>0},_t.allowDirectSuper.get=function(){return(128&this.currentThisScope().flags)>0},_t.treatFunctionsAsVar.get=function(){return this.treatFunctionsAsVarInScope(this.currentScope())},_t.inNonArrowFunction.get=function(){return(2&this.currentThisScope().flags)>0},kt.extend=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];for(var i=this,s=0;s<t.length;s++)i=t[s](i);return i},kt.parse=function(t,e){return new this(e,t).parse()},kt.parseExpressionAt=function(t,e,i){var s=new this(i,t,e);return s.nextToken(),s.parseExpression()},kt.tokenizer=function(t,e){return new this(e,t)},Object.defineProperties(kt.prototype,_t);var bt=kt.prototype,vt=/^(?:'((?:\\.|[^'\\])*?)'|"((?:\\.|[^"\\])*?)")/;function St(){this.shorthandAssign=this.trailingComma=this.parenthesizedAssign=this.parenthesizedBind=this.doubleProto=-1}bt.strictDirective=function(t){for(;;){nt.lastIndex=t,t+=nt.exec(this.input)[0].length;var e=vt.exec(this.input.slice(t));if(!e)return!1;if("use strict"===(e[1]||e[2])){nt.lastIndex=t+e[0].length;var i=nt.exec(this.input),s=i.index+i[0].length,r=this.input.charAt(s);return";"===r||"}"===r||et.test(i[0])&&!(/[(`.[+\-/*%<>=,?^&]/.test(r)||"!"===r&&"="===this.input.charAt(s+1))}t+=e[0].length,nt.lastIndex=t,t+=nt.exec(this.input)[0].length,";"===this.input[t]&&t++}},bt.eat=function(t){return this.type===t&&(this.next(),!0)},bt.isContextual=function(t){return this.type===tt.name&&this.value===t&&!this.containsEsc},bt.eatContextual=function(t){return!!this.isContextual(t)&&(this.next(),!0)},bt.expectContextual=function(t){this.eatContextual(t)||this.unexpected()},bt.canInsertSemicolon=function(){return this.type===tt.eof||this.type===tt.braceR||et.test(this.input.slice(this.lastTokEnd,this.start))},bt.insertSemicolon=function(){if(this.canInsertSemicolon())return this.options.onInsertedSemicolon&&this.options.onInsertedSemicolon(this.lastTokEnd,this.lastTokEndLoc),!0},bt.semicolon=function(){this.eat(tt.semi)||this.insertSemicolon()||this.unexpected()},bt.afterTrailingComma=function(t,e){if(this.type===t)return this.options.onTrailingComma&&this.options.onTrailingComma(this.lastTokStart,this.lastTokStartLoc),e||this.next(),!0},bt.expect=function(t){this.eat(t)||this.unexpected()},bt.unexpected=function(t){this.raise(null!=t?t:this.start,"Unexpected token")},bt.checkPatternErrors=function(t,e){if(t){t.trailingComma>-1&&this.raiseRecoverable(t.trailingComma,"Comma is not permitted after the rest element");var i=e?t.parenthesizedAssign:t.parenthesizedBind;i>-1&&this.raiseRecoverable(i,"Parenthesized pattern")}},bt.checkExpressionErrors=function(t,e){if(!t)return!1;var i=t.shorthandAssign,s=t.doubleProto;if(!e)return i>=0||s>=0;i>=0&&this.raise(i,"Shorthand property assignments are valid only in destructuring patterns"),s>=0&&this.raiseRecoverable(s,"Redefinition of __proto__ property")},bt.checkYieldAwaitInDefaultParams=function(){this.yieldPos&&(!this.awaitPos||this.yieldPos<this.awaitPos)&&this.raise(this.yieldPos,"Yield expression cannot be a default value"),this.awaitPos&&this.raise(this.awaitPos,"Await expression cannot be a default value")},bt.isSimpleAssignTarget=function(t){return"ParenthesizedExpression"===t.type?this.isSimpleAssignTarget(t.expression):"Identifier"===t.type||"MemberExpression"===t.type};var wt=kt.prototype;wt.parseTopLevel=function(t){var e={};for(t.body||(t.body=[]);this.type!==tt.eof;){var i=this.parseStatement(null,!0,e);t.body.push(i)}if(this.inModule)for(var s=0,r=Object.keys(this.undefinedExports);s<r.length;s+=1){var n=r[s];this.raiseRecoverable(this.undefinedExports[n].start,"Export '"+n+"' is not defined")}return this.adaptDirectivePrologue(t.body),this.next(),t.sourceType=this.options.sourceType,this.finishNode(t,"Program")};var Ct={kind:"loop"},Et={kind:"switch"};wt.isLet=function(t){if(this.options.ecmaVersion<6||!this.isContextual("let"))return!1;nt.lastIndex=this.pos;var e=nt.exec(this.input),i=this.pos+e[0].length,s=this.input.charCodeAt(i);if(91===s)return!0;if(t)return!1;if(123===s)return!0;if(G(s,!0)){for(var r=i+1;K(this.input.charCodeAt(r),!0);)++r;var n=this.input.slice(i,r);if(!B.test(n))return!0}return!1},wt.isAsyncFunction=function(){if(this.options.ecmaVersion<8||!this.isContextual("async"))return!1;nt.lastIndex=this.pos;var t=nt.exec(this.input),e=this.pos+t[0].length;return!(et.test(this.input.slice(this.pos,e))||"function"!==this.input.slice(e,e+8)||e+8!==this.input.length&&K(this.input.charAt(e+8)))},wt.parseStatement=function(t,e,i){var s,r=this.type,n=this.startNode();switch(this.isLet(t)&&(r=tt._var,s="let"),r){case tt._break:case tt._continue:return this.parseBreakContinueStatement(n,r.keyword);case tt._debugger:return this.parseDebuggerStatement(n);case tt._do:return this.parseDoStatement(n);case tt._for:return this.parseForStatement(n);case tt._function:return t&&(this.strict||"if"!==t&&"label"!==t)&&this.options.ecmaVersion>=6&&this.unexpected(),this.parseFunctionStatement(n,!1,!t);case tt._class:return t&&this.unexpected(),this.parseClass(n,!0);case tt._if:return this.parseIfStatement(n);case tt._return:return this.parseReturnStatement(n);case tt._switch:return this.parseSwitchStatement(n);case tt._throw:return this.parseThrowStatement(n);case tt._try:return this.parseTryStatement(n);case tt._const:case tt._var:return s=s||this.value,t&&"var"!==s&&this.unexpected(),this.parseVarStatement(n,s);case tt._while:return this.parseWhileStatement(n);case tt._with:return this.parseWithStatement(n);case tt.braceL:return this.parseBlock(!0,n);case tt.semi:return this.parseEmptyStatement(n);case tt._export:case tt._import:if(this.options.ecmaVersion>10&&r===tt._import){nt.lastIndex=this.pos;var a=nt.exec(this.input),o=this.pos+a[0].length,h=this.input.charCodeAt(o);if(40===h||46===h)return this.parseExpressionStatement(n,this.parseExpression())}return this.options.allowImportExportEverywhere||(e||this.raise(this.start,"'import' and 'export' may only appear at the top level"),this.inModule||this.raise(this.start,"'import' and 'export' may appear only with 'sourceType: module'")),r===tt._import?this.parseImport(n):this.parseExport(n,i);default:if(this.isAsyncFunction())return t&&this.unexpected(),this.next(),this.parseFunctionStatement(n,!0,!t);var p=this.value,c=this.parseExpression();return r===tt.name&&"Identifier"===c.type&&this.eat(tt.colon)?this.parseLabeledStatement(n,p,c,t):this.parseExpressionStatement(n,c)}},wt.parseBreakContinueStatement=function(t,e){var i="break"===e;this.next(),this.eat(tt.semi)||this.insertSemicolon()?t.label=null:this.type!==tt.name?this.unexpected():(t.label=this.parseIdent(),this.semicolon());for(var s=0;s<this.labels.length;++s){var r=this.labels[s];if(null==t.label||r.name===t.label.name){if(null!=r.kind&&(i||"loop"===r.kind))break;if(t.label&&i)break}}return s===this.labels.length&&this.raise(t.start,"Unsyntactic "+e),this.finishNode(t,i?"BreakStatement":"ContinueStatement")},wt.parseDebuggerStatement=function(t){return this.next(),this.semicolon(),this.finishNode(t,"DebuggerStatement")},wt.parseDoStatement=function(t){return this.next(),this.labels.push(Ct),t.body=this.parseStatement("do"),this.labels.pop(),this.expect(tt._while),t.test=this.parseParenExpression(),this.options.ecmaVersion>=6?this.eat(tt.semi):this.semicolon(),this.finishNode(t,"DoWhileStatement")},wt.parseForStatement=function(t){this.next();var e=this.options.ecmaVersion>=9&&(this.inAsync||!this.inFunction&&this.options.allowAwaitOutsideFunction)&&this.eatContextual("await")?this.lastTokStart:-1;if(this.labels.push(Ct),this.enterScope(0),this.expect(tt.parenL),this.type===tt.semi)return e>-1&&this.unexpected(e),this.parseFor(t,null);var i=this.isLet();if(this.type===tt._var||this.type===tt._const||i){var s=this.startNode(),r=i?"let":this.value;return this.next(),this.parseVar(s,!0,r),this.finishNode(s,"VariableDeclaration"),(this.type===tt._in||this.options.ecmaVersion>=6&&this.isContextual("of"))&&1===s.declarations.length?(this.options.ecmaVersion>=9&&(this.type===tt._in?e>-1&&this.unexpected(e):t.await=e>-1),this.parseForIn(t,s)):(e>-1&&this.unexpected(e),this.parseFor(t,s))}var n=new St,a=this.parseExpression(!0,n);return this.type===tt._in||this.options.ecmaVersion>=6&&this.isContextual("of")?(this.options.ecmaVersion>=9&&(this.type===tt._in?e>-1&&this.unexpected(e):t.await=e>-1),this.toAssignable(a,!1,n),this.checkLValPattern(a),this.parseForIn(t,a)):(this.checkExpressionErrors(n,!0),e>-1&&this.unexpected(e),this.parseFor(t,a))},wt.parseFunctionStatement=function(t,e,i){return this.next(),this.parseFunction(t,At|(i?0:Nt),!1,e)},wt.parseIfStatement=function(t){return this.next(),t.test=this.parseParenExpression(),t.consequent=this.parseStatement("if"),t.alternate=this.eat(tt._else)?this.parseStatement("if"):null,this.finishNode(t,"IfStatement")},wt.parseReturnStatement=function(t){return this.inFunction||this.options.allowReturnOutsideFunction||this.raise(this.start,"'return' outside of function"),this.next(),this.eat(tt.semi)||this.insertSemicolon()?t.argument=null:(t.argument=this.parseExpression(),this.semicolon()),this.finishNode(t,"ReturnStatement")},wt.parseSwitchStatement=function(t){var e;this.next(),t.discriminant=this.parseParenExpression(),t.cases=[],this.expect(tt.braceL),this.labels.push(Et),this.enterScope(0);for(var i=!1;this.type!==tt.braceR;)if(this.type===tt._case||this.type===tt._default){var s=this.type===tt._case;e&&this.finishNode(e,"SwitchCase"),t.cases.push(e=this.startNode()),e.consequent=[],this.next(),s?e.test=this.parseExpression():(i&&this.raiseRecoverable(this.lastTokStart,"Multiple default clauses"),i=!0,e.test=null),this.expect(tt.colon)}else e||this.unexpected(),e.consequent.push(this.parseStatement(null));return this.exitScope(),e&&this.finishNode(e,"SwitchCase"),this.next(),this.labels.pop(),this.finishNode(t,"SwitchStatement")},wt.parseThrowStatement=function(t){return this.next(),et.test(this.input.slice(this.lastTokEnd,this.start))&&this.raise(this.lastTokEnd,"Illegal newline after throw"),t.argument=this.parseExpression(),this.semicolon(),this.finishNode(t,"ThrowStatement")};var It=[];wt.parseTryStatement=function(t){if(this.next(),t.block=this.parseBlock(),t.handler=null,this.type===tt._catch){var e=this.startNode();if(this.next(),this.eat(tt.parenL)){e.param=this.parseBindingAtom();var i="Identifier"===e.param.type;this.enterScope(i?32:0),this.checkLValPattern(e.param,i?4:2),this.expect(tt.parenR)}else this.options.ecmaVersion<10&&this.unexpected(),e.param=null,this.enterScope(0);e.body=this.parseBlock(!1),this.exitScope(),t.handler=this.finishNode(e,"CatchClause")}return t.finalizer=this.eat(tt._finally)?this.parseBlock():null,t.handler||t.finalizer||this.raise(t.start,"Missing catch or finally clause"),this.finishNode(t,"TryStatement")},wt.parseVarStatement=function(t,e){return this.next(),this.parseVar(t,!1,e),this.semicolon(),this.finishNode(t,"VariableDeclaration")},wt.parseWhileStatement=function(t){return this.next(),t.test=this.parseParenExpression(),this.labels.push(Ct),t.body=this.parseStatement("while"),this.labels.pop(),this.finishNode(t,"WhileStatement")},wt.parseWithStatement=function(t){return this.strict&&this.raise(this.start,"'with' in strict mode"),this.next(),t.object=this.parseParenExpression(),t.body=this.parseStatement("with"),this.finishNode(t,"WithStatement")},wt.parseEmptyStatement=function(t){return this.next(),this.finishNode(t,"EmptyStatement")},wt.parseLabeledStatement=function(t,e,i,s){for(var r=0,n=this.labels;r<n.length;r+=1){n[r].name===e&&this.raise(i.start,"Label '"+e+"' is already declared")}for(var a=this.type.isLoop?"loop":this.type===tt._switch?"switch":null,o=this.labels.length-1;o>=0;o--){var h=this.labels[o];if(h.statementStart!==t.start)break;h.statementStart=this.start,h.kind=a}return this.labels.push({name:e,kind:a,statementStart:this.start}),t.body=this.parseStatement(s?-1===s.indexOf("label")?s+"label":s:"label"),this.labels.pop(),t.label=i,this.finishNode(t,"LabeledStatement")},wt.parseExpressionStatement=function(t,e){return t.expression=e,this.semicolon(),this.finishNode(t,"ExpressionStatement")},wt.parseBlock=function(t,e,i){for(void 0===t&&(t=!0),void 0===e&&(e=this.startNode()),e.body=[],this.expect(tt.braceL),t&&this.enterScope(0);this.type!==tt.braceR;){var s=this.parseStatement(null);e.body.push(s)}return i&&(this.strict=!1),this.next(),t&&this.exitScope(),this.finishNode(e,"BlockStatement")},wt.parseFor=function(t,e){return t.init=e,this.expect(tt.semi),t.test=this.type===tt.semi?null:this.parseExpression(),this.expect(tt.semi),t.update=this.type===tt.parenR?null:this.parseExpression(),this.expect(tt.parenR),t.body=this.parseStatement("for"),this.exitScope(),this.labels.pop(),this.finishNode(t,"ForStatement")},wt.parseForIn=function(t,e){var i=this.type===tt._in;return this.next(),"VariableDeclaration"===e.type&&null!=e.declarations[0].init&&(!i||this.options.ecmaVersion<8||this.strict||"var"!==e.kind||"Identifier"!==e.declarations[0].id.type)&&this.raise(e.start,(i?"for-in":"for-of")+" loop variable declaration may not have an initializer"),t.left=e,t.right=i?this.parseExpression():this.parseMaybeAssign(),this.expect(tt.parenR),t.body=this.parseStatement("for"),this.exitScope(),this.labels.pop(),this.finishNode(t,i?"ForInStatement":"ForOfStatement")},wt.parseVar=function(t,e,i){for(t.declarations=[],t.kind=i;;){var s=this.startNode();if(this.parseVarId(s,i),this.eat(tt.eq)?s.init=this.parseMaybeAssign(e):"const"!==i||this.type===tt._in||this.options.ecmaVersion>=6&&this.isContextual("of")?"Identifier"===s.id.type||e&&(this.type===tt._in||this.isContextual("of"))?s.init=null:this.raise(this.lastTokEnd,"Complex binding patterns require an initialization value"):this.unexpected(),t.declarations.push(this.finishNode(s,"VariableDeclarator")),!this.eat(tt.comma))break}return t},wt.parseVarId=function(t,e){t.id=this.parseBindingAtom(),this.checkLValPattern(t.id,"var"===e?1:2,!1)};var At=1,Nt=2;wt.parseFunction=function(t,e,i,s){this.initFunction(t),(this.options.ecmaVersion>=9||this.options.ecmaVersion>=6&&!s)&&(this.type===tt.star&&e&Nt&&this.unexpected(),t.generator=this.eat(tt.star)),this.options.ecmaVersion>=8&&(t.async=!!s),e&At&&(t.id=4&e&&this.type!==tt.name?null:this.parseIdent(),!t.id||e&Nt||this.checkLValSimple(t.id,this.strict||t.generator||t.async?this.treatFunctionsAsVar?1:2:3));var r=this.yieldPos,n=this.awaitPos,a=this.awaitIdentPos;return this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,this.enterScope(xt(t.async,t.generator)),e&At||(t.id=this.type===tt.name?this.parseIdent():null),this.parseFunctionParams(t),this.parseFunctionBody(t,i,!1),this.yieldPos=r,this.awaitPos=n,this.awaitIdentPos=a,this.finishNode(t,e&At?"FunctionDeclaration":"FunctionExpression")},wt.parseFunctionParams=function(t){this.expect(tt.parenL),t.params=this.parseBindingList(tt.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams()},wt.parseClass=function(t,e){this.next();var i=this.strict;this.strict=!0,this.parseClassId(t,e),this.parseClassSuper(t);var s=this.startNode(),r=!1;for(s.body=[],this.expect(tt.braceL);this.type!==tt.braceR;){var n=this.parseClassElement(null!==t.superClass);n&&(s.body.push(n),"MethodDefinition"===n.type&&"constructor"===n.kind&&(r&&this.raise(n.start,"Duplicate constructor in the same class"),r=!0))}return this.strict=i,this.next(),t.body=this.finishNode(s,"ClassBody"),this.finishNode(t,e?"ClassDeclaration":"ClassExpression")},wt.parseClassElement=function(t){var e=this;if(this.eat(tt.semi))return null;var i=this.startNode(),s=function(t,s){void 0===s&&(s=!1);var r=e.start,n=e.startLoc;return!!e.eatContextual(t)&&(!(e.type===tt.parenL||s&&e.canInsertSemicolon())||(i.key&&e.unexpected(),i.computed=!1,i.key=e.startNodeAt(r,n),i.key.name=t,e.finishNode(i.key,"Identifier"),!1))};i.kind="method",i.static=s("static");var r=this.eat(tt.star),n=!1;r||(this.options.ecmaVersion>=8&&s("async",!0)?(n=!0,r=this.options.ecmaVersion>=9&&this.eat(tt.star)):s("get")?i.kind="get":s("set")&&(i.kind="set")),i.key||this.parsePropertyName(i);var a=i.key,o=!1;return i.computed||i.static||!("Identifier"===a.type&&"constructor"===a.name||"Literal"===a.type&&"constructor"===a.value)?i.static&&"Identifier"===a.type&&"prototype"===a.name&&this.raise(a.start,"Classes may not have a static property named prototype"):("method"!==i.kind&&this.raise(a.start,"Constructor can't have get/set modifier"),r&&this.raise(a.start,"Constructor can't be a generator"),n&&this.raise(a.start,"Constructor can't be an async method"),i.kind="constructor",o=t),this.parseClassMethod(i,r,n,o),"get"===i.kind&&0!==i.value.params.length&&this.raiseRecoverable(i.value.start,"getter should have no params"),"set"===i.kind&&1!==i.value.params.length&&this.raiseRecoverable(i.value.start,"setter should have exactly one param"),"set"===i.kind&&"RestElement"===i.value.params[0].type&&this.raiseRecoverable(i.value.params[0].start,"Setter cannot use rest params"),i},wt.parseClassMethod=function(t,e,i,s){return t.value=this.parseMethod(e,i,s),this.finishNode(t,"MethodDefinition")},wt.parseClassId=function(t,e){this.type===tt.name?(t.id=this.parseIdent(),e&&this.checkLValSimple(t.id,2,!1)):(!0===e&&this.unexpected(),t.id=null)},wt.parseClassSuper=function(t){t.superClass=this.eat(tt._extends)?this.parseExprSubscripts():null},wt.parseExport=function(t,e){if(this.next(),this.eat(tt.star))return this.options.ecmaVersion>=11&&(this.eatContextual("as")?(t.exported=this.parseIdent(!0),this.checkExport(e,t.exported.name,this.lastTokStart)):t.exported=null),this.expectContextual("from"),this.type!==tt.string&&this.unexpected(),t.source=this.parseExprAtom(),this.semicolon(),this.finishNode(t,"ExportAllDeclaration");if(this.eat(tt._default)){var i;if(this.checkExport(e,"default",this.lastTokStart),this.type===tt._function||(i=this.isAsyncFunction())){var s=this.startNode();this.next(),i&&this.next(),t.declaration=this.parseFunction(s,4|At,!1,i)}else if(this.type===tt._class){var r=this.startNode();t.declaration=this.parseClass(r,"nullableID")}else t.declaration=this.parseMaybeAssign(),this.semicolon();return this.finishNode(t,"ExportDefaultDeclaration")}if(this.shouldParseExportStatement())t.declaration=this.parseStatement(null),"VariableDeclaration"===t.declaration.type?this.checkVariableExport(e,t.declaration.declarations):this.checkExport(e,t.declaration.id.name,t.declaration.id.start),t.specifiers=[],t.source=null;else{if(t.declaration=null,t.specifiers=this.parseExportSpecifiers(e),this.eatContextual("from"))this.type!==tt.string&&this.unexpected(),t.source=this.parseExprAtom();else{for(var n=0,a=t.specifiers;n<a.length;n+=1){var o=a[n];this.checkUnreserved(o.local),this.checkLocalExport(o.local)}t.source=null}this.semicolon()}return this.finishNode(t,"ExportNamedDeclaration")},wt.checkExport=function(t,e,i){t&&(pt(t,e)&&this.raiseRecoverable(i,"Duplicate export '"+e+"'"),t[e]=!0)},wt.checkPatternExport=function(t,e){var i=e.type;if("Identifier"===i)this.checkExport(t,e.name,e.start);else if("ObjectPattern"===i)for(var s=0,r=e.properties;s<r.length;s+=1){var n=r[s];this.checkPatternExport(t,n)}else if("ArrayPattern"===i)for(var a=0,o=e.elements;a<o.length;a+=1){var h=o[a];h&&this.checkPatternExport(t,h)}else"Property"===i?this.checkPatternExport(t,e.value):"AssignmentPattern"===i?this.checkPatternExport(t,e.left):"RestElement"===i?this.checkPatternExport(t,e.argument):"ParenthesizedExpression"===i&&this.checkPatternExport(t,e.expression)},wt.checkVariableExport=function(t,e){if(t)for(var i=0,s=e;i<s.length;i+=1){var r=s[i];this.checkPatternExport(t,r.id)}},wt.shouldParseExportStatement=function(){return"var"===this.type.keyword||"const"===this.type.keyword||"class"===this.type.keyword||"function"===this.type.keyword||this.isLet()||this.isAsyncFunction()},wt.parseExportSpecifiers=function(t){var e=[],i=!0;for(this.expect(tt.braceL);!this.eat(tt.braceR);){if(i)i=!1;else if(this.expect(tt.comma),this.afterTrailingComma(tt.braceR))break;var s=this.startNode();s.local=this.parseIdent(!0),s.exported=this.eatContextual("as")?this.parseIdent(!0):s.local,this.checkExport(t,s.exported.name,s.exported.start),e.push(this.finishNode(s,"ExportSpecifier"))}return e},wt.parseImport=function(t){return this.next(),this.type===tt.string?(t.specifiers=It,t.source=this.parseExprAtom()):(t.specifiers=this.parseImportSpecifiers(),this.expectContextual("from"),t.source=this.type===tt.string?this.parseExprAtom():this.unexpected()),this.semicolon(),this.finishNode(t,"ImportDeclaration")},wt.parseImportSpecifiers=function(){var t=[],e=!0;if(this.type===tt.name){var i=this.startNode();if(i.local=this.parseIdent(),this.checkLValSimple(i.local,2),t.push(this.finishNode(i,"ImportDefaultSpecifier")),!this.eat(tt.comma))return t}if(this.type===tt.star){var s=this.startNode();return this.next(),this.expectContextual("as"),s.local=this.parseIdent(),this.checkLValSimple(s.local,2),t.push(this.finishNode(s,"ImportNamespaceSpecifier")),t}for(this.expect(tt.braceL);!this.eat(tt.braceR);){if(e)e=!1;else if(this.expect(tt.comma),this.afterTrailingComma(tt.braceR))break;var r=this.startNode();r.imported=this.parseIdent(!0),this.eatContextual("as")?r.local=this.parseIdent():(this.checkUnreserved(r.imported),r.local=r.imported),this.checkLValSimple(r.local,2),t.push(this.finishNode(r,"ImportSpecifier"))}return t},wt.adaptDirectivePrologue=function(t){for(var e=0;e<t.length&&this.isDirectiveCandidate(t[e]);++e)t[e].directive=t[e].expression.raw.slice(1,-1)},wt.isDirectiveCandidate=function(t){return"ExpressionStatement"===t.type&&"Literal"===t.expression.type&&"string"==typeof t.expression.value&&('"'===this.input[t.start]||"'"===this.input[t.start])};var Lt=kt.prototype;Lt.toAssignable=function(t,e,i){if(this.options.ecmaVersion>=6&&t)switch(t.type){case"Identifier":this.inAsync&&"await"===t.name&&this.raise(t.start,"Cannot use 'await' as identifier inside an async function");break;case"ObjectPattern":case"ArrayPattern":case"AssignmentPattern":case"RestElement":break;case"ObjectExpression":t.type="ObjectPattern",i&&this.checkPatternErrors(i,!0);for(var s=0,r=t.properties;s<r.length;s+=1){var n=r[s];this.toAssignable(n,e),"RestElement"!==n.type||"ArrayPattern"!==n.argument.type&&"ObjectPattern"!==n.argument.type||this.raise(n.argument.start,"Unexpected token")}break;case"Property":"init"!==t.kind&&this.raise(t.key.start,"Object pattern can't contain getter or setter"),this.toAssignable(t.value,e);break;case"ArrayExpression":t.type="ArrayPattern",i&&this.checkPatternErrors(i,!0),this.toAssignableList(t.elements,e);break;case"SpreadElement":t.type="RestElement",this.toAssignable(t.argument,e),"AssignmentPattern"===t.argument.type&&this.raise(t.argument.start,"Rest elements cannot have a default value");break;case"AssignmentExpression":"="!==t.operator&&this.raise(t.left.end,"Only '=' operator can be used for specifying default value."),t.type="AssignmentPattern",delete t.operator,this.toAssignable(t.left,e);break;case"ParenthesizedExpression":this.toAssignable(t.expression,e,i);break;case"ChainExpression":this.raiseRecoverable(t.start,"Optional chaining cannot appear in left-hand side");break;case"MemberExpression":if(!e)break;default:this.raise(t.start,"Assigning to rvalue")}else i&&this.checkPatternErrors(i,!0);return t},Lt.toAssignableList=function(t,e){for(var i=t.length,s=0;s<i;s++){var r=t[s];r&&this.toAssignable(r,e)}if(i){var n=t[i-1];6===this.options.ecmaVersion&&e&&n&&"RestElement"===n.type&&"Identifier"!==n.argument.type&&this.unexpected(n.argument.start)}return t},Lt.parseSpread=function(t){var e=this.startNode();return this.next(),e.argument=this.parseMaybeAssign(!1,t),this.finishNode(e,"SpreadElement")},Lt.parseRestBinding=function(){var t=this.startNode();return this.next(),6===this.options.ecmaVersion&&this.type!==tt.name&&this.unexpected(),t.argument=this.parseBindingAtom(),this.finishNode(t,"RestElement")},Lt.parseBindingAtom=function(){if(this.options.ecmaVersion>=6)switch(this.type){case tt.bracketL:var t=this.startNode();return this.next(),t.elements=this.parseBindingList(tt.bracketR,!0,!0),this.finishNode(t,"ArrayPattern");case tt.braceL:return this.parseObj(!0)}return this.parseIdent()},Lt.parseBindingList=function(t,e,i){for(var s=[],r=!0;!this.eat(t);)if(r?r=!1:this.expect(tt.comma),e&&this.type===tt.comma)s.push(null);else{if(i&&this.afterTrailingComma(t))break;if(this.type===tt.ellipsis){var n=this.parseRestBinding();this.parseBindingListItem(n),s.push(n),this.type===tt.comma&&this.raise(this.start,"Comma is not permitted after the rest element"),this.expect(t);break}var a=this.parseMaybeDefault(this.start,this.startLoc);this.parseBindingListItem(a),s.push(a)}return s},Lt.parseBindingListItem=function(t){return t},Lt.parseMaybeDefault=function(t,e,i){if(i=i||this.parseBindingAtom(),this.options.ecmaVersion<6||!this.eat(tt.eq))return i;var s=this.startNodeAt(t,e);return s.left=i,s.right=this.parseMaybeAssign(),this.finishNode(s,"AssignmentPattern")},Lt.checkLValSimple=function(t,e,i){void 0===e&&(e=0);var s=0!==e;switch(t.type){case"Identifier":this.strict&&this.reservedWordsStrictBind.test(t.name)&&this.raiseRecoverable(t.start,(s?"Binding ":"Assigning to ")+t.name+" in strict mode"),s&&(2===e&&"let"===t.name&&this.raiseRecoverable(t.start,"let is disallowed as a lexically bound name"),i&&(pt(i,t.name)&&this.raiseRecoverable(t.start,"Argument name clash"),i[t.name]=!0),5!==e&&this.declareName(t.name,e,t.start));break;case"ChainExpression":this.raiseRecoverable(t.start,"Optional chaining cannot appear in left-hand side");break;case"MemberExpression":s&&this.raiseRecoverable(t.start,"Binding member expression");break;case"ParenthesizedExpression":return s&&this.raiseRecoverable(t.start,"Binding parenthesized expression"),this.checkLValSimple(t.expression,e,i);default:this.raise(t.start,(s?"Binding":"Assigning to")+" rvalue")}},Lt.checkLValPattern=function(t,e,i){switch(void 0===e&&(e=0),t.type){case"ObjectPattern":for(var s=0,r=t.properties;s<r.length;s+=1){var n=r[s];this.checkLValInnerPattern(n,e,i)}break;case"ArrayPattern":for(var a=0,o=t.elements;a<o.length;a+=1){var h=o[a];h&&this.checkLValInnerPattern(h,e,i)}break;default:this.checkLValSimple(t,e,i)}},Lt.checkLValInnerPattern=function(t,e,i){switch(void 0===e&&(e=0),t.type){case"Property":this.checkLValInnerPattern(t.value,e,i);break;case"AssignmentPattern":this.checkLValPattern(t.left,e,i);break;case"RestElement":this.checkLValPattern(t.argument,e,i);break;default:this.checkLValPattern(t,e,i)}};var Tt=kt.prototype;Tt.checkPropClash=function(t,e,i){if(!(this.options.ecmaVersion>=9&&"SpreadElement"===t.type||this.options.ecmaVersion>=6&&(t.computed||t.method||t.shorthand))){var s,r=t.key;switch(r.type){case"Identifier":s=r.name;break;case"Literal":s=String(r.value);break;default:return}var n=t.kind;if(this.options.ecmaVersion>=6)"__proto__"===s&&"init"===n&&(e.proto&&(i?i.doubleProto<0&&(i.doubleProto=r.start):this.raiseRecoverable(r.start,"Redefinition of __proto__ property")),e.proto=!0);else{var a=e[s="$"+s];if(a)("init"===n?this.strict&&a.init||a.get||a.set:a.init||a[n])&&this.raiseRecoverable(r.start,"Redefinition of property");else a=e[s]={init:!1,get:!1,set:!1};a[n]=!0}}},Tt.parseExpression=function(t,e){var i=this.start,s=this.startLoc,r=this.parseMaybeAssign(t,e);if(this.type===tt.comma){var n=this.startNodeAt(i,s);for(n.expressions=[r];this.eat(tt.comma);)n.expressions.push(this.parseMaybeAssign(t,e));return this.finishNode(n,"SequenceExpression")}return r},Tt.parseMaybeAssign=function(t,e,i){if(this.isContextual("yield")){if(this.inGenerator)return this.parseYield(t);this.exprAllowed=!1}var s=!1,r=-1,n=-1;e?(r=e.parenthesizedAssign,n=e.trailingComma,e.parenthesizedAssign=e.trailingComma=-1):(e=new St,s=!0);var a=this.start,o=this.startLoc;this.type!==tt.parenL&&this.type!==tt.name||(this.potentialArrowAt=this.start);var h=this.parseMaybeConditional(t,e);if(i&&(h=i.call(this,h,a,o)),this.type.isAssign){var p=this.startNodeAt(a,o);return p.operator=this.value,this.type===tt.eq&&(h=this.toAssignable(h,!1,e)),s||(e.parenthesizedAssign=e.trailingComma=e.doubleProto=-1),e.shorthandAssign>=h.start&&(e.shorthandAssign=-1),this.type===tt.eq?this.checkLValPattern(h):this.checkLValSimple(h),p.left=h,this.next(),p.right=this.parseMaybeAssign(t),this.finishNode(p,"AssignmentExpression")}return s&&this.checkExpressionErrors(e,!0),r>-1&&(e.parenthesizedAssign=r),n>-1&&(e.trailingComma=n),h},Tt.parseMaybeConditional=function(t,e){var i=this.start,s=this.startLoc,r=this.parseExprOps(t,e);if(this.checkExpressionErrors(e))return r;if(this.eat(tt.question)){var n=this.startNodeAt(i,s);return n.test=r,n.consequent=this.parseMaybeAssign(),this.expect(tt.colon),n.alternate=this.parseMaybeAssign(t),this.finishNode(n,"ConditionalExpression")}return r},Tt.parseExprOps=function(t,e){var i=this.start,s=this.startLoc,r=this.parseMaybeUnary(e,!1);return this.checkExpressionErrors(e)||r.start===i&&"ArrowFunctionExpression"===r.type?r:this.parseExprOp(r,i,s,-1,t)},Tt.parseExprOp=function(t,e,i,s,r){var n=this.type.binop;if(null!=n&&(!r||this.type!==tt._in)&&n>s){var a=this.type===tt.logicalOR||this.type===tt.logicalAND,o=this.type===tt.coalesce;o&&(n=tt.logicalAND.binop);var h=this.value;this.next();var p=this.start,c=this.startLoc,l=this.parseExprOp(this.parseMaybeUnary(null,!1),p,c,n,r),u=this.buildBinary(e,i,t,l,h,a||o);return(a&&this.type===tt.coalesce||o&&(this.type===tt.logicalOR||this.type===tt.logicalAND))&&this.raiseRecoverable(this.start,"Logical expressions and coalesce expressions cannot be mixed. Wrap either by parentheses"),this.parseExprOp(u,e,i,s,r)}return t},Tt.buildBinary=function(t,e,i,s,r,n){var a=this.startNodeAt(t,e);return a.left=i,a.operator=r,a.right=s,this.finishNode(a,n?"LogicalExpression":"BinaryExpression")},Tt.parseMaybeUnary=function(t,e){var i,s=this.start,r=this.startLoc;if(this.isContextual("await")&&(this.inAsync||!this.inFunction&&this.options.allowAwaitOutsideFunction))i=this.parseAwait(),e=!0;else if(this.type.prefix){var n=this.startNode(),a=this.type===tt.incDec;n.operator=this.value,n.prefix=!0,this.next(),n.argument=this.parseMaybeUnary(null,!0),this.checkExpressionErrors(t,!0),a?this.checkLValSimple(n.argument):this.strict&&"delete"===n.operator&&"Identifier"===n.argument.type?this.raiseRecoverable(n.start,"Deleting local variable in strict mode"):e=!0,i=this.finishNode(n,a?"UpdateExpression":"UnaryExpression")}else{if(i=this.parseExprSubscripts(t),this.checkExpressionErrors(t))return i;for(;this.type.postfix&&!this.canInsertSemicolon();){var o=this.startNodeAt(s,r);o.operator=this.value,o.prefix=!1,o.argument=i,this.checkLValSimple(i),this.next(),i=this.finishNode(o,"UpdateExpression")}}return!e&&this.eat(tt.starstar)?this.buildBinary(s,r,i,this.parseMaybeUnary(null,!1),"**",!1):i},Tt.parseExprSubscripts=function(t){var e=this.start,i=this.startLoc,s=this.parseExprAtom(t);if("ArrowFunctionExpression"===s.type&&")"!==this.input.slice(this.lastTokStart,this.lastTokEnd))return s;var r=this.parseSubscripts(s,e,i);return t&&"MemberExpression"===r.type&&(t.parenthesizedAssign>=r.start&&(t.parenthesizedAssign=-1),t.parenthesizedBind>=r.start&&(t.parenthesizedBind=-1)),r},Tt.parseSubscripts=function(t,e,i,s){for(var r=this.options.ecmaVersion>=8&&"Identifier"===t.type&&"async"===t.name&&this.lastTokEnd===t.end&&!this.canInsertSemicolon()&&t.end-t.start==5&&this.potentialArrowAt===t.start,n=!1;;){var a=this.parseSubscript(t,e,i,s,r,n);if(a.optional&&(n=!0),a===t||"ArrowFunctionExpression"===a.type){if(n){var o=this.startNodeAt(e,i);o.expression=a,a=this.finishNode(o,"ChainExpression")}return a}t=a}},Tt.parseSubscript=function(t,e,i,s,r,n){var a=this.options.ecmaVersion>=11,o=a&&this.eat(tt.questionDot);s&&o&&this.raise(this.lastTokStart,"Optional chaining cannot appear in the callee of new expressions");var h=this.eat(tt.bracketL);if(h||o&&this.type!==tt.parenL&&this.type!==tt.backQuote||this.eat(tt.dot)){var p=this.startNodeAt(e,i);p.object=t,p.property=h?this.parseExpression():this.parseIdent("never"!==this.options.allowReserved),p.computed=!!h,h&&this.expect(tt.bracketR),a&&(p.optional=o),t=this.finishNode(p,"MemberExpression")}else if(!s&&this.eat(tt.parenL)){var c=new St,l=this.yieldPos,u=this.awaitPos,d=this.awaitIdentPos;this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0;var f=this.parseExprList(tt.parenR,this.options.ecmaVersion>=8,!1,c);if(r&&!o&&!this.canInsertSemicolon()&&this.eat(tt.arrow))return this.checkPatternErrors(c,!1),this.checkYieldAwaitInDefaultParams(),this.awaitIdentPos>0&&this.raise(this.awaitIdentPos,"Cannot use 'await' as identifier inside an async function"),this.yieldPos=l,this.awaitPos=u,this.awaitIdentPos=d,this.parseArrowExpression(this.startNodeAt(e,i),f,!0);this.checkExpressionErrors(c,!0),this.yieldPos=l||this.yieldPos,this.awaitPos=u||this.awaitPos,this.awaitIdentPos=d||this.awaitIdentPos;var m=this.startNodeAt(e,i);m.callee=t,m.arguments=f,a&&(m.optional=o),t=this.finishNode(m,"CallExpression")}else if(this.type===tt.backQuote){(o||n)&&this.raise(this.start,"Optional chaining cannot appear in the tag of tagged template expressions");var g=this.startNodeAt(e,i);g.tag=t,g.quasi=this.parseTemplate({isTagged:!0}),t=this.finishNode(g,"TaggedTemplateExpression")}return t},Tt.parseExprAtom=function(t){this.type===tt.slash&&this.readRegexp();var e,i=this.potentialArrowAt===this.start;switch(this.type){case tt._super:return this.allowSuper||this.raise(this.start,"'super' keyword outside a method"),e=this.startNode(),this.next(),this.type!==tt.parenL||this.allowDirectSuper||this.raise(e.start,"super() call outside constructor of a subclass"),this.type!==tt.dot&&this.type!==tt.bracketL&&this.type!==tt.parenL&&this.unexpected(),this.finishNode(e,"Super");case tt._this:return e=this.startNode(),this.next(),this.finishNode(e,"ThisExpression");case tt.name:var s=this.start,r=this.startLoc,n=this.containsEsc,a=this.parseIdent(!1);if(this.options.ecmaVersion>=8&&!n&&"async"===a.name&&!this.canInsertSemicolon()&&this.eat(tt._function))return this.parseFunction(this.startNodeAt(s,r),0,!1,!0);if(i&&!this.canInsertSemicolon()){if(this.eat(tt.arrow))return this.parseArrowExpression(this.startNodeAt(s,r),[a],!1);if(this.options.ecmaVersion>=8&&"async"===a.name&&this.type===tt.name&&!n)return a=this.parseIdent(!1),!this.canInsertSemicolon()&&this.eat(tt.arrow)||this.unexpected(),this.parseArrowExpression(this.startNodeAt(s,r),[a],!0)}return a;case tt.regexp:var o=this.value;return(e=this.parseLiteral(o.value)).regex={pattern:o.pattern,flags:o.flags},e;case tt.num:case tt.string:return this.parseLiteral(this.value);case tt._null:case tt._true:case tt._false:return(e=this.startNode()).value=this.type===tt._null?null:this.type===tt._true,e.raw=this.type.keyword,this.next(),this.finishNode(e,"Literal");case tt.parenL:var h=this.start,p=this.parseParenAndDistinguishExpression(i);return t&&(t.parenthesizedAssign<0&&!this.isSimpleAssignTarget(p)&&(t.parenthesizedAssign=h),t.parenthesizedBind<0&&(t.parenthesizedBind=h)),p;case tt.bracketL:return e=this.startNode(),this.next(),e.elements=this.parseExprList(tt.bracketR,!0,!0,t),this.finishNode(e,"ArrayExpression");case tt.braceL:return this.parseObj(!1,t);case tt._function:return e=this.startNode(),this.next(),this.parseFunction(e,0);case tt._class:return this.parseClass(this.startNode(),!1);case tt._new:return this.parseNew();case tt.backQuote:return this.parseTemplate();case tt._import:return this.options.ecmaVersion>=11?this.parseExprImport():this.unexpected();default:this.unexpected()}},Tt.parseExprImport=function(){var t=this.startNode();this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword import");var e=this.parseIdent(!0);switch(this.type){case tt.parenL:return this.parseDynamicImport(t);case tt.dot:return t.meta=e,this.parseImportMeta(t);default:this.unexpected()}},Tt.parseDynamicImport=function(t){if(this.next(),t.source=this.parseMaybeAssign(),!this.eat(tt.parenR)){var e=this.start;this.eat(tt.comma)&&this.eat(tt.parenR)?this.raiseRecoverable(e,"Trailing comma is not allowed in import()"):this.unexpected(e)}return this.finishNode(t,"ImportExpression")},Tt.parseImportMeta=function(t){this.next();var e=this.containsEsc;return t.property=this.parseIdent(!0),"meta"!==t.property.name&&this.raiseRecoverable(t.property.start,"The only valid meta property for import is 'import.meta'"),e&&this.raiseRecoverable(t.start,"'import.meta' must not contain escaped characters"),"module"!==this.options.sourceType&&this.raiseRecoverable(t.start,"Cannot use 'import.meta' outside a module"),this.finishNode(t,"MetaProperty")},Tt.parseLiteral=function(t){var e=this.startNode();return e.value=t,e.raw=this.input.slice(this.start,this.end),110===e.raw.charCodeAt(e.raw.length-1)&&(e.bigint=e.raw.slice(0,-1).replace(/_/g,"")),this.next(),this.finishNode(e,"Literal")},Tt.parseParenExpression=function(){this.expect(tt.parenL);var t=this.parseExpression();return this.expect(tt.parenR),t},Tt.parseParenAndDistinguishExpression=function(t){var e,i=this.start,s=this.startLoc,r=this.options.ecmaVersion>=8;if(this.options.ecmaVersion>=6){this.next();var n,a=this.start,o=this.startLoc,h=[],p=!0,c=!1,l=new St,u=this.yieldPos,d=this.awaitPos;for(this.yieldPos=0,this.awaitPos=0;this.type!==tt.parenR;){if(p?p=!1:this.expect(tt.comma),r&&this.afterTrailingComma(tt.parenR,!0)){c=!0;break}if(this.type===tt.ellipsis){n=this.start,h.push(this.parseParenItem(this.parseRestBinding())),this.type===tt.comma&&this.raise(this.start,"Comma is not permitted after the rest element");break}h.push(this.parseMaybeAssign(!1,l,this.parseParenItem))}var f=this.start,m=this.startLoc;if(this.expect(tt.parenR),t&&!this.canInsertSemicolon()&&this.eat(tt.arrow))return this.checkPatternErrors(l,!1),this.checkYieldAwaitInDefaultParams(),this.yieldPos=u,this.awaitPos=d,this.parseParenArrowList(i,s,h);h.length&&!c||this.unexpected(this.lastTokStart),n&&this.unexpected(n),this.checkExpressionErrors(l,!0),this.yieldPos=u||this.yieldPos,this.awaitPos=d||this.awaitPos,h.length>1?((e=this.startNodeAt(a,o)).expressions=h,this.finishNodeAt(e,"SequenceExpression",f,m)):e=h[0]}else e=this.parseParenExpression();if(this.options.preserveParens){var g=this.startNodeAt(i,s);return g.expression=e,this.finishNode(g,"ParenthesizedExpression")}return e},Tt.parseParenItem=function(t){return t},Tt.parseParenArrowList=function(t,e,i){return this.parseArrowExpression(this.startNodeAt(t,e),i)};var Pt=[];Tt.parseNew=function(){this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword new");var t=this.startNode(),e=this.parseIdent(!0);if(this.options.ecmaVersion>=6&&this.eat(tt.dot)){t.meta=e;var i=this.containsEsc;return t.property=this.parseIdent(!0),"target"!==t.property.name&&this.raiseRecoverable(t.property.start,"The only valid meta property for new is 'new.target'"),i&&this.raiseRecoverable(t.start,"'new.target' must not contain escaped characters"),this.inNonArrowFunction||this.raiseRecoverable(t.start,"'new.target' can only be used in functions"),this.finishNode(t,"MetaProperty")}var s=this.start,r=this.startLoc,n=this.type===tt._import;return t.callee=this.parseSubscripts(this.parseExprAtom(),s,r,!0),n&&"ImportExpression"===t.callee.type&&this.raise(s,"Cannot use new with import()"),this.eat(tt.parenL)?t.arguments=this.parseExprList(tt.parenR,this.options.ecmaVersion>=8,!1):t.arguments=Pt,this.finishNode(t,"NewExpression")},Tt.parseTemplateElement=function(t){var e=t.isTagged,i=this.startNode();return this.type===tt.invalidTemplate?(e||this.raiseRecoverable(this.start,"Bad escape sequence in untagged template literal"),i.value={raw:this.value,cooked:null}):i.value={raw:this.input.slice(this.start,this.end).replace(/\r\n?/g,"\n"),cooked:this.value},this.next(),i.tail=this.type===tt.backQuote,this.finishNode(i,"TemplateElement")},Tt.parseTemplate=function(t){void 0===t&&(t={});var e=t.isTagged;void 0===e&&(e=!1);var i=this.startNode();this.next(),i.expressions=[];var s=this.parseTemplateElement({isTagged:e});for(i.quasis=[s];!s.tail;)this.type===tt.eof&&this.raise(this.pos,"Unterminated template literal"),this.expect(tt.dollarBraceL),i.expressions.push(this.parseExpression()),this.expect(tt.braceR),i.quasis.push(s=this.parseTemplateElement({isTagged:e}));return this.next(),this.finishNode(i,"TemplateLiteral")},Tt.isAsyncProp=function(t){return!t.computed&&"Identifier"===t.key.type&&"async"===t.key.name&&(this.type===tt.name||this.type===tt.num||this.type===tt.string||this.type===tt.bracketL||this.type.keyword||this.options.ecmaVersion>=9&&this.type===tt.star)&&!et.test(this.input.slice(this.lastTokEnd,this.start))},Tt.parseObj=function(t,e){var i=this.startNode(),s=!0,r={};for(i.properties=[],this.next();!this.eat(tt.braceR);){if(s)s=!1;else if(this.expect(tt.comma),this.options.ecmaVersion>=5&&this.afterTrailingComma(tt.braceR))break;var n=this.parseProperty(t,e);t||this.checkPropClash(n,r,e),i.properties.push(n)}return this.finishNode(i,t?"ObjectPattern":"ObjectExpression")},Tt.parseProperty=function(t,e){var i,s,r,n,a=this.startNode();if(this.options.ecmaVersion>=9&&this.eat(tt.ellipsis))return t?(a.argument=this.parseIdent(!1),this.type===tt.comma&&this.raise(this.start,"Comma is not permitted after the rest element"),this.finishNode(a,"RestElement")):(this.type===tt.parenL&&e&&(e.parenthesizedAssign<0&&(e.parenthesizedAssign=this.start),e.parenthesizedBind<0&&(e.parenthesizedBind=this.start)),a.argument=this.parseMaybeAssign(!1,e),this.type===tt.comma&&e&&e.trailingComma<0&&(e.trailingComma=this.start),this.finishNode(a,"SpreadElement"));this.options.ecmaVersion>=6&&(a.method=!1,a.shorthand=!1,(t||e)&&(r=this.start,n=this.startLoc),t||(i=this.eat(tt.star)));var o=this.containsEsc;return this.parsePropertyName(a),!t&&!o&&this.options.ecmaVersion>=8&&!i&&this.isAsyncProp(a)?(s=!0,i=this.options.ecmaVersion>=9&&this.eat(tt.star),this.parsePropertyName(a,e)):s=!1,this.parsePropertyValue(a,t,i,s,r,n,e,o),this.finishNode(a,"Property")},Tt.parsePropertyValue=function(t,e,i,s,r,n,a,o){if((i||s)&&this.type===tt.colon&&this.unexpected(),this.eat(tt.colon))t.value=e?this.parseMaybeDefault(this.start,this.startLoc):this.parseMaybeAssign(!1,a),t.kind="init";else if(this.options.ecmaVersion>=6&&this.type===tt.parenL)e&&this.unexpected(),t.kind="init",t.method=!0,t.value=this.parseMethod(i,s);else if(e||o||!(this.options.ecmaVersion>=5)||t.computed||"Identifier"!==t.key.type||"get"!==t.key.name&&"set"!==t.key.name||this.type===tt.comma||this.type===tt.braceR||this.type===tt.eq)this.options.ecmaVersion>=6&&!t.computed&&"Identifier"===t.key.type?((i||s)&&this.unexpected(),this.checkUnreserved(t.key),"await"!==t.key.name||this.awaitIdentPos||(this.awaitIdentPos=r),t.kind="init",e?t.value=this.parseMaybeDefault(r,n,this.copyNode(t.key)):this.type===tt.eq&&a?(a.shorthandAssign<0&&(a.shorthandAssign=this.start),t.value=this.parseMaybeDefault(r,n,this.copyNode(t.key))):t.value=this.copyNode(t.key),t.shorthand=!0):this.unexpected();else{(i||s)&&this.unexpected(),t.kind=t.key.name,this.parsePropertyName(t),t.value=this.parseMethod(!1);var h="get"===t.kind?0:1;if(t.value.params.length!==h){var p=t.value.start;"get"===t.kind?this.raiseRecoverable(p,"getter should have no params"):this.raiseRecoverable(p,"setter should have exactly one param")}else"set"===t.kind&&"RestElement"===t.value.params[0].type&&this.raiseRecoverable(t.value.params[0].start,"Setter cannot use rest params")}},Tt.parsePropertyName=function(t){if(this.options.ecmaVersion>=6){if(this.eat(tt.bracketL))return t.computed=!0,t.key=this.parseMaybeAssign(),this.expect(tt.bracketR),t.key;t.computed=!1}return t.key=this.type===tt.num||this.type===tt.string?this.parseExprAtom():this.parseIdent("never"!==this.options.allowReserved)},Tt.initFunction=function(t){t.id=null,this.options.ecmaVersion>=6&&(t.generator=t.expression=!1),this.options.ecmaVersion>=8&&(t.async=!1)},Tt.parseMethod=function(t,e,i){var s=this.startNode(),r=this.yieldPos,n=this.awaitPos,a=this.awaitIdentPos;return this.initFunction(s),this.options.ecmaVersion>=6&&(s.generator=t),this.options.ecmaVersion>=8&&(s.async=!!e),this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,this.enterScope(64|xt(e,s.generator)|(i?128:0)),this.expect(tt.parenL),s.params=this.parseBindingList(tt.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams(),this.parseFunctionBody(s,!1,!0),this.yieldPos=r,this.awaitPos=n,this.awaitIdentPos=a,this.finishNode(s,"FunctionExpression")},Tt.parseArrowExpression=function(t,e,i){var s=this.yieldPos,r=this.awaitPos,n=this.awaitIdentPos;return this.enterScope(16|xt(i,!1)),this.initFunction(t),this.options.ecmaVersion>=8&&(t.async=!!i),this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,t.params=this.toAssignableList(e,!0),this.parseFunctionBody(t,!0,!1),this.yieldPos=s,this.awaitPos=r,this.awaitIdentPos=n,this.finishNode(t,"ArrowFunctionExpression")},Tt.parseFunctionBody=function(t,e,i){var s=e&&this.type!==tt.braceL,r=this.strict,n=!1;if(s)t.body=this.parseMaybeAssign(),t.expression=!0,this.checkParams(t,!1);else{var a=this.options.ecmaVersion>=7&&!this.isSimpleParamList(t.params);r&&!a||(n=this.strictDirective(this.end))&&a&&this.raiseRecoverable(t.start,"Illegal 'use strict' directive in function with non-simple parameter list");var o=this.labels;this.labels=[],n&&(this.strict=!0),this.checkParams(t,!r&&!n&&!e&&!i&&this.isSimpleParamList(t.params)),this.strict&&t.id&&this.checkLValSimple(t.id,5),t.body=this.parseBlock(!1,void 0,n&&!r),t.expression=!1,this.adaptDirectivePrologue(t.body.body),this.labels=o}this.exitScope()},Tt.isSimpleParamList=function(t){for(var e=0,i=t;e<i.length;e+=1){if("Identifier"!==i[e].type)return!1}return!0},Tt.checkParams=function(t,e){for(var i={},s=0,r=t.params;s<r.length;s+=1){var n=r[s];this.checkLValInnerPattern(n,1,e?null:i)}},Tt.parseExprList=function(t,e,i,s){for(var r=[],n=!0;!this.eat(t);){if(n)n=!1;else if(this.expect(tt.comma),e&&this.afterTrailingComma(t))break;var a=void 0;i&&this.type===tt.comma?a=null:this.type===tt.ellipsis?(a=this.parseSpread(s),s&&this.type===tt.comma&&s.trailingComma<0&&(s.trailingComma=this.start)):a=this.parseMaybeAssign(!1,s),r.push(a)}return r},Tt.checkUnreserved=function(t){var e=t.start,i=t.end,s=t.name;(this.inGenerator&&"yield"===s&&this.raiseRecoverable(e,"Cannot use 'yield' as identifier inside a generator"),this.inAsync&&"await"===s&&this.raiseRecoverable(e,"Cannot use 'await' as identifier inside an async function"),this.keywords.test(s)&&this.raise(e,"Unexpected keyword '"+s+"'"),this.options.ecmaVersion<6&&-1!==this.input.slice(e,i).indexOf("\\"))||(this.strict?this.reservedWordsStrict:this.reservedWords).test(s)&&(this.inAsync||"await"!==s||this.raiseRecoverable(e,"Cannot use keyword 'await' outside an async function"),this.raiseRecoverable(e,"The keyword '"+s+"' is reserved"))},Tt.parseIdent=function(t,e){var i=this.startNode();return this.type===tt.name?i.name=this.value:this.type.keyword?(i.name=this.type.keyword,"class"!==i.name&&"function"!==i.name||this.lastTokEnd===this.lastTokStart+1&&46===this.input.charCodeAt(this.lastTokStart)||this.context.pop()):this.unexpected(),this.next(!!t),this.finishNode(i,"Identifier"),t||(this.checkUnreserved(i),"await"!==i.name||this.awaitIdentPos||(this.awaitIdentPos=i.start)),i},Tt.parseYield=function(t){this.yieldPos||(this.yieldPos=this.start);var e=this.startNode();return this.next(),this.type===tt.semi||this.canInsertSemicolon()||this.type!==tt.star&&!this.type.startsExpr?(e.delegate=!1,e.argument=null):(e.delegate=this.eat(tt.star),e.argument=this.parseMaybeAssign(t)),this.finishNode(e,"YieldExpression")},Tt.parseAwait=function(){this.awaitPos||(this.awaitPos=this.start);var t=this.startNode();return this.next(),t.argument=this.parseMaybeUnary(null,!0),this.finishNode(t,"AwaitExpression")};var Vt=kt.prototype;Vt.raise=function(t,e){var i=ft(this.input,t);e+=" ("+i.line+":"+i.column+")";var s=new SyntaxError(e);throw s.pos=t,s.loc=i,s.raisedAt=this.pos,s},Vt.raiseRecoverable=Vt.raise,Vt.curPosition=function(){if(this.options.locations)return new ut(this.curLine,this.pos-this.lineStart)};var Rt=kt.prototype,Ot=function(t){this.flags=t,this.var=[],this.lexical=[],this.functions=[]};Rt.enterScope=function(t){this.scopeStack.push(new Ot(t))},Rt.exitScope=function(){this.scopeStack.pop()},Rt.treatFunctionsAsVarInScope=function(t){return 2&t.flags||!this.inModule&&1&t.flags},Rt.declareName=function(t,e,i){var s=!1;if(2===e){var r=this.currentScope();s=r.lexical.indexOf(t)>-1||r.functions.indexOf(t)>-1||r.var.indexOf(t)>-1,r.lexical.push(t),this.inModule&&1&r.flags&&delete this.undefinedExports[t]}else if(4===e){this.currentScope().lexical.push(t)}else if(3===e){var n=this.currentScope();s=this.treatFunctionsAsVar?n.lexical.indexOf(t)>-1:n.lexical.indexOf(t)>-1||n.var.indexOf(t)>-1,n.functions.push(t)}else for(var a=this.scopeStack.length-1;a>=0;--a){var o=this.scopeStack[a];if(o.lexical.indexOf(t)>-1&&!(32&o.flags&&o.lexical[0]===t)||!this.treatFunctionsAsVarInScope(o)&&o.functions.indexOf(t)>-1){s=!0;break}if(o.var.push(t),this.inModule&&1&o.flags&&delete this.undefinedExports[t],3&o.flags)break}s&&this.raiseRecoverable(i,"Identifier '"+t+"' has already been declared")},Rt.checkLocalExport=function(t){-1===this.scopeStack[0].lexical.indexOf(t.name)&&-1===this.scopeStack[0].var.indexOf(t.name)&&(this.undefinedExports[t.name]=t)},Rt.currentScope=function(){return this.scopeStack[this.scopeStack.length-1]},Rt.currentVarScope=function(){for(var t=this.scopeStack.length-1;;t--){var e=this.scopeStack[t];if(3&e.flags)return e}},Rt.currentThisScope=function(){for(var t=this.scopeStack.length-1;;t--){var e=this.scopeStack[t];if(3&e.flags&&!(16&e.flags))return e}};var Mt=function(t,e,i){this.type="",this.start=e,this.end=0,t.options.locations&&(this.loc=new dt(t,i)),t.options.directSourceFile&&(this.sourceFile=t.options.directSourceFile),t.options.ranges&&(this.range=[e,0])},Dt=kt.prototype;function Bt(t,e,i,s){return t.type=e,t.end=i,this.options.locations&&(t.loc.end=s),this.options.ranges&&(t.range[1]=i),t}Dt.startNode=function(){return new Mt(this,this.start,this.startLoc)},Dt.startNodeAt=function(t,e){return new Mt(this,t,e)},Dt.finishNode=function(t,e){return Bt.call(this,t,e,this.lastTokEnd,this.lastTokEndLoc)},Dt.finishNodeAt=function(t,e,i,s){return Bt.call(this,t,e,i,s)},Dt.copyNode=function(t){var e=new Mt(this,t.start,this.startLoc);for(var i in t)e[i]=t[i];return e};var Ft=function(t,e,i,s,r){this.token=t,this.isExpr=!!e,this.preserveSpace=!!i,this.override=s,this.generator=!!r},Ut={b_stat:new Ft("{",!1),b_expr:new Ft("{",!0),b_tmpl:new Ft("${",!1),p_stat:new Ft("(",!1),p_expr:new Ft("(",!0),q_tmpl:new Ft("`",!0,!0,(function(t){return t.tryReadTemplateToken()})),f_stat:new Ft("function",!1),f_expr:new Ft("function",!0),f_expr_gen:new Ft("function",!0,!1,null,!0),f_gen:new Ft("function",!1,!1,null,!0)},jt=kt.prototype;jt.initialContext=function(){return[Ut.b_stat]},jt.braceIsBlock=function(t){var e=this.curContext();return e===Ut.f_expr||e===Ut.f_stat||(t!==tt.colon||e!==Ut.b_stat&&e!==Ut.b_expr?t===tt._return||t===tt.name&&this.exprAllowed?et.test(this.input.slice(this.lastTokEnd,this.start)):t===tt._else||t===tt.semi||t===tt.eof||t===tt.parenR||t===tt.arrow||(t===tt.braceL?e===Ut.b_stat:t!==tt._var&&t!==tt._const&&t!==tt.name&&!this.exprAllowed):!e.isExpr)},jt.inGeneratorContext=function(){for(var t=this.context.length-1;t>=1;t--){var e=this.context[t];if("function"===e.token)return e.generator}return!1},jt.updateContext=function(t){var e,i=this.type;i.keyword&&t===tt.dot?this.exprAllowed=!1:(e=i.updateContext)?e.call(this,t):this.exprAllowed=i.beforeExpr},tt.parenR.updateContext=tt.braceR.updateContext=function(){if(1!==this.context.length){var t=this.context.pop();t===Ut.b_stat&&"function"===this.curContext().token&&(t=this.context.pop()),this.exprAllowed=!t.isExpr}else this.exprAllowed=!0},tt.braceL.updateContext=function(t){this.context.push(this.braceIsBlock(t)?Ut.b_stat:Ut.b_expr),this.exprAllowed=!0},tt.dollarBraceL.updateContext=function(){this.context.push(Ut.b_tmpl),this.exprAllowed=!0},tt.parenL.updateContext=function(t){var e=t===tt._if||t===tt._for||t===tt._with||t===tt._while;this.context.push(e?Ut.p_stat:Ut.p_expr),this.exprAllowed=!0},tt.incDec.updateContext=function(){},tt._function.updateContext=tt._class.updateContext=function(t){!t.beforeExpr||t===tt._else||t===tt.semi&&this.curContext()!==Ut.p_stat||t===tt._return&&et.test(this.input.slice(this.lastTokEnd,this.start))||(t===tt.colon||t===tt.braceL)&&this.curContext()===Ut.b_stat?this.context.push(Ut.f_stat):this.context.push(Ut.f_expr),this.exprAllowed=!1},tt.backQuote.updateContext=function(){this.curContext()===Ut.q_tmpl?this.context.pop():this.context.push(Ut.q_tmpl),this.exprAllowed=!1},tt.star.updateContext=function(t){if(t===tt._function){var e=this.context.length-1;this.context[e]===Ut.f_expr?this.context[e]=Ut.f_expr_gen:this.context[e]=Ut.f_gen}this.exprAllowed=!0},tt.name.updateContext=function(t){var e=!1;this.options.ecmaVersion>=6&&t!==tt.dot&&("of"===this.value&&!this.exprAllowed||"yield"===this.value&&this.inGeneratorContext())&&(e=!0),this.exprAllowed=e};var Wt="ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS",qt=Wt+" Extended_Pictographic",Ht={9:Wt,10:qt,11:qt,12:"ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS Extended_Pictographic EBase EComp EMod EPres ExtPict"},zt="Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu",Gt="Adlam Adlm Ahom Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb",Kt=Gt+" Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd",Qt=Kt+" Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho",Xt={9:Gt,10:Kt,11:Qt,12:"Adlam Adlm Ahom Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho Chorasmian Chrs Diak Dives_Akuru Khitan_Small_Script Kits Yezi Yezidi"},Yt={};function $t(t){var e=Yt[t]={binary:lt(Ht[t]+" "+zt),nonBinary:{General_Category:lt(zt),Script:lt(Xt[t])}};e.nonBinary.Script_Extensions=e.nonBinary.Script,e.nonBinary.gc=e.nonBinary.General_Category,e.nonBinary.sc=e.nonBinary.Script,e.nonBinary.scx=e.nonBinary.Script_Extensions}$t(9),$t(10),$t(11),$t(12);var Jt=kt.prototype,Zt=function(t){this.parser=t,this.validFlags="gim"+(t.options.ecmaVersion>=6?"uy":"")+(t.options.ecmaVersion>=9?"s":""),this.unicodeProperties=Yt[t.options.ecmaVersion>=12?12:t.options.ecmaVersion],this.source="",this.flags="",this.start=0,this.switchU=!1,this.switchN=!1,this.pos=0,this.lastIntValue=0,this.lastStringValue="",this.lastAssertionIsQuantifiable=!1,this.numCapturingParens=0,this.maxBackReference=0,this.groupNames=[],this.backReferenceNames=[]};function te(t){return t<=65535?String.fromCharCode(t):(t-=65536,String.fromCharCode(55296+(t>>10),56320+(1023&t)))}function ee(t){return 36===t||t>=40&&t<=43||46===t||63===t||t>=91&&t<=94||t>=123&&t<=125}function ie(t){return t>=65&&t<=90||t>=97&&t<=122}function se(t){return ie(t)||95===t}function re(t){return se(t)||ne(t)}function ne(t){return t>=48&&t<=57}function ae(t){return t>=48&&t<=57||t>=65&&t<=70||t>=97&&t<=102}function oe(t){return t>=65&&t<=70?t-65+10:t>=97&&t<=102?t-97+10:t-48}function he(t){return t>=48&&t<=55}Zt.prototype.reset=function(t,e,i){var s=-1!==i.indexOf("u");this.start=0|t,this.source=e+"",this.flags=i,this.switchU=s&&this.parser.options.ecmaVersion>=6,this.switchN=s&&this.parser.options.ecmaVersion>=9},Zt.prototype.raise=function(t){this.parser.raiseRecoverable(this.start,"Invalid regular expression: /"+this.source+"/: "+t)},Zt.prototype.at=function(t,e){void 0===e&&(e=!1);var i=this.source,s=i.length;if(t>=s)return-1;var r=i.charCodeAt(t);if(!e&&!this.switchU||r<=55295||r>=57344||t+1>=s)return r;var n=i.charCodeAt(t+1);return n>=56320&&n<=57343?(r<<10)+n-56613888:r},Zt.prototype.nextIndex=function(t,e){void 0===e&&(e=!1);var i=this.source,s=i.length;if(t>=s)return s;var r,n=i.charCodeAt(t);return!e&&!this.switchU||n<=55295||n>=57344||t+1>=s||(r=i.charCodeAt(t+1))<56320||r>57343?t+1:t+2},Zt.prototype.current=function(t){return void 0===t&&(t=!1),this.at(this.pos,t)},Zt.prototype.lookahead=function(t){return void 0===t&&(t=!1),this.at(this.nextIndex(this.pos,t),t)},Zt.prototype.advance=function(t){void 0===t&&(t=!1),this.pos=this.nextIndex(this.pos,t)},Zt.prototype.eat=function(t,e){return void 0===e&&(e=!1),this.current(e)===t&&(this.advance(e),!0)},Jt.validateRegExpFlags=function(t){for(var e=t.validFlags,i=t.flags,s=0;s<i.length;s++){var r=i.charAt(s);-1===e.indexOf(r)&&this.raise(t.start,"Invalid regular expression flag"),i.indexOf(r,s+1)>-1&&this.raise(t.start,"Duplicate regular expression flag")}},Jt.validateRegExpPattern=function(t){this.regexp_pattern(t),!t.switchN&&this.options.ecmaVersion>=9&&t.groupNames.length>0&&(t.switchN=!0,this.regexp_pattern(t))},Jt.regexp_pattern=function(t){t.pos=0,t.lastIntValue=0,t.lastStringValue="",t.lastAssertionIsQuantifiable=!1,t.numCapturingParens=0,t.maxBackReference=0,t.groupNames.length=0,t.backReferenceNames.length=0,this.regexp_disjunction(t),t.pos!==t.source.length&&(t.eat(41)&&t.raise("Unmatched ')'"),(t.eat(93)||t.eat(125))&&t.raise("Lone quantifier brackets")),t.maxBackReference>t.numCapturingParens&&t.raise("Invalid escape");for(var e=0,i=t.backReferenceNames;e<i.length;e+=1){var s=i[e];-1===t.groupNames.indexOf(s)&&t.raise("Invalid named capture referenced")}},Jt.regexp_disjunction=function(t){for(this.regexp_alternative(t);t.eat(124);)this.regexp_alternative(t);this.regexp_eatQuantifier(t,!0)&&t.raise("Nothing to repeat"),t.eat(123)&&t.raise("Lone quantifier brackets")},Jt.regexp_alternative=function(t){for(;t.pos<t.source.length&&this.regexp_eatTerm(t););},Jt.regexp_eatTerm=function(t){return this.regexp_eatAssertion(t)?(t.lastAssertionIsQuantifiable&&this.regexp_eatQuantifier(t)&&t.switchU&&t.raise("Invalid quantifier"),!0):!!(t.switchU?this.regexp_eatAtom(t):this.regexp_eatExtendedAtom(t))&&(this.regexp_eatQuantifier(t),!0)},Jt.regexp_eatAssertion=function(t){var e=t.pos;if(t.lastAssertionIsQuantifiable=!1,t.eat(94)||t.eat(36))return!0;if(t.eat(92)){if(t.eat(66)||t.eat(98))return!0;t.pos=e}if(t.eat(40)&&t.eat(63)){var i=!1;if(this.options.ecmaVersion>=9&&(i=t.eat(60)),t.eat(61)||t.eat(33))return this.regexp_disjunction(t),t.eat(41)||t.raise("Unterminated group"),t.lastAssertionIsQuantifiable=!i,!0}return t.pos=e,!1},Jt.regexp_eatQuantifier=function(t,e){return void 0===e&&(e=!1),!!this.regexp_eatQuantifierPrefix(t,e)&&(t.eat(63),!0)},Jt.regexp_eatQuantifierPrefix=function(t,e){return t.eat(42)||t.eat(43)||t.eat(63)||this.regexp_eatBracedQuantifier(t,e)},Jt.regexp_eatBracedQuantifier=function(t,e){var i=t.pos;if(t.eat(123)){var s=0,r=-1;if(this.regexp_eatDecimalDigits(t)&&(s=t.lastIntValue,t.eat(44)&&this.regexp_eatDecimalDigits(t)&&(r=t.lastIntValue),t.eat(125)))return-1!==r&&r<s&&!e&&t.raise("numbers out of order in {} quantifier"),!0;t.switchU&&!e&&t.raise("Incomplete quantifier"),t.pos=i}return!1},Jt.regexp_eatAtom=function(t){return this.regexp_eatPatternCharacters(t)||t.eat(46)||this.regexp_eatReverseSolidusAtomEscape(t)||this.regexp_eatCharacterClass(t)||this.regexp_eatUncapturingGroup(t)||this.regexp_eatCapturingGroup(t)},Jt.regexp_eatReverseSolidusAtomEscape=function(t){var e=t.pos;if(t.eat(92)){if(this.regexp_eatAtomEscape(t))return!0;t.pos=e}return!1},Jt.regexp_eatUncapturingGroup=function(t){var e=t.pos;if(t.eat(40)){if(t.eat(63)&&t.eat(58)){if(this.regexp_disjunction(t),t.eat(41))return!0;t.raise("Unterminated group")}t.pos=e}return!1},Jt.regexp_eatCapturingGroup=function(t){if(t.eat(40)){if(this.options.ecmaVersion>=9?this.regexp_groupSpecifier(t):63===t.current()&&t.raise("Invalid group"),this.regexp_disjunction(t),t.eat(41))return t.numCapturingParens+=1,!0;t.raise("Unterminated group")}return!1},Jt.regexp_eatExtendedAtom=function(t){return t.eat(46)||this.regexp_eatReverseSolidusAtomEscape(t)||this.regexp_eatCharacterClass(t)||this.regexp_eatUncapturingGroup(t)||this.regexp_eatCapturingGroup(t)||this.regexp_eatInvalidBracedQuantifier(t)||this.regexp_eatExtendedPatternCharacter(t)},Jt.regexp_eatInvalidBracedQuantifier=function(t){return this.regexp_eatBracedQuantifier(t,!0)&&t.raise("Nothing to repeat"),!1},Jt.regexp_eatSyntaxCharacter=function(t){var e=t.current();return!!ee(e)&&(t.lastIntValue=e,t.advance(),!0)},Jt.regexp_eatPatternCharacters=function(t){for(var e=t.pos,i=0;-1!==(i=t.current())&&!ee(i);)t.advance();return t.pos!==e},Jt.regexp_eatExtendedPatternCharacter=function(t){var e=t.current();return!(-1===e||36===e||e>=40&&e<=43||46===e||63===e||91===e||94===e||124===e)&&(t.advance(),!0)},Jt.regexp_groupSpecifier=function(t){if(t.eat(63)){if(this.regexp_eatGroupName(t))return-1!==t.groupNames.indexOf(t.lastStringValue)&&t.raise("Duplicate capture group name"),void t.groupNames.push(t.lastStringValue);t.raise("Invalid group")}},Jt.regexp_eatGroupName=function(t){if(t.lastStringValue="",t.eat(60)){if(this.regexp_eatRegExpIdentifierName(t)&&t.eat(62))return!0;t.raise("Invalid capture group name")}return!1},Jt.regexp_eatRegExpIdentifierName=function(t){if(t.lastStringValue="",this.regexp_eatRegExpIdentifierStart(t)){for(t.lastStringValue+=te(t.lastIntValue);this.regexp_eatRegExpIdentifierPart(t);)t.lastStringValue+=te(t.lastIntValue);return!0}return!1},Jt.regexp_eatRegExpIdentifierStart=function(t){var e=t.pos,i=this.options.ecmaVersion>=11,s=t.current(i);return t.advance(i),92===s&&this.regexp_eatRegExpUnicodeEscapeSequence(t,i)&&(s=t.lastIntValue),function(t){return G(t,!0)||36===t||95===t}(s)?(t.lastIntValue=s,!0):(t.pos=e,!1)},Jt.regexp_eatRegExpIdentifierPart=function(t){var e=t.pos,i=this.options.ecmaVersion>=11,s=t.current(i);return t.advance(i),92===s&&this.regexp_eatRegExpUnicodeEscapeSequence(t,i)&&(s=t.lastIntValue),function(t){return K(t,!0)||36===t||95===t||8204===t||8205===t}(s)?(t.lastIntValue=s,!0):(t.pos=e,!1)},Jt.regexp_eatAtomEscape=function(t){return!!(this.regexp_eatBackReference(t)||this.regexp_eatCharacterClassEscape(t)||this.regexp_eatCharacterEscape(t)||t.switchN&&this.regexp_eatKGroupName(t))||(t.switchU&&(99===t.current()&&t.raise("Invalid unicode escape"),t.raise("Invalid escape")),!1)},Jt.regexp_eatBackReference=function(t){var e=t.pos;if(this.regexp_eatDecimalEscape(t)){var i=t.lastIntValue;if(t.switchU)return i>t.maxBackReference&&(t.maxBackReference=i),!0;if(i<=t.numCapturingParens)return!0;t.pos=e}return!1},Jt.regexp_eatKGroupName=function(t){if(t.eat(107)){if(this.regexp_eatGroupName(t))return t.backReferenceNames.push(t.lastStringValue),!0;t.raise("Invalid named reference")}return!1},Jt.regexp_eatCharacterEscape=function(t){return this.regexp_eatControlEscape(t)||this.regexp_eatCControlLetter(t)||this.regexp_eatZero(t)||this.regexp_eatHexEscapeSequence(t)||this.regexp_eatRegExpUnicodeEscapeSequence(t,!1)||!t.switchU&&this.regexp_eatLegacyOctalEscapeSequence(t)||this.regexp_eatIdentityEscape(t)},Jt.regexp_eatCControlLetter=function(t){var e=t.pos;if(t.eat(99)){if(this.regexp_eatControlLetter(t))return!0;t.pos=e}return!1},Jt.regexp_eatZero=function(t){return 48===t.current()&&!ne(t.lookahead())&&(t.lastIntValue=0,t.advance(),!0)},Jt.regexp_eatControlEscape=function(t){var e=t.current();return 116===e?(t.lastIntValue=9,t.advance(),!0):110===e?(t.lastIntValue=10,t.advance(),!0):118===e?(t.lastIntValue=11,t.advance(),!0):102===e?(t.lastIntValue=12,t.advance(),!0):114===e&&(t.lastIntValue=13,t.advance(),!0)},Jt.regexp_eatControlLetter=function(t){var e=t.current();return!!ie(e)&&(t.lastIntValue=e%32,t.advance(),!0)},Jt.regexp_eatRegExpUnicodeEscapeSequence=function(t,e){void 0===e&&(e=!1);var i,s=t.pos,r=e||t.switchU;if(t.eat(117)){if(this.regexp_eatFixedHexDigits(t,4)){var n=t.lastIntValue;if(r&&n>=55296&&n<=56319){var a=t.pos;if(t.eat(92)&&t.eat(117)&&this.regexp_eatFixedHexDigits(t,4)){var o=t.lastIntValue;if(o>=56320&&o<=57343)return t.lastIntValue=1024*(n-55296)+(o-56320)+65536,!0}t.pos=a,t.lastIntValue=n}return!0}if(r&&t.eat(123)&&this.regexp_eatHexDigits(t)&&t.eat(125)&&((i=t.lastIntValue)>=0&&i<=1114111))return!0;r&&t.raise("Invalid unicode escape"),t.pos=s}return!1},Jt.regexp_eatIdentityEscape=function(t){if(t.switchU)return!!this.regexp_eatSyntaxCharacter(t)||!!t.eat(47)&&(t.lastIntValue=47,!0);var e=t.current();return!(99===e||t.switchN&&107===e)&&(t.lastIntValue=e,t.advance(),!0)},Jt.regexp_eatDecimalEscape=function(t){t.lastIntValue=0;var e=t.current();if(e>=49&&e<=57){do{t.lastIntValue=10*t.lastIntValue+(e-48),t.advance()}while((e=t.current())>=48&&e<=57);return!0}return!1},Jt.regexp_eatCharacterClassEscape=function(t){var e=t.current();if(function(t){return 100===t||68===t||115===t||83===t||119===t||87===t}(e))return t.lastIntValue=-1,t.advance(),!0;if(t.switchU&&this.options.ecmaVersion>=9&&(80===e||112===e)){if(t.lastIntValue=-1,t.advance(),t.eat(123)&&this.regexp_eatUnicodePropertyValueExpression(t)&&t.eat(125))return!0;t.raise("Invalid property name")}return!1},Jt.regexp_eatUnicodePropertyValueExpression=function(t){var e=t.pos;if(this.regexp_eatUnicodePropertyName(t)&&t.eat(61)){var i=t.lastStringValue;if(this.regexp_eatUnicodePropertyValue(t)){var s=t.lastStringValue;return this.regexp_validateUnicodePropertyNameAndValue(t,i,s),!0}}if(t.pos=e,this.regexp_eatLoneUnicodePropertyNameOrValue(t)){var r=t.lastStringValue;return this.regexp_validateUnicodePropertyNameOrValue(t,r),!0}return!1},Jt.regexp_validateUnicodePropertyNameAndValue=function(t,e,i){pt(t.unicodeProperties.nonBinary,e)||t.raise("Invalid property name"),t.unicodeProperties.nonBinary[e].test(i)||t.raise("Invalid property value")},Jt.regexp_validateUnicodePropertyNameOrValue=function(t,e){t.unicodeProperties.binary.test(e)||t.raise("Invalid property name")},Jt.regexp_eatUnicodePropertyName=function(t){var e=0;for(t.lastStringValue="";se(e=t.current());)t.lastStringValue+=te(e),t.advance();return""!==t.lastStringValue},Jt.regexp_eatUnicodePropertyValue=function(t){var e=0;for(t.lastStringValue="";re(e=t.current());)t.lastStringValue+=te(e),t.advance();return""!==t.lastStringValue},Jt.regexp_eatLoneUnicodePropertyNameOrValue=function(t){return this.regexp_eatUnicodePropertyValue(t)},Jt.regexp_eatCharacterClass=function(t){if(t.eat(91)){if(t.eat(94),this.regexp_classRanges(t),t.eat(93))return!0;t.raise("Unterminated character class")}return!1},Jt.regexp_classRanges=function(t){for(;this.regexp_eatClassAtom(t);){var e=t.lastIntValue;if(t.eat(45)&&this.regexp_eatClassAtom(t)){var i=t.lastIntValue;!t.switchU||-1!==e&&-1!==i||t.raise("Invalid character class"),-1!==e&&-1!==i&&e>i&&t.raise("Range out of order in character class")}}},Jt.regexp_eatClassAtom=function(t){var e=t.pos;if(t.eat(92)){if(this.regexp_eatClassEscape(t))return!0;if(t.switchU){var i=t.current();(99===i||he(i))&&t.raise("Invalid class escape"),t.raise("Invalid escape")}t.pos=e}var s=t.current();return 93!==s&&(t.lastIntValue=s,t.advance(),!0)},Jt.regexp_eatClassEscape=function(t){var e=t.pos;if(t.eat(98))return t.lastIntValue=8,!0;if(t.switchU&&t.eat(45))return t.lastIntValue=45,!0;if(!t.switchU&&t.eat(99)){if(this.regexp_eatClassControlLetter(t))return!0;t.pos=e}return this.regexp_eatCharacterClassEscape(t)||this.regexp_eatCharacterEscape(t)},Jt.regexp_eatClassControlLetter=function(t){var e=t.current();return!(!ne(e)&&95!==e)&&(t.lastIntValue=e%32,t.advance(),!0)},Jt.regexp_eatHexEscapeSequence=function(t){var e=t.pos;if(t.eat(120)){if(this.regexp_eatFixedHexDigits(t,2))return!0;t.switchU&&t.raise("Invalid escape"),t.pos=e}return!1},Jt.regexp_eatDecimalDigits=function(t){var e=t.pos,i=0;for(t.lastIntValue=0;ne(i=t.current());)t.lastIntValue=10*t.lastIntValue+(i-48),t.advance();return t.pos!==e},Jt.regexp_eatHexDigits=function(t){var e=t.pos,i=0;for(t.lastIntValue=0;ae(i=t.current());)t.lastIntValue=16*t.lastIntValue+oe(i),t.advance();return t.pos!==e},Jt.regexp_eatLegacyOctalEscapeSequence=function(t){if(this.regexp_eatOctalDigit(t)){var e=t.lastIntValue;if(this.regexp_eatOctalDigit(t)){var i=t.lastIntValue;e<=3&&this.regexp_eatOctalDigit(t)?t.lastIntValue=64*e+8*i+t.lastIntValue:t.lastIntValue=8*e+i}else t.lastIntValue=e;return!0}return!1},Jt.regexp_eatOctalDigit=function(t){var e=t.current();return he(e)?(t.lastIntValue=e-48,t.advance(),!0):(t.lastIntValue=0,!1)},Jt.regexp_eatFixedHexDigits=function(t,e){var i=t.pos;t.lastIntValue=0;for(var s=0;s<e;++s){var r=t.current();if(!ae(r))return t.pos=i,!1;t.lastIntValue=16*t.lastIntValue+oe(r),t.advance()}return!0};var pe=function(t){this.type=t.type,this.value=t.value,this.start=t.start,this.end=t.end,t.options.locations&&(this.loc=new dt(t,t.startLoc,t.endLoc)),t.options.ranges&&(this.range=[t.start,t.end])},ce=kt.prototype;function le(t){return"function"!=typeof BigInt?null:BigInt(t.replace(/_/g,""))}function ue(t){return t<=65535?String.fromCharCode(t):(t-=65536,String.fromCharCode(55296+(t>>10),56320+(1023&t)))}ce.next=function(t){!t&&this.type.keyword&&this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword "+this.type.keyword),this.options.onToken&&this.options.onToken(new pe(this)),this.lastTokEnd=this.end,this.lastTokStart=this.start,this.lastTokEndLoc=this.endLoc,this.lastTokStartLoc=this.startLoc,this.nextToken()},ce.getToken=function(){return this.next(),new pe(this)},"undefined"!=typeof Symbol&&(ce[Symbol.iterator]=function(){var t=this;return{next:function(){var e=t.getToken();return{done:e.type===tt.eof,value:e}}}}),ce.curContext=function(){return this.context[this.context.length-1]},ce.nextToken=function(){var t=this.curContext();return t&&t.preserveSpace||this.skipSpace(),this.start=this.pos,this.options.locations&&(this.startLoc=this.curPosition()),this.pos>=this.input.length?this.finishToken(tt.eof):t.override?t.override(this):void this.readToken(this.fullCharCodeAtPos())},ce.readToken=function(t){return G(t,this.options.ecmaVersion>=6)||92===t?this.readWord():this.getTokenFromCode(t)},ce.fullCharCodeAtPos=function(){var t=this.input.charCodeAt(this.pos);return t<=55295||t>=57344?t:(t<<10)+this.input.charCodeAt(this.pos+1)-56613888},ce.skipBlockComment=function(){var t,e=this.options.onComment&&this.curPosition(),i=this.pos,s=this.input.indexOf("*/",this.pos+=2);if(-1===s&&this.raise(this.pos-2,"Unterminated comment"),this.pos=s+2,this.options.locations)for(it.lastIndex=i;(t=it.exec(this.input))&&t.index<this.pos;)++this.curLine,this.lineStart=t.index+t[0].length;this.options.onComment&&this.options.onComment(!0,this.input.slice(i+2,s),i,this.pos,e,this.curPosition())},ce.skipLineComment=function(t){for(var e=this.pos,i=this.options.onComment&&this.curPosition(),s=this.input.charCodeAt(this.pos+=t);this.pos<this.input.length&&!st(s);)s=this.input.charCodeAt(++this.pos);this.options.onComment&&this.options.onComment(!1,this.input.slice(e+t,this.pos),e,this.pos,i,this.curPosition())},ce.skipSpace=function(){t:for(;this.pos<this.input.length;){var t=this.input.charCodeAt(this.pos);switch(t){case 32:case 160:++this.pos;break;case 13:10===this.input.charCodeAt(this.pos+1)&&++this.pos;case 10:case 8232:case 8233:++this.pos,this.options.locations&&(++this.curLine,this.lineStart=this.pos);break;case 47:switch(this.input.charCodeAt(this.pos+1)){case 42:this.skipBlockComment();break;case 47:this.skipLineComment(2);break;default:break t}break;default:if(!(t>8&&t<14||t>=5760&&rt.test(String.fromCharCode(t))))break t;++this.pos}}},ce.finishToken=function(t,e){this.end=this.pos,this.options.locations&&(this.endLoc=this.curPosition());var i=this.type;this.type=t,this.value=e,this.updateContext(i)},ce.readToken_dot=function(){var t=this.input.charCodeAt(this.pos+1);if(t>=48&&t<=57)return this.readNumber(!0);var e=this.input.charCodeAt(this.pos+2);return this.options.ecmaVersion>=6&&46===t&&46===e?(this.pos+=3,this.finishToken(tt.ellipsis)):(++this.pos,this.finishToken(tt.dot))},ce.readToken_slash=function(){var t=this.input.charCodeAt(this.pos+1);return this.exprAllowed?(++this.pos,this.readRegexp()):61===t?this.finishOp(tt.assign,2):this.finishOp(tt.slash,1)},ce.readToken_mult_modulo_exp=function(t){var e=this.input.charCodeAt(this.pos+1),i=1,s=42===t?tt.star:tt.modulo;return this.options.ecmaVersion>=7&&42===t&&42===e&&(++i,s=tt.starstar,e=this.input.charCodeAt(this.pos+2)),61===e?this.finishOp(tt.assign,i+1):this.finishOp(s,i)},ce.readToken_pipe_amp=function(t){var e=this.input.charCodeAt(this.pos+1);if(e===t){if(this.options.ecmaVersion>=12)if(61===this.input.charCodeAt(this.pos+2))return this.finishOp(tt.assign,3);return this.finishOp(124===t?tt.logicalOR:tt.logicalAND,2)}return 61===e?this.finishOp(tt.assign,2):this.finishOp(124===t?tt.bitwiseOR:tt.bitwiseAND,1)},ce.readToken_caret=function(){return 61===this.input.charCodeAt(this.pos+1)?this.finishOp(tt.assign,2):this.finishOp(tt.bitwiseXOR,1)},ce.readToken_plus_min=function(t){var e=this.input.charCodeAt(this.pos+1);return e===t?45!==e||this.inModule||62!==this.input.charCodeAt(this.pos+2)||0!==this.lastTokEnd&&!et.test(this.input.slice(this.lastTokEnd,this.pos))?this.finishOp(tt.incDec,2):(this.skipLineComment(3),this.skipSpace(),this.nextToken()):61===e?this.finishOp(tt.assign,2):this.finishOp(tt.plusMin,1)},ce.readToken_lt_gt=function(t){var e=this.input.charCodeAt(this.pos+1),i=1;return e===t?(i=62===t&&62===this.input.charCodeAt(this.pos+2)?3:2,61===this.input.charCodeAt(this.pos+i)?this.finishOp(tt.assign,i+1):this.finishOp(tt.bitShift,i)):33!==e||60!==t||this.inModule||45!==this.input.charCodeAt(this.pos+2)||45!==this.input.charCodeAt(this.pos+3)?(61===e&&(i=2),this.finishOp(tt.relational,i)):(this.skipLineComment(4),this.skipSpace(),this.nextToken())},ce.readToken_eq_excl=function(t){var e=this.input.charCodeAt(this.pos+1);return 61===e?this.finishOp(tt.equality,61===this.input.charCodeAt(this.pos+2)?3:2):61===t&&62===e&&this.options.ecmaVersion>=6?(this.pos+=2,this.finishToken(tt.arrow)):this.finishOp(61===t?tt.eq:tt.prefix,1)},ce.readToken_question=function(){var t=this.options.ecmaVersion;if(t>=11){var e=this.input.charCodeAt(this.pos+1);if(46===e){var i=this.input.charCodeAt(this.pos+2);if(i<48||i>57)return this.finishOp(tt.questionDot,2)}if(63===e){if(t>=12)if(61===this.input.charCodeAt(this.pos+2))return this.finishOp(tt.assign,3);return this.finishOp(tt.coalesce,2)}}return this.finishOp(tt.question,1)},ce.getTokenFromCode=function(t){switch(t){case 46:return this.readToken_dot();case 40:return++this.pos,this.finishToken(tt.parenL);case 41:return++this.pos,this.finishToken(tt.parenR);case 59:return++this.pos,this.finishToken(tt.semi);case 44:return++this.pos,this.finishToken(tt.comma);case 91:return++this.pos,this.finishToken(tt.bracketL);case 93:return++this.pos,this.finishToken(tt.bracketR);case 123:return++this.pos,this.finishToken(tt.braceL);case 125:return++this.pos,this.finishToken(tt.braceR);case 58:return++this.pos,this.finishToken(tt.colon);case 96:if(this.options.ecmaVersion<6)break;return++this.pos,this.finishToken(tt.backQuote);case 48:var e=this.input.charCodeAt(this.pos+1);if(120===e||88===e)return this.readRadixNumber(16);if(this.options.ecmaVersion>=6){if(111===e||79===e)return this.readRadixNumber(8);if(98===e||66===e)return this.readRadixNumber(2)}case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return this.readNumber(!1);case 34:case 39:return this.readString(t);case 47:return this.readToken_slash();case 37:case 42:return this.readToken_mult_modulo_exp(t);case 124:case 38:return this.readToken_pipe_amp(t);case 94:return this.readToken_caret();case 43:case 45:return this.readToken_plus_min(t);case 60:case 62:return this.readToken_lt_gt(t);case 61:case 33:return this.readToken_eq_excl(t);case 63:return this.readToken_question();case 126:return this.finishOp(tt.prefix,1)}this.raise(this.pos,"Unexpected character '"+ue(t)+"'")},ce.finishOp=function(t,e){var i=this.input.slice(this.pos,this.pos+e);return this.pos+=e,this.finishToken(t,i)},ce.readRegexp=function(){for(var t,e,i=this.pos;;){this.pos>=this.input.length&&this.raise(i,"Unterminated regular expression");var s=this.input.charAt(this.pos);if(et.test(s)&&this.raise(i,"Unterminated regular expression"),t)t=!1;else{if("["===s)e=!0;else if("]"===s&&e)e=!1;else if("/"===s&&!e)break;t="\\"===s}++this.pos}var r=this.input.slice(i,this.pos);++this.pos;var n=this.pos,a=this.readWord1();this.containsEsc&&this.unexpected(n);var o=this.regexpState||(this.regexpState=new Zt(this));o.reset(i,r,a),this.validateRegExpFlags(o),this.validateRegExpPattern(o);var h=null;try{h=new RegExp(r,a)}catch(t){}return this.finishToken(tt.regexp,{pattern:r,flags:a,value:h})},ce.readInt=function(t,e,i){for(var s=this.options.ecmaVersion>=12&&void 0===e,r=i&&48===this.input.charCodeAt(this.pos),n=this.pos,a=0,o=0,h=0,p=null==e?1/0:e;h<p;++h,++this.pos){var c=this.input.charCodeAt(this.pos),l=void 0;if(s&&95===c)r&&this.raiseRecoverable(this.pos,"Numeric separator is not allowed in legacy octal numeric literals"),95===o&&this.raiseRecoverable(this.pos,"Numeric separator must be exactly one underscore"),0===h&&this.raiseRecoverable(this.pos,"Numeric separator is not allowed at the first of digits"),o=c;else{if((l=c>=97?c-97+10:c>=65?c-65+10:c>=48&&c<=57?c-48:1/0)>=t)break;o=c,a=a*t+l}}return s&&95===o&&this.raiseRecoverable(this.pos-1,"Numeric separator is not allowed at the last of digits"),this.pos===n||null!=e&&this.pos-n!==e?null:a},ce.readRadixNumber=function(t){var e=this.pos;this.pos+=2;var i=this.readInt(t);return null==i&&this.raise(this.start+2,"Expected number in radix "+t),this.options.ecmaVersion>=11&&110===this.input.charCodeAt(this.pos)?(i=le(this.input.slice(e,this.pos)),++this.pos):G(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number"),this.finishToken(tt.num,i)},ce.readNumber=function(t){var e=this.pos;t||null!==this.readInt(10,void 0,!0)||this.raise(e,"Invalid number");var i=this.pos-e>=2&&48===this.input.charCodeAt(e);i&&this.strict&&this.raise(e,"Invalid number");var s=this.input.charCodeAt(this.pos);if(!i&&!t&&this.options.ecmaVersion>=11&&110===s){var r=le(this.input.slice(e,this.pos));return++this.pos,G(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number"),this.finishToken(tt.num,r)}i&&/[89]/.test(this.input.slice(e,this.pos))&&(i=!1),46!==s||i||(++this.pos,this.readInt(10),s=this.input.charCodeAt(this.pos)),69!==s&&101!==s||i||(43!==(s=this.input.charCodeAt(++this.pos))&&45!==s||++this.pos,null===this.readInt(10)&&this.raise(e,"Invalid number")),G(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number");var n,a=(n=this.input.slice(e,this.pos),i?parseInt(n,8):parseFloat(n.replace(/_/g,"")));return this.finishToken(tt.num,a)},ce.readCodePoint=function(){var t;if(123===this.input.charCodeAt(this.pos)){this.options.ecmaVersion<6&&this.unexpected();var e=++this.pos;t=this.readHexChar(this.input.indexOf("}",this.pos)-this.pos),++this.pos,t>1114111&&this.invalidStringToken(e,"Code point out of bounds")}else t=this.readHexChar(4);return t},ce.readString=function(t){for(var e="",i=++this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated string constant");var s=this.input.charCodeAt(this.pos);if(s===t)break;92===s?(e+=this.input.slice(i,this.pos),e+=this.readEscapedChar(!1),i=this.pos):(st(s,this.options.ecmaVersion>=10)&&this.raise(this.start,"Unterminated string constant"),++this.pos)}return e+=this.input.slice(i,this.pos++),this.finishToken(tt.string,e)};var de={};ce.tryReadTemplateToken=function(){this.inTemplateElement=!0;try{this.readTmplToken()}catch(t){if(t!==de)throw t;this.readInvalidTemplateToken()}this.inTemplateElement=!1},ce.invalidStringToken=function(t,e){if(this.inTemplateElement&&this.options.ecmaVersion>=9)throw de;this.raise(t,e)},ce.readTmplToken=function(){for(var t="",e=this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated template");var i=this.input.charCodeAt(this.pos);if(96===i||36===i&&123===this.input.charCodeAt(this.pos+1))return this.pos!==this.start||this.type!==tt.template&&this.type!==tt.invalidTemplate?(t+=this.input.slice(e,this.pos),this.finishToken(tt.template,t)):36===i?(this.pos+=2,this.finishToken(tt.dollarBraceL)):(++this.pos,this.finishToken(tt.backQuote));if(92===i)t+=this.input.slice(e,this.pos),t+=this.readEscapedChar(!0),e=this.pos;else if(st(i)){switch(t+=this.input.slice(e,this.pos),++this.pos,i){case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:t+="\n";break;default:t+=String.fromCharCode(i)}this.options.locations&&(++this.curLine,this.lineStart=this.pos),e=this.pos}else++this.pos}},ce.readInvalidTemplateToken=function(){for(;this.pos<this.input.length;this.pos++)switch(this.input[this.pos]){case"\\":++this.pos;break;case"$":if("{"!==this.input[this.pos+1])break;case"`":return this.finishToken(tt.invalidTemplate,this.input.slice(this.start,this.pos))}this.raise(this.start,"Unterminated template")},ce.readEscapedChar=function(t){var e=this.input.charCodeAt(++this.pos);switch(++this.pos,e){case 110:return"\n";case 114:return"\r";case 120:return String.fromCharCode(this.readHexChar(2));case 117:return ue(this.readCodePoint());case 116:return"\t";case 98:return"\b";case 118:return"\v";case 102:return"\f";case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:return this.options.locations&&(this.lineStart=this.pos,++this.curLine),"";case 56:case 57:if(this.strict&&this.invalidStringToken(this.pos-1,"Invalid escape sequence"),t){var i=this.pos-1;return this.invalidStringToken(i,"Invalid escape sequence in template string"),null}default:if(e>=48&&e<=55){var s=this.input.substr(this.pos-1,3).match(/^[0-7]+/)[0],r=parseInt(s,8);return r>255&&(s=s.slice(0,-1),r=parseInt(s,8)),this.pos+=s.length-1,e=this.input.charCodeAt(this.pos),"0"===s&&56!==e&&57!==e||!this.strict&&!t||this.invalidStringToken(this.pos-1-s.length,t?"Octal literal in template string":"Octal literal in strict mode"),String.fromCharCode(r)}return st(e)?"":String.fromCharCode(e)}},ce.readHexChar=function(t){var e=this.pos,i=this.readInt(16,t);return null===i&&this.invalidStringToken(e,"Bad character escape sequence"),i},ce.readWord1=function(){this.containsEsc=!1;for(var t="",e=!0,i=this.pos,s=this.options.ecmaVersion>=6;this.pos<this.input.length;){var r=this.fullCharCodeAtPos();if(K(r,s))this.pos+=r<=65535?1:2;else{if(92!==r)break;this.containsEsc=!0,t+=this.input.slice(i,this.pos);var n=this.pos;117!==this.input.charCodeAt(++this.pos)&&this.invalidStringToken(this.pos,"Expecting Unicode escape sequence \\uXXXX"),++this.pos;var a=this.readCodePoint();(e?G:K)(a,s)||this.invalidStringToken(n,"Invalid Unicode escape"),t+=ue(a),i=this.pos}e=!1}return t+this.input.slice(i,this.pos)},ce.readWord=function(){var t=this.readWord1(),e=tt.name;return this.keywords.test(t)&&(e=J[t]),this.finishToken(e,t)};kt.acorn={Parser:kt,version:"8.0.4",defaultOptions:mt,Position:ut,SourceLocation:dt,getLineInfo:ft,Node:Mt,TokenType:Q,tokTypes:tt,keywordTypes:J,TokContext:Ft,tokContexts:Ut,isIdentifierChar:K,isIdentifierStart:G,Token:pe,isNewLine:st,lineBreak:et,lineBreakG:it,nonASCIIwhitespace:rt};function fe(t){return"✖"===t.name}function me(){}var ge=function(t,e){if(void 0===e&&(e={}),this.toks=this.constructor.BaseParser.tokenizer(t,e),this.options=this.toks.options,this.input=this.toks.input,this.tok=this.last={type:tt.eof,start:0,end:0},this.tok.validateRegExpFlags=me,this.tok.validateRegExpPattern=me,this.options.locations){var i=this.toks.curPosition();this.tok.loc=new dt(this.toks,i,i)}this.ahead=[],this.context=[],this.curIndent=0,this.curLineStart=0,this.nextLineStart=this.lineEnd(this.curLineStart)+1,this.inAsync=!1,this.inFunction=!1};ge.prototype.startNode=function(){return new Mt(this.toks,this.tok.start,this.options.locations?this.tok.loc.start:null)},ge.prototype.storeCurrentPos=function(){return this.options.locations?[this.tok.start,this.tok.loc.start]:this.tok.start},ge.prototype.startNodeAt=function(t){return this.options.locations?new Mt(this.toks,t[0],t[1]):new Mt(this.toks,t)},ge.prototype.finishNode=function(t,e){return t.type=e,t.end=this.last.end,this.options.locations&&(t.loc.end=this.last.loc.end),this.options.ranges&&(t.range[1]=this.last.end),t},ge.prototype.dummyNode=function(t){var e=this.startNode();return e.type=t,e.end=e.start,this.options.locations&&(e.loc.end=e.loc.start),this.options.ranges&&(e.range[1]=e.start),this.last={type:tt.name,start:e.start,end:e.start,loc:e.loc},e},ge.prototype.dummyIdent=function(){var t=this.dummyNode("Identifier");return t.name="✖",t},ge.prototype.dummyString=function(){var t=this.dummyNode("Literal");return t.value=t.raw="✖",t},ge.prototype.eat=function(t){return this.tok.type===t&&(this.next(),!0)},ge.prototype.isContextual=function(t){return this.tok.type===tt.name&&this.tok.value===t},ge.prototype.eatContextual=function(t){return this.tok.value===t&&this.eat(tt.name)},ge.prototype.canInsertSemicolon=function(){return this.tok.type===tt.eof||this.tok.type===tt.braceR||et.test(this.input.slice(this.last.end,this.tok.start))},ge.prototype.semicolon=function(){return this.eat(tt.semi)},ge.prototype.expect=function(t){if(this.eat(t))return!0;for(var e=1;e<=2;e++)if(this.lookAhead(e).type===t){for(var i=0;i<e;i++)this.next();return!0}},ge.prototype.pushCx=function(){this.context.push(this.curIndent)},ge.prototype.popCx=function(){this.curIndent=this.context.pop()},ge.prototype.lineEnd=function(t){for(;t<this.input.length&&!st(this.input.charCodeAt(t));)++t;return t},ge.prototype.indentationAfter=function(t){for(var e=0;;++t){var i=this.input.charCodeAt(t);if(32===i)++e;else{if(9!==i)return e;e+=this.options.tabSize}}},ge.prototype.closes=function(t,e,i,s){return this.tok.type===t||this.tok.type===tt.eof||i!==this.curLineStart&&this.curIndent<e&&this.tokenStartsLine()&&(!s||this.nextLineStart>=this.input.length||this.indentationAfter(this.nextLineStart)<e)},ge.prototype.tokenStartsLine=function(){for(var t=this.tok.start-1;t>=this.curLineStart;--t){var e=this.input.charCodeAt(t);if(9!==e&&32!==e)return!1}return!0},ge.prototype.extend=function(t,e){this[t]=e(this[t])},ge.prototype.parse=function(){return this.next(),this.parseTopLevel()},ge.extend=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];for(var i=this,s=0;s<t.length;s++)i=t[s](i);return i},ge.parse=function(t,e){return new this(t,e).parse()},ge.BaseParser=kt;var ye=ge.prototype;function xe(t){return t<14&&t>8||32===t||160===t||st(t)}ye.next=function(){if(this.last=this.tok,this.ahead.length?this.tok=this.ahead.shift():this.tok=this.readToken(),this.tok.start>=this.nextLineStart){for(;this.tok.start>=this.nextLineStart;)this.curLineStart=this.nextLineStart,this.nextLineStart=this.lineEnd(this.curLineStart)+1;this.curIndent=this.indentationAfter(this.curLineStart)}},ye.readToken=function(){for(;;)try{return this.toks.next(),this.toks.type===tt.dot&&"."===this.input.substr(this.toks.end,1)&&this.options.ecmaVersion>=6&&(this.toks.end++,this.toks.type=tt.ellipsis),new pe(this.toks)}catch(n){if(!(n instanceof SyntaxError))throw n;var t=n.message,e=n.raisedAt,i=!0;if(/unterminated/i.test(t))if(e=this.lineEnd(n.pos+1),/string/.test(t))i={start:n.pos,end:e,type:tt.string,value:this.input.slice(n.pos+1,e)};else if(/regular expr/i.test(t)){var s=this.input.slice(n.pos,e);try{s=new RegExp(s)}catch(t){}i={start:n.pos,end:e,type:tt.regexp,value:s}}else i=!!/template/.test(t)&&{start:n.pos,end:e,type:tt.template,value:this.input.slice(n.pos,e)};else if(/invalid (unicode|regexp|number)|expecting unicode|octal literal|is reserved|directly after number|expected number in radix/i.test(t))for(;e<this.input.length&&!xe(this.input.charCodeAt(e));)++e;else if(/character escape|expected hexadecimal/i.test(t))for(;e<this.input.length;){var r=this.input.charCodeAt(e++);if(34===r||39===r||st(r))break}else if(/unexpected character/i.test(t))e++,i=!1;else{if(!/regular expression/i.test(t))throw n;i=!0}if(this.resetTo(e),!0===i&&(i={start:e,end:e,type:tt.name,value:"✖"}),i)return this.options.locations&&(i.loc=new dt(this.toks,ft(this.input,i.start),ft(this.input,i.end))),i}},ye.resetTo=function(t){this.toks.pos=t;var e,i=this.input.charAt(t-1);if(this.toks.exprAllowed=!i||/[[{(,;:?/*=+\-~!|&%^<>]/.test(i)||/[enwfd]/.test(i)&&/\b(case|else|return|throw|new|in|(instance|type)?of|delete|void)$/.test(this.input.slice(t-10,t)),this.options.locations)for(this.toks.curLine=1,this.toks.lineStart=it.lastIndex=0;(e=it.exec(this.input))&&e.index<t;)++this.toks.curLine,this.toks.lineStart=e.index+e[0].length},ye.lookAhead=function(t){for(;t>this.ahead.length;)this.ahead.push(this.readToken());return this.ahead[t-1]};var ke=ge.prototype;ke.parseTopLevel=function(){var t=this.startNodeAt(this.options.locations?[0,ft(this.input,0)]:0);for(t.body=[];this.tok.type!==tt.eof;)t.body.push(this.parseStatement());return this.toks.adaptDirectivePrologue(t.body),this.last=this.tok,t.sourceType=this.options.sourceType,this.finishNode(t,"Program")},ke.parseStatement=function(){var t,e=this.tok.type,i=this.startNode();switch(this.toks.isLet()&&(e=tt._var,t="let"),e){case tt._break:case tt._continue:this.next();var s=e===tt._break;return this.semicolon()||this.canInsertSemicolon()?i.label=null:(i.label=this.tok.type===tt.name?this.parseIdent():null,this.semicolon()),this.finishNode(i,s?"BreakStatement":"ContinueStatement");case tt._debugger:return this.next(),this.semicolon(),this.finishNode(i,"DebuggerStatement");case tt._do:return this.next(),i.body=this.parseStatement(),i.test=this.eat(tt._while)?this.parseParenExpression():this.dummyIdent(),this.semicolon(),this.finishNode(i,"DoWhileStatement");case tt._for:this.next();var r=this.options.ecmaVersion>=9&&this.eatContextual("await");if(this.pushCx(),this.expect(tt.parenL),this.tok.type===tt.semi)return this.parseFor(i,null);var n=this.toks.isLet();if(n||this.tok.type===tt._var||this.tok.type===tt._const){var a=this.parseVar(this.startNode(),!0,n?"let":this.tok.value);return 1!==a.declarations.length||this.tok.type!==tt._in&&!this.isContextual("of")?this.parseFor(i,a):(this.options.ecmaVersion>=9&&this.tok.type!==tt._in&&(i.await=r),this.parseForIn(i,a))}var o=this.parseExpression(!0);return this.tok.type===tt._in||this.isContextual("of")?(this.options.ecmaVersion>=9&&this.tok.type!==tt._in&&(i.await=r),this.parseForIn(i,this.toAssignable(o))):this.parseFor(i,o);case tt._function:return this.next(),this.parseFunction(i,!0);case tt._if:return this.next(),i.test=this.parseParenExpression(),i.consequent=this.parseStatement(),i.alternate=this.eat(tt._else)?this.parseStatement():null,this.finishNode(i,"IfStatement");case tt._return:return this.next(),this.eat(tt.semi)||this.canInsertSemicolon()?i.argument=null:(i.argument=this.parseExpression(),this.semicolon()),this.finishNode(i,"ReturnStatement");case tt._switch:var h,p=this.curIndent,c=this.curLineStart;for(this.next(),i.discriminant=this.parseParenExpression(),i.cases=[],this.pushCx(),this.expect(tt.braceL);!this.closes(tt.braceR,p,c,!0);)if(this.tok.type===tt._case||this.tok.type===tt._default){var l=this.tok.type===tt._case;h&&this.finishNode(h,"SwitchCase"),i.cases.push(h=this.startNode()),h.consequent=[],this.next(),h.test=l?this.parseExpression():null,this.expect(tt.colon)}else h||(i.cases.push(h=this.startNode()),h.consequent=[],h.test=null),h.consequent.push(this.parseStatement());return h&&this.finishNode(h,"SwitchCase"),this.popCx(),this.eat(tt.braceR),this.finishNode(i,"SwitchStatement");case tt._throw:return this.next(),i.argument=this.parseExpression(),this.semicolon(),this.finishNode(i,"ThrowStatement");case tt._try:if(this.next(),i.block=this.parseBlock(),i.handler=null,this.tok.type===tt._catch){var u=this.startNode();this.next(),this.eat(tt.parenL)?(u.param=this.toAssignable(this.parseExprAtom(),!0),this.expect(tt.parenR)):u.param=null,u.body=this.parseBlock(),i.handler=this.finishNode(u,"CatchClause")}return i.finalizer=this.eat(tt._finally)?this.parseBlock():null,i.handler||i.finalizer?this.finishNode(i,"TryStatement"):i.block;case tt._var:case tt._const:return this.parseVar(i,!1,t||this.tok.value);case tt._while:return this.next(),i.test=this.parseParenExpression(),i.body=this.parseStatement(),this.finishNode(i,"WhileStatement");case tt._with:return this.next(),i.object=this.parseParenExpression(),i.body=this.parseStatement(),this.finishNode(i,"WithStatement");case tt.braceL:return this.parseBlock();case tt.semi:return this.next(),this.finishNode(i,"EmptyStatement");case tt._class:return this.parseClass(!0);case tt._import:if(this.options.ecmaVersion>10){var d=this.lookAhead(1).type;if(d===tt.parenL||d===tt.dot)return i.expression=this.parseExpression(),this.semicolon(),this.finishNode(i,"ExpressionStatement")}return this.parseImport();case tt._export:return this.parseExport();default:if(this.toks.isAsyncFunction())return this.next(),this.next(),this.parseFunction(i,!0,!0);var f=this.parseExpression();return fe(f)?(this.next(),this.tok.type===tt.eof?this.finishNode(i,"EmptyStatement"):this.parseStatement()):e===tt.name&&"Identifier"===f.type&&this.eat(tt.colon)?(i.body=this.parseStatement(),i.label=f,this.finishNode(i,"LabeledStatement")):(i.expression=f,this.semicolon(),this.finishNode(i,"ExpressionStatement"))}},ke.parseBlock=function(){var t=this.startNode();this.pushCx(),this.expect(tt.braceL);var e=this.curIndent,i=this.curLineStart;for(t.body=[];!this.closes(tt.braceR,e,i,!0);)t.body.push(this.parseStatement());return this.popCx(),this.eat(tt.braceR),this.finishNode(t,"BlockStatement")},ke.parseFor=function(t,e){return t.init=e,t.test=t.update=null,this.eat(tt.semi)&&this.tok.type!==tt.semi&&(t.test=this.parseExpression()),this.eat(tt.semi)&&this.tok.type!==tt.parenR&&(t.update=this.parseExpression()),this.popCx(),this.expect(tt.parenR),t.body=this.parseStatement(),this.finishNode(t,"ForStatement")},ke.parseForIn=function(t,e){var i=this.tok.type===tt._in?"ForInStatement":"ForOfStatement";return this.next(),t.left=e,t.right=this.parseExpression(),this.popCx(),this.expect(tt.parenR),t.body=this.parseStatement(),this.finishNode(t,i)},ke.parseVar=function(t,e,i){t.kind=i,this.next(),t.declarations=[];do{var s=this.startNode();s.id=this.options.ecmaVersion>=6?this.toAssignable(this.parseExprAtom(),!0):this.parseIdent(),s.init=this.eat(tt.eq)?this.parseMaybeAssign(e):null,t.declarations.push(this.finishNode(s,"VariableDeclarator"))}while(this.eat(tt.comma));if(!t.declarations.length){var r=this.startNode();r.id=this.dummyIdent(),t.declarations.push(this.finishNode(r,"VariableDeclarator"))}return e||this.semicolon(),this.finishNode(t,"VariableDeclaration")},ke.parseClass=function(t){var e=this.startNode();this.next(),this.tok.type===tt.name?e.id=this.parseIdent():e.id=!0===t?this.dummyIdent():null,e.superClass=this.eat(tt._extends)?this.parseExpression():null,e.body=this.startNode(),e.body.body=[],this.pushCx();var i=this.curIndent+1,s=this.curLineStart;for(this.eat(tt.braceL),this.curIndent+1<i&&(i=this.curIndent,s=this.curLineStart);!this.closes(tt.braceR,i,s);)if(!this.semicolon()){var r=this.startNode(),n=void 0,a=void 0;this.options.ecmaVersion>=6&&(r.static=!1,n=this.eat(tt.star)),this.parsePropertyName(r),fe(r.key)?(fe(this.parseMaybeAssign())&&this.next(),this.eat(tt.comma)):("Identifier"!==r.key.type||r.computed||"static"!==r.key.name||this.tok.type===tt.parenL||this.tok.type===tt.braceL?r.static=!1:(r.static=!0,n=this.eat(tt.star),this.parsePropertyName(r)),r.computed||"Identifier"!==r.key.type||"async"!==r.key.name||this.tok.type===tt.parenL||this.canInsertSemicolon()?a=!1:(a=!0,n=this.options.ecmaVersion>=9&&this.eat(tt.star),this.parsePropertyName(r)),this.options.ecmaVersion>=5&&"Identifier"===r.key.type&&!r.computed&&("get"===r.key.name||"set"===r.key.name)&&this.tok.type!==tt.parenL&&this.tok.type!==tt.braceL?(r.kind=r.key.name,this.parsePropertyName(r),r.value=this.parseMethod(!1)):(r.computed||r.static||n||a||!("Identifier"===r.key.type&&"constructor"===r.key.name||"Literal"===r.key.type&&"constructor"===r.key.value)?r.kind="method":r.kind="constructor",r.value=this.parseMethod(n,a)),e.body.body.push(this.finishNode(r,"MethodDefinition")))}return this.popCx(),this.eat(tt.braceR)||(this.last.end=this.tok.start,this.options.locations&&(this.last.loc.end=this.tok.loc.start)),this.semicolon(),this.finishNode(e.body,"ClassBody"),this.finishNode(e,t?"ClassDeclaration":"ClassExpression")},ke.parseFunction=function(t,e,i){var s=this.inAsync,r=this.inFunction;return this.initFunction(t),this.options.ecmaVersion>=6&&(t.generator=this.eat(tt.star)),this.options.ecmaVersion>=8&&(t.async=!!i),this.tok.type===tt.name?t.id=this.parseIdent():!0===e&&(t.id=this.dummyIdent()),this.inAsync=t.async,this.inFunction=!0,t.params=this.parseFunctionParams(),t.body=this.parseBlock(),this.toks.adaptDirectivePrologue(t.body.body),this.inAsync=s,this.inFunction=r,this.finishNode(t,e?"FunctionDeclaration":"FunctionExpression")},ke.parseExport=function(){var t=this.startNode();if(this.next(),this.eat(tt.star))return this.options.ecmaVersion>=11&&(this.eatContextual("as")?t.exported=this.parseExprAtom():t.exported=null),t.source=this.eatContextual("from")?this.parseExprAtom():this.dummyString(),this.finishNode(t,"ExportAllDeclaration");if(this.eat(tt._default)){var e;if(this.tok.type===tt._function||(e=this.toks.isAsyncFunction())){var i=this.startNode();this.next(),e&&this.next(),t.declaration=this.parseFunction(i,"nullableID",e)}else this.tok.type===tt._class?t.declaration=this.parseClass("nullableID"):(t.declaration=this.parseMaybeAssign(),this.semicolon());return this.finishNode(t,"ExportDefaultDeclaration")}return this.tok.type.keyword||this.toks.isLet()||this.toks.isAsyncFunction()?(t.declaration=this.parseStatement(),t.specifiers=[],t.source=null):(t.declaration=null,t.specifiers=this.parseExportSpecifierList(),t.source=this.eatContextual("from")?this.parseExprAtom():null,this.semicolon()),this.finishNode(t,"ExportNamedDeclaration")},ke.parseImport=function(){var t,e=this.startNode();(this.next(),this.tok.type===tt.string)?(e.specifiers=[],e.source=this.parseExprAtom()):(this.tok.type===tt.name&&"from"!==this.tok.value&&((t=this.startNode()).local=this.parseIdent(),this.finishNode(t,"ImportDefaultSpecifier"),this.eat(tt.comma)),e.specifiers=this.parseImportSpecifiers(),e.source=this.eatContextual("from")&&this.tok.type===tt.string?this.parseExprAtom():this.dummyString(),t&&e.specifiers.unshift(t));return this.semicolon(),this.finishNode(e,"ImportDeclaration")},ke.parseImportSpecifiers=function(){var t=[];if(this.tok.type===tt.star){var e=this.startNode();this.next(),e.local=this.eatContextual("as")?this.parseIdent():this.dummyIdent(),t.push(this.finishNode(e,"ImportNamespaceSpecifier"))}else{var i=this.curIndent,s=this.curLineStart,r=this.nextLineStart;for(this.pushCx(),this.eat(tt.braceL),this.curLineStart>r&&(r=this.curLineStart);!this.closes(tt.braceR,i+(this.curLineStart<=r?1:0),s);){var n=this.startNode();if(this.eat(tt.star))n.local=this.eatContextual("as")?this.parseIdent():this.dummyIdent(),this.finishNode(n,"ImportNamespaceSpecifier");else{if(this.isContextual("from"))break;if(n.imported=this.parseIdent(),fe(n.imported))break;n.local=this.eatContextual("as")?this.parseIdent():n.imported,this.finishNode(n,"ImportSpecifier")}t.push(n),this.eat(tt.comma)}this.eat(tt.braceR),this.popCx()}return t},ke.parseExportSpecifierList=function(){var t=[],e=this.curIndent,i=this.curLineStart,s=this.nextLineStart;for(this.pushCx(),this.eat(tt.braceL),this.curLineStart>s&&(s=this.curLineStart);!this.closes(tt.braceR,e+(this.curLineStart<=s?1:0),i)&&!this.isContextual("from");){var r=this.startNode();if(r.local=this.parseIdent(),fe(r.local))break;r.exported=this.eatContextual("as")?this.parseIdent():r.local,this.finishNode(r,"ExportSpecifier"),t.push(r),this.eat(tt.comma)}return this.eat(tt.braceR),this.popCx(),t};var _e=ge.prototype;_e.checkLVal=function(t){if(!t)return t;switch(t.type){case"Identifier":case"MemberExpression":return t;case"ParenthesizedExpression":return t.expression=this.checkLVal(t.expression),t;default:return this.dummyIdent()}},_e.parseExpression=function(t){var e=this.storeCurrentPos(),i=this.parseMaybeAssign(t);if(this.tok.type===tt.comma){var s=this.startNodeAt(e);for(s.expressions=[i];this.eat(tt.comma);)s.expressions.push(this.parseMaybeAssign(t));return this.finishNode(s,"SequenceExpression")}return i},_e.parseParenExpression=function(){this.pushCx(),this.expect(tt.parenL);var t=this.parseExpression();return this.popCx(),this.expect(tt.parenR),t},_e.parseMaybeAssign=function(t){if(this.toks.isContextual("yield")){var e=this.startNode();return this.next(),this.semicolon()||this.canInsertSemicolon()||this.tok.type!==tt.star&&!this.tok.type.startsExpr?(e.delegate=!1,e.argument=null):(e.delegate=this.eat(tt.star),e.argument=this.parseMaybeAssign()),this.finishNode(e,"YieldExpression")}var i=this.storeCurrentPos(),s=this.parseMaybeConditional(t);if(this.tok.type.isAssign){var r=this.startNodeAt(i);return r.operator=this.tok.value,r.left=this.tok.type===tt.eq?this.toAssignable(s):this.checkLVal(s),this.next(),r.right=this.parseMaybeAssign(t),this.finishNode(r,"AssignmentExpression")}return s},_e.parseMaybeConditional=function(t){var e=this.storeCurrentPos(),i=this.parseExprOps(t);if(this.eat(tt.question)){var s=this.startNodeAt(e);return s.test=i,s.consequent=this.parseMaybeAssign(),s.alternate=this.expect(tt.colon)?this.parseMaybeAssign(t):this.dummyIdent(),this.finishNode(s,"ConditionalExpression")}return i},_e.parseExprOps=function(t){var e=this.storeCurrentPos(),i=this.curIndent,s=this.curLineStart;return this.parseExprOp(this.parseMaybeUnary(!1),e,-1,t,i,s)},_e.parseExprOp=function(t,e,i,s,r,n){if(this.curLineStart!==n&&this.curIndent<r&&this.tokenStartsLine())return t;var a=this.tok.type.binop;if(null!=a&&(!s||this.tok.type!==tt._in)&&a>i){var o=this.startNodeAt(e);if(o.left=t,o.operator=this.tok.value,this.next(),this.curLineStart!==n&&this.curIndent<r&&this.tokenStartsLine())o.right=this.dummyIdent();else{var h=this.storeCurrentPos();o.right=this.parseExprOp(this.parseMaybeUnary(!1),h,a,s,r,n)}return this.finishNode(o,/&&|\|\||\?\?/.test(o.operator)?"LogicalExpression":"BinaryExpression"),this.parseExprOp(o,e,i,s,r,n)}return t},_e.parseMaybeUnary=function(t){var e,i=this.storeCurrentPos();if(this.options.ecmaVersion>=8&&this.toks.isContextual("await")&&(this.inAsync||!this.inFunction&&this.options.allowAwaitOutsideFunction))e=this.parseAwait(),t=!0;else if(this.tok.type.prefix){var s=this.startNode(),r=this.tok.type===tt.incDec;r||(t=!0),s.operator=this.tok.value,s.prefix=!0,this.next(),s.argument=this.parseMaybeUnary(!0),r&&(s.argument=this.checkLVal(s.argument)),e=this.finishNode(s,r?"UpdateExpression":"UnaryExpression")}else if(this.tok.type===tt.ellipsis){var n=this.startNode();this.next(),n.argument=this.parseMaybeUnary(t),e=this.finishNode(n,"SpreadElement")}else for(e=this.parseExprSubscripts();this.tok.type.postfix&&!this.canInsertSemicolon();){var a=this.startNodeAt(i);a.operator=this.tok.value,a.prefix=!1,a.argument=this.checkLVal(e),this.next(),e=this.finishNode(a,"UpdateExpression")}if(!t&&this.eat(tt.starstar)){var o=this.startNodeAt(i);return o.operator="**",o.left=e,o.right=this.parseMaybeUnary(!1),this.finishNode(o,"BinaryExpression")}return e},_e.parseExprSubscripts=function(){var t=this.storeCurrentPos();return this.parseSubscripts(this.parseExprAtom(),t,!1,this.curIndent,this.curLineStart)},_e.parseSubscripts=function(t,e,i,s,r){for(var n=this.options.ecmaVersion>=11,a=!1;;){if(this.curLineStart!==r&&this.curIndent<=s&&this.tokenStartsLine()){if(this.tok.type!==tt.dot||this.curIndent!==s)break;--s}var o="Identifier"===t.type&&"async"===t.name&&!this.canInsertSemicolon(),h=n&&this.eat(tt.questionDot);if(h&&(a=!0),h&&this.tok.type!==tt.parenL&&this.tok.type!==tt.bracketL&&this.tok.type!==tt.backQuote||this.eat(tt.dot)){var p=this.startNodeAt(e);p.object=t,this.curLineStart!==r&&this.curIndent<=s&&this.tokenStartsLine()?p.property=this.dummyIdent():p.property=this.parsePropertyAccessor()||this.dummyIdent(),p.computed=!1,n&&(p.optional=h),t=this.finishNode(p,"MemberExpression")}else if(this.tok.type===tt.bracketL){this.pushCx(),this.next();var c=this.startNodeAt(e);c.object=t,c.property=this.parseExpression(),c.computed=!0,n&&(c.optional=h),this.popCx(),this.expect(tt.bracketR),t=this.finishNode(c,"MemberExpression")}else if(i||this.tok.type!==tt.parenL){if(this.tok.type!==tt.backQuote)break;var l=this.startNodeAt(e);l.tag=t,l.quasi=this.parseTemplate(),t=this.finishNode(l,"TaggedTemplateExpression")}else{var u=this.parseExprList(tt.parenR);if(o&&this.eat(tt.arrow))return this.parseArrowExpression(this.startNodeAt(e),u,!0);var d=this.startNodeAt(e);d.callee=t,d.arguments=u,n&&(d.optional=h),t=this.finishNode(d,"CallExpression")}}if(a){var f=this.startNodeAt(e);f.expression=t,t=this.finishNode(f,"ChainExpression")}return t},_e.parseExprAtom=function(){var t;switch(this.tok.type){case tt._this:case tt._super:var e=this.tok.type===tt._this?"ThisExpression":"Super";return t=this.startNode(),this.next(),this.finishNode(t,e);case tt.name:var i=this.storeCurrentPos(),s=this.parseIdent(),r=!1;if("async"===s.name&&!this.canInsertSemicolon()){if(this.eat(tt._function))return this.parseFunction(this.startNodeAt(i),!1,!0);this.tok.type===tt.name&&(s=this.parseIdent(),r=!0)}return this.eat(tt.arrow)?this.parseArrowExpression(this.startNodeAt(i),[s],r):s;case tt.regexp:t=this.startNode();var n=this.tok.value;return t.regex={pattern:n.pattern,flags:n.flags},t.value=n.value,t.raw=this.input.slice(this.tok.start,this.tok.end),this.next(),this.finishNode(t,"Literal");case tt.num:case tt.string:return(t=this.startNode()).value=this.tok.value,t.raw=this.input.slice(this.tok.start,this.tok.end),this.tok.type===tt.num&&110===t.raw.charCodeAt(t.raw.length-1)&&(t.bigint=t.raw.slice(0,-1).replace(/_/g,"")),this.next(),this.finishNode(t,"Literal");case tt._null:case tt._true:case tt._false:return(t=this.startNode()).value=this.tok.type===tt._null?null:this.tok.type===tt._true,t.raw=this.tok.type.keyword,this.next(),this.finishNode(t,"Literal");case tt.parenL:var a=this.storeCurrentPos();this.next();var o=this.parseExpression();if(this.expect(tt.parenR),this.eat(tt.arrow)){var h=o.expressions||[o];return h.length&&fe(h[h.length-1])&&h.pop(),this.parseArrowExpression(this.startNodeAt(a),h)}if(this.options.preserveParens){var p=this.startNodeAt(a);p.expression=o,o=this.finishNode(p,"ParenthesizedExpression")}return o;case tt.bracketL:return(t=this.startNode()).elements=this.parseExprList(tt.bracketR,!0),this.finishNode(t,"ArrayExpression");case tt.braceL:return this.parseObj();case tt._class:return this.parseClass(!1);case tt._function:return t=this.startNode(),this.next(),this.parseFunction(t,!1);case tt._new:return this.parseNew();case tt.backQuote:return this.parseTemplate();case tt._import:return this.options.ecmaVersion>=11?this.parseExprImport():this.dummyIdent();default:return this.dummyIdent()}},_e.parseExprImport=function(){var t=this.startNode(),e=this.parseIdent(!0);switch(this.tok.type){case tt.parenL:return this.parseDynamicImport(t);case tt.dot:return t.meta=e,this.parseImportMeta(t);default:return t.name="import",this.finishNode(t,"Identifier")}},_e.parseDynamicImport=function(t){return t.source=this.parseExprList(tt.parenR)[0]||this.dummyString(),this.finishNode(t,"ImportExpression")},_e.parseImportMeta=function(t){return this.next(),t.property=this.parseIdent(!0),this.finishNode(t,"MetaProperty")},_e.parseNew=function(){var t=this.startNode(),e=this.curIndent,i=this.curLineStart,s=this.parseIdent(!0);if(this.options.ecmaVersion>=6&&this.eat(tt.dot))return t.meta=s,t.property=this.parseIdent(!0),this.finishNode(t,"MetaProperty");var r=this.storeCurrentPos();return t.callee=this.parseSubscripts(this.parseExprAtom(),r,!0,e,i),this.tok.type===tt.parenL?t.arguments=this.parseExprList(tt.parenR):t.arguments=[],this.finishNode(t,"NewExpression")},_e.parseTemplateElement=function(){var t=this.startNode();return this.tok.type===tt.invalidTemplate?t.value={raw:this.tok.value,cooked:null}:t.value={raw:this.input.slice(this.tok.start,this.tok.end).replace(/\r\n?/g,"\n"),cooked:this.tok.value},this.next(),t.tail=this.tok.type===tt.backQuote,this.finishNode(t,"TemplateElement")},_e.parseTemplate=function(){var t=this.startNode();this.next(),t.expressions=[];var e=this.parseTemplateElement();for(t.quasis=[e];!e.tail;)this.next(),t.expressions.push(this.parseExpression()),this.expect(tt.braceR)?e=this.parseTemplateElement():((e=this.startNode()).value={cooked:"",raw:""},e.tail=!0,this.finishNode(e,"TemplateElement")),t.quasis.push(e);return this.expect(tt.backQuote),this.finishNode(t,"TemplateLiteral")},_e.parseObj=function(){var t=this.startNode();t.properties=[],this.pushCx();var e=this.curIndent+1,i=this.curLineStart;for(this.eat(tt.braceL),this.curIndent+1<e&&(e=this.curIndent,i=this.curLineStart);!this.closes(tt.braceR,e,i);){var s=this.startNode(),r=void 0,n=void 0,a=void 0;if(this.options.ecmaVersion>=9&&this.eat(tt.ellipsis))s.argument=this.parseMaybeAssign(),t.properties.push(this.finishNode(s,"SpreadElement")),this.eat(tt.comma);else if(this.options.ecmaVersion>=6&&(a=this.storeCurrentPos(),s.method=!1,s.shorthand=!1,r=this.eat(tt.star)),this.parsePropertyName(s),this.toks.isAsyncProp(s)?(n=!0,r=this.options.ecmaVersion>=9&&this.eat(tt.star),this.parsePropertyName(s)):n=!1,fe(s.key))fe(this.parseMaybeAssign())&&this.next(),this.eat(tt.comma);else{if(this.eat(tt.colon))s.kind="init",s.value=this.parseMaybeAssign();else if(this.options.ecmaVersion>=6&&(this.tok.type===tt.parenL||this.tok.type===tt.braceL))s.kind="init",s.method=!0,s.value=this.parseMethod(r,n);else if(this.options.ecmaVersion>=5&&"Identifier"===s.key.type&&!s.computed&&("get"===s.key.name||"set"===s.key.name)&&this.tok.type!==tt.comma&&this.tok.type!==tt.braceR&&this.tok.type!==tt.eq)s.kind=s.key.name,this.parsePropertyName(s),s.value=this.parseMethod(!1);else{if(s.kind="init",this.options.ecmaVersion>=6)if(this.eat(tt.eq)){var o=this.startNodeAt(a);o.operator="=",o.left=s.key,o.right=this.parseMaybeAssign(),s.value=this.finishNode(o,"AssignmentExpression")}else s.value=s.key;else s.value=this.dummyIdent();s.shorthand=!0}t.properties.push(this.finishNode(s,"Property")),this.eat(tt.comma)}}return this.popCx(),this.eat(tt.braceR)||(this.last.end=this.tok.start,this.options.locations&&(this.last.loc.end=this.tok.loc.start)),this.finishNode(t,"ObjectExpression")},_e.parsePropertyName=function(t){if(this.options.ecmaVersion>=6){if(this.eat(tt.bracketL))return t.computed=!0,t.key=this.parseExpression(),void this.expect(tt.bracketR);t.computed=!1}var e=this.tok.type===tt.num||this.tok.type===tt.string?this.parseExprAtom():this.parseIdent();t.key=e||this.dummyIdent()},_e.parsePropertyAccessor=function(){if(this.tok.type===tt.name||this.tok.type.keyword)return this.parseIdent()},_e.parseIdent=function(){var t=this.tok.type===tt.name?this.tok.value:this.tok.type.keyword;if(!t)return this.dummyIdent();var e=this.startNode();return this.next(),e.name=t,this.finishNode(e,"Identifier")},_e.initFunction=function(t){t.id=null,t.params=[],this.options.ecmaVersion>=6&&(t.generator=!1,t.expression=!1),this.options.ecmaVersion>=8&&(t.async=!1)},_e.toAssignable=function(t,e){if(!t||"Identifier"===t.type||"MemberExpression"===t.type&&!e);else if("ParenthesizedExpression"===t.type)this.toAssignable(t.expression,e);else{if(this.options.ecmaVersion<6)return this.dummyIdent();if("ObjectExpression"===t.type){t.type="ObjectPattern";for(var i=0,s=t.properties;i<s.length;i+=1){var r=s[i];this.toAssignable(r,e)}}else if("ArrayExpression"===t.type)t.type="ArrayPattern",this.toAssignableList(t.elements,e);else if("Property"===t.type)this.toAssignable(t.value,e);else if("SpreadElement"===t.type)t.type="RestElement",this.toAssignable(t.argument,e);else{if("AssignmentExpression"!==t.type)return this.dummyIdent();t.type="AssignmentPattern",delete t.operator}}return t},_e.toAssignableList=function(t,e){for(var i=0,s=t;i<s.length;i+=1){var r=s[i];this.toAssignable(r,e)}return t},_e.parseFunctionParams=function(t){return t=this.parseExprList(tt.parenR),this.toAssignableList(t,!0)},_e.parseMethod=function(t,e){var i=this.startNode(),s=this.inAsync,r=this.inFunction;return this.initFunction(i),this.options.ecmaVersion>=6&&(i.generator=!!t),this.options.ecmaVersion>=8&&(i.async=!!e),this.inAsync=i.async,this.inFunction=!0,i.params=this.parseFunctionParams(),i.body=this.parseBlock(),this.toks.adaptDirectivePrologue(i.body.body),this.inAsync=s,this.inFunction=r,this.finishNode(i,"FunctionExpression")},_e.parseArrowExpression=function(t,e,i){var s=this.inAsync,r=this.inFunction;return this.initFunction(t),this.options.ecmaVersion>=8&&(t.async=!!i),this.inAsync=t.async,this.inFunction=!0,t.params=this.toAssignableList(e,!0),t.expression=this.tok.type!==tt.braceL,t.expression?t.body=this.parseMaybeAssign():(t.body=this.parseBlock(),this.toks.adaptDirectivePrologue(t.body.body)),this.inAsync=s,this.inFunction=r,this.finishNode(t,"ArrowFunctionExpression")},_e.parseExprList=function(t,e){this.pushCx();var i=this.curIndent,s=this.curLineStart,r=[];for(this.next();!this.closes(t,i+1,s);)if(this.eat(tt.comma))r.push(e?null:this.dummyIdent());else{var n=this.parseMaybeAssign();if(fe(n)){if(this.closes(t,i,s))break;this.next()}else r.push(n);this.eat(tt.comma)}return this.popCx(),this.eat(t)||(this.last.end=this.tok.start,this.options.locations&&(this.last.loc.end=this.tok.loc.start)),r},_e.parseAwait=function(){var t=this.startNode();return this.next(),t.argument=this.parseMaybeUnary(),this.finishNode(t,"AwaitExpression")},mt.tabSize=4;var be=Object.freeze({__proto__:null,Chunk:undefined,javaScriptOutline:function(e){let i,s=[],r=0;try{i=n(e,{ecmaVersion:h,ranges:!1})}catch(t){i=ge.parse(e,{ecmaVersion:h,ranges:!1})}const o=t.findLineEndingIndexes(e),p=new a.TextCursor(o);return new c((function(t){if("ClassDeclaration"===t.type)l(t.id);else if("VariableDeclarator"===t.type&&t.init&&m(t.init))l(t.id);else if("AssignmentExpression"===t.type&&d(t.left)&&m(t.right))l(t.left);else if("Property"===t.type&&d(t.key)&&m(t.value))l(t.key);else if("FunctionDeclaration"===t.type)u(t.id,t);else if("VariableDeclarator"===t.type&&t.init&&f(t.init))u(t.id,t.init);else if("AssignmentExpression"===t.type&&d(t.left)&&f(t.right))u(t.left,t.right);else if(("MethodDefinition"===t.type||"Property"===t.type)&&d(t.key)&&f(t.value)){const e=[];"get"!==t.kind&&"set"!==t.kind||e.push(t.kind),"static"in t&&t.static&&e.push("static"),u(t.key,t.value,e.join(" "))}return})).walk(i),{chunk:s,isLastChunk:!0};function l(t){const e="class "+g(t);p.advance(t.start),x({name:e,line:p.lineNumber(),column:p.columnNumber(),arguments:void 0})}function u(t,e,i){let s=g(t);const r=e;r.generator&&(s="*"+s),i&&(s=i+" "+s),r.async&&(s="async "+s),p.advance(t.start),x({name:s,line:p.lineNumber(),column:p.columnNumber(),arguments:y(r.params)})}function d(t){return!!t&&("MemberExpression"===t.type?!t.computed&&"Identifier"===t.property.type:"Identifier"===t.type)}function f(t){return!!t&&("FunctionExpression"===t.type||"ArrowFunctionExpression"===t.type)}function m(t){return void 0!==t&&"ClassExpression"===t.type}function g(t){"MemberExpression"===t.type&&(t=t.property),console.assert("Identifier"===t.type,"Cannot extract identifier from unknown type: "+t.type);return t.name}function y(t){const e=[];for(const i of t)"Identifier"===i.type?e.push(i.name):"RestElement"===i.type&&"Identifier"===i.argument.type?e.push("..."+i.argument.name):console.error("Error: unexpected function parameter type: "+i.type);return"("+e.join(", ")+")"}function x(t){s.push(t),p.offset()-r<1e5||(postMessage({chunk:s,isLastChunk:!1}),s=[],r=p.offset())}}});export{P as CSSFormatter,R as CSSRuleParser,d as FormattedContentBuilder,L as FormatterWorker,C as HTMLFormatter,m as JavaScriptFormatter,be as JavaScriptOutline};
