import{TextUtils as e,TextRange as t,StaticContentProvider as i,ContentProvider as s}from"../text_utils/text_utils.js";import{i18n as n}from"../i18n/i18n.js";import{ContextMenu as r,View as o,Toolbar as h,TextEditor as a,ProgressIndicator as l,Widget as c,SearchableView as d,ARIAUtils as u,UIUtils as _,DropTarget as g,TreeOutline as m,EmptyWidget as p}from"../ui/ui.js";import{Settings as S,Worker as f,WasmDisassembly as x,ParsedURL as w,ResourceType as C}from"../common/common.js";import{ScriptFormatter as y}from"../formatter/formatter.js";import{ArrayUtilities as T,NumberUtilities as E,StringUtilities as b}from"../platform/platform.js";import{CodeMirrorTextEditor as v,CodeMirrorUtils as M}from"../text_editor/text_editor.js";import{InspectorFrontendHost as L}from"../host/host.js";import{UISourceCode as R}from"../workspace/workspace.js";import{ObjectPropertiesSection as P}from"../object_ui/object_ui.js";import{RemoteObject as I}from"../sdk/sdk.js";import{Diff as O}from"../diff/diff.js";const F=new WeakSet;class H extends v.CodeMirrorTextEditor{constructor(t,i){const s={lineNumbers:!0,lineWrapping:!1,bracketMatchingSetting:S.Settings.instance().moduleSetting("textEditorBracketMatching"),padBottom:S.Settings.instance().moduleSetting("allowScrollPastEof").get(),lineWiseCopyCut:!0,devtoolsAccessibleName:void 0,mimeType:void 0,autoHeight:void 0,maxHighlightLength:void 0,placeholder:void 0,inputStyle:void 0};function n(e){this._isHandlingMouseDownEvent=e}i&&Object.assign(s,i),super(s),this.codeMirror().addKeyMap({Enter:"smartNewlineAndIndent",Esc:"sourcesDismiss"}),this._delegate=t,this.codeMirror().on("cursorActivity",this._cursorActivity.bind(this)),this.codeMirror().on("gutterClick",this._gutterClick.bind(this)),this.codeMirror().on("scroll",this._scroll.bind(this)),this.codeMirror().on("focus",this._focus.bind(this)),this.codeMirror().on("blur",this._blur.bind(this)),this.codeMirror().on("beforeSelectionChange",this._fireBeforeSelectionChanged.bind(this)),this.codeMirror().on("gutterContextMenu",this._gutterContextMenu.bind(this)),this.codeMirror().on("contextmenu",this._textAreaContextMenu.bind(this)),this._gutterMouseMove=e=>{const t=e;this.element.classList.toggle("CodeMirror-gutter-hovered",t.clientX<this.codeMirror().getGutterElement().getBoundingClientRect().right)},this._gutterMouseOut=()=>{this.element.classList.toggle("CodeMirror-gutter-hovered",!1)},this.codeMirror().addKeyMap(k),this._tokenHighlighter=new A(this,this.codeMirror()),this._gutters=[U],this.codeMirror().setOption("gutters",this._gutters.slice()),this.codeMirror().setOption("electricChars",!1),this.codeMirror().setOption("smartIndent",!1),this._isHandlingMouseDownEvent=!1,this.element.addEventListener("mousedown",n.bind(this,!0),!0),this.element.addEventListener("mousedown",n.bind(this,!1),!1),S.Settings.instance().moduleSetting("textEditorIndent").addChangeListener(this._onUpdateEditorIndentation,this),S.Settings.instance().moduleSetting("textEditorAutoDetectIndent").addChangeListener(this._onUpdateEditorIndentation,this),S.Settings.instance().moduleSetting("showWhitespacesInEditor").addChangeListener(this._updateWhitespace,this),S.Settings.instance().moduleSetting("textEditorCodeFolding").addChangeListener(this._updateCodeFolding,this),S.Settings.instance().moduleSetting("allowScrollPastEof").addChangeListener(this._updateScrollPastEof,this),this._updateCodeFolding(),this._autocompleteConfig={isWordChar:e.Utils.isWordChar,substituteRangeCallback:void 0,tooltipCallback:void 0,suggestionsCallback:void 0,anchorBehavior:void 0},S.Settings.instance().moduleSetting("textEditorAutocompletion").addChangeListener(this._updateAutocomplete,this),this._updateAutocomplete(),this._onUpdateEditorIndentation(),this._setupWhitespaceHighlight(),this._infoBarDiv=null}static getForCodeMirror(e){return v.CodeMirrorTextEditor.getForCodeMirror(e)}attachInfobar(e){this._infoBarDiv||(this._infoBarDiv=document.createElement("div"),this._infoBarDiv.classList.add("flex-none"),this.element.insertBefore(this._infoBarDiv,this.element.firstChild)),this._infoBarDiv.appendChild(e.element),e.setParentView(this),this.doResize()}static _guessIndentationLevel(t){const i=/^\t+/;let s=0;const n=new Map;for(let r=0;r<t.length;++r){const o=t[r];if(0===o.length||!e.Utils.isSpaceChar(o[0]))continue;if(i.test(o)){++s;continue}let h=0;for(;h<o.length&&e.Utils.isSpaceChar(o[h]);)++h;h%2==0&&n.set(h,1+(n.get(h)||0))}const r=3*t.length/100;if(s&&s>r)return"\t";let o=1/0;for(const[e,t]of n)t<r||o>e&&(o=e);return o===1/0?S.Settings.instance().moduleSetting("textEditorIndent").get():" ".repeat(o)}_isSearchActive(){return Boolean(this._tokenHighlighter.highlightedRegex())}scrollToLine(e){super.scrollToLine(e),this._scroll()}highlightSearchResults(e,i){this._selectionBeforeSearch||(this._selectionBeforeSearch=this.selection()),this.codeMirror().operation(function(){i&&(this.scrollLineIntoView(i.startLine),i.endColumn>v.CodeMirrorTextEditor.maxHighlightLength?this.setSelection(i):this.setSelection(t.TextRange.createFromLocation(i.startLine,i.startColumn))),this._tokenHighlighter.highlightSearchResults(e,i)}.bind(this))}cancelSearchResultsHighlight(){this.codeMirror().operation(this._tokenHighlighter.highlightSelectedTokens.bind(this._tokenHighlighter)),this._selectionBeforeSearch&&(this._reportJump(this._selectionBeforeSearch,this.selection()),delete this._selectionBeforeSearch)}removeHighlight(e){e.clear()}highlightRange(e,t){t="CodeMirror-persist-highlight "+t;const i=M.toPos(e);return++i.end.ch,this.codeMirror().markText(i.start,i.end,{className:t,startStyle:t+"-start",endStyle:t+"-end"})}installGutter(e,t){-1===this._gutters.indexOf(e)&&(t?this._gutters.unshift(e):this._gutters.push(e),this.codeMirror().setOption("gutters",this._gutters.slice()),this.refresh())}uninstallGutter(e){const t=this._gutters.indexOf(e);-1!==t&&(this.codeMirror().clearGutter(e),this._gutters.splice(t,1),this.codeMirror().setOption("gutters",this._gutters.slice()),this.refresh())}setGutterDecoration(e,t,i){console.assert(-1!==this._gutters.indexOf(t),"Cannot decorate unexisting gutter."),this.codeMirror().setGutterMarker(e,t,i)}setExecutionLocation(e,t){if(this.clearPositionHighlight(),this._executionLine=this.codeMirror().getLineHandle(e),!this._executionLine)return;this.showExecutionLineBackground(),this.codeMirror().addLineClass(this._executionLine,"wrap","cm-execution-line-outline");let i,s=this.tokenAtTextPosition(e,t);if(s&&!s.type&&s.startColumn+1===s.endColumn){const t=this.codeMirror().getLine(e)[s.startColumn];"."!==t&&"("!==t||(s=this.tokenAtTextPosition(e,s.endColumn+1))}i=s&&s.type?s.endColumn:this.codeMirror().getLine(e).length,this._executionLineTailMarker=this.codeMirror().markText({line:e,ch:t},{line:e,ch:i},{className:"cm-execution-line-tail"})}showExecutionLineBackground(){this._executionLine&&this.codeMirror().addLineClass(this._executionLine,"wrap","cm-execution-line")}hideExecutionLineBackground(){this._executionLine&&this.codeMirror().removeLineClass(this._executionLine,"wrap","cm-execution-line")}clearExecutionLine(){this.clearPositionHighlight(),this._executionLine&&(this.hideExecutionLineBackground(),this.codeMirror().removeLineClass(this._executionLine,"wrap","cm-execution-line-outline")),delete this._executionLine,this._executionLineTailMarker&&this._executionLineTailMarker.clear(),delete this._executionLineTailMarker}toggleLineClass(e,t,i){if(this.hasLineClass(e,t)===i)return;const s=this.codeMirror().getLineHandle(e);s&&(i?(this.codeMirror().addLineClass(s,"gutter",t),this.codeMirror().addLineClass(s,"wrap",t)):(this.codeMirror().removeLineClass(s,"gutter",t),this.codeMirror().removeLineClass(s,"wrap",t)))}hasLineClass(e,t){const i=this.codeMirror().lineInfo(e);if(!i)return!1;const s=i.wrapClass;if(!s)return!1;return-1!==s.split(" ").indexOf(t)}_gutterClick(e,t,i,s){this.dispatchEventToListeners(N.GutterClick,{gutterType:i,lineNumber:t,event:s})}_textAreaContextMenu(e,t){const i=new r.ContextMenu(t);t.consume(!0);const s=this.selection();this._delegate.populateTextAreaContextMenu(i,s.startLine,s.startColumn).then((()=>{i.appendApplicableItems(this),i.show()}))}_gutterContextMenu(e,t,i,s){const n=new r.ContextMenu(s);s.consume(!0),this._delegate.populateLineGutterContextMenu(n,t).then((()=>{n.appendApplicableItems(this),n.show()}))}editRange(e,t,i){const s=super.editRange(e,t,i);return S.Settings.instance().moduleSetting("textEditorAutoDetectIndent").get()&&this._onUpdateEditorIndentation(),s}_onUpdateEditorIndentation(){this._setEditorIndentation(M.pullLines(this.codeMirror(),D))}_setEditorIndentation(e){const t={};let i=S.Settings.instance().moduleSetting("textEditorIndent").get();S.Settings.instance().moduleSetting("textEditorAutoDetectIndent").get()&&(i=H._guessIndentationLevel(e)),"\t"===i?(this.codeMirror().setOption("indentWithTabs",!0),this.codeMirror().setOption("indentUnit",4)):(this.codeMirror().setOption("indentWithTabs",!1),this.codeMirror().setOption("indentUnit",i.length),t.Tab=function(e){if(e.somethingSelected())return CodeMirror.Pass;const t=e.getCursor("head");e.replaceRange(i.substring(t.ch%i.length),e.getCursor())}),this.codeMirror().setOption("extraKeys",t),this._indentationLevel=i}indent(){return this._indentationLevel}_onAutoAppendedSpaces(){this._autoAppendedSpaces=this._autoAppendedSpaces||[];for(let t=0;t<this._autoAppendedSpaces.length;++t){const i=this._autoAppendedSpaces[t].resolve();if(!i)continue;const s=this.line(i.lineNumber);s.length===i.columnNumber&&e.Utils.lineIndent(s).length===s.length&&this.codeMirror().replaceRange("",new CodeMirror.Pos(i.lineNumber,0),new CodeMirror.Pos(i.lineNumber,i.columnNumber))}this._autoAppendedSpaces=[];const t=this.selections();for(let e=0;e<t.length;++e){const i=t[e];this._autoAppendedSpaces.push(this.textEditorPositionHandle(i.startLine,i.startColumn))}}_cursorActivity(){this._isSearchActive()||this.codeMirror().operation(this._tokenHighlighter.highlightSelectedTokens.bind(this._tokenHighlighter));const e=this.codeMirror().getCursor("anchor"),t=this.codeMirror().getCursor("head");this.dispatchEventToListeners(N.SelectionChanged,M.toRange(e,t))}_reportJump(e,t){e&&t&&e.equal(t)||this.dispatchEventToListeners(N.JumpHappened,{from:e,to:t})}_scroll(){const e=this.codeMirror().lineAtHeight(this.codeMirror().getScrollInfo().top,"local");this.dispatchEventToListeners(N.ScrollChanged,e)}_focus(){this.dispatchEventToListeners(N.EditorFocused)}_blur(){this.dispatchEventToListeners(N.EditorBlurred)}_fireBeforeSelectionChanged(e,t){if(!this._isHandlingMouseDownEvent)return;if(!t.ranges.length)return;const i=t.ranges[0];this._reportJump(this.selection(),M.toRange(i.anchor,i.head))}dispose(){super.dispose(),S.Settings.instance().moduleSetting("textEditorIndent").removeChangeListener(this._onUpdateEditorIndentation,this),S.Settings.instance().moduleSetting("textEditorAutoDetectIndent").removeChangeListener(this._onUpdateEditorIndentation,this),S.Settings.instance().moduleSetting("showWhitespacesInEditor").removeChangeListener(this._updateWhitespace,this),S.Settings.instance().moduleSetting("textEditorCodeFolding").removeChangeListener(this._updateCodeFolding,this),S.Settings.instance().moduleSetting("allowScrollPastEof").removeChangeListener(this._updateScrollPastEof,this)}setText(e){this._setEditorIndentation(e.split("\n").slice(0,D)),super.setText(e)}_updateWhitespace(){this.setMimeType(this.mimeType())}_updateCodeFolding(){S.Settings.instance().moduleSetting("textEditorCodeFolding").get()?(this.installGutter("CodeMirror-foldgutter",!1),this.element.addEventListener("mousemove",this._gutterMouseMove),this.element.addEventListener("mouseout",this._gutterMouseOut),this.codeMirror().setOption("foldGutter",!0),this.codeMirror().setOption("foldOptions",{minFoldSize:1})):(this.codeMirror().execCommand("unfoldAll"),this.element.removeEventListener("mousemove",this._gutterMouseMove),this.element.removeEventListener("mouseout",this._gutterMouseOut),this.uninstallGutter("CodeMirror-foldgutter"),this.codeMirror().setOption("foldGutter",!1))}_updateScrollPastEof(){this.toggleScrollPastEof(S.Settings.instance().moduleSetting("allowScrollPastEof").get())}rewriteMimeType(e){this._setupWhitespaceHighlight();const t=S.Settings.instance().moduleSetting("showWhitespacesInEditor").get();return this.element.classList.toggle("show-whitespaces","all"===t),"all"===t?this._allWhitespaceOverlayMode(e):"trailing"===t?this._trailingWhitespaceOverlayMode(e):e}_allWhitespaceOverlayMode(e){let t=CodeMirror.mimeModes[e]?CodeMirror.mimeModes[e].name||CodeMirror.mimeModes[e]:CodeMirror.mimeModes["text/plain"];if(t+="+all-whitespaces",CodeMirror.modes[t])return t;return CodeMirror.defineMode(t,(function(t,i){const s={token:function(e){if(" "===e.peek()){let t=0;for(;t<V&&" "===e.peek();)++t,e.next();return"whitespace whitespace-"+t}for(;!e.eol()&&" "!==e.peek();)e.next();return null}};return CodeMirror.overlayMode(CodeMirror.getMode(t,e),s,!1)})),t}_trailingWhitespaceOverlayMode(e){let t=CodeMirror.mimeModes[e]?CodeMirror.mimeModes[e].name||CodeMirror.mimeModes[e]:CodeMirror.mimeModes["text/plain"];if(t+="+trailing-whitespaces",CodeMirror.modes[t])return t;return CodeMirror.defineMode(t,(function(t,i){const s={token:function(e){if(e.match(/^\s+$/,!0))return"trailing-whitespace";do{e.next()}while(!e.eol()&&" "!==e.peek());return null}};return CodeMirror.overlayMode(CodeMirror.getMode(t,e),s,!1)})),t}_setupWhitespaceHighlight(){const e=this.element.ownerDocument;if(F.has(e)||!S.Settings.instance().moduleSetting("showWhitespacesInEditor").get())return;F.add(e);let t="",i="";for(let e=1;e<=V;++e){t+="·";i+=".show-whitespaces .CodeMirror .cm-whitespace-"+e+"::before { content: '"+t+"';}\n"}const s=e.createElement("style");s.textContent=i,e.head.appendChild(s)}configureAutocomplete(e){this._autocompleteConfig=e,this._updateAutocomplete()}_updateAutocomplete(){super.configureAutocomplete(S.Settings.instance().moduleSetting("textEditorAutocompletion").get()?this._autocompleteConfig:null)}}const N={GutterClick:Symbol("GutterClick"),SelectionChanged:Symbol("SelectionChanged"),ScrollChanged:Symbol("ScrollChanged"),EditorFocused:Symbol("EditorFocused"),EditorBlurred:Symbol("EditorBlurred"),JumpHappened:Symbol("JumpHappened")};CodeMirror.commands.smartNewlineAndIndent=function(t){t.operation(function(t){const i=t.listSelections(),s=[];for(let n=0;n<i.length;++n){const r=i[n],o=CodeMirror.cmpPos(r.head,r.anchor)<0?r.head:r.anchor,h=t.getLine(o.line),a=e.Utils.lineIndent(h);s.push("\n"+a.substring(0,Math.min(o.ch,a.length)))}t.replaceSelections(s),H.getForCodeMirror(t)._onAutoAppendedSpaces()}.bind(null,t))},CodeMirror.commands.sourcesDismiss=function(e){return 1===e.listSelections().length&&H.getForCodeMirror(e)._isSearchActive()?CodeMirror.Pass:CodeMirror.commands.dismiss(e)};const k={name:"blockIndentKeymap",Enter:function(t){let i=t.listSelections();const s=[];let n=!1;for(let r=0;r<i.length;++r){const o=i[r],h=CodeMirror.cmpPos(o.head,o.anchor)<0?o.head:o.anchor,a=t.getLine(h.line),l=e.Utils.lineIndent(a);let c="\n"+l+H.getForCodeMirror(t).indent(),d=!1;if(0===o.head.ch)return CodeMirror.Pass;if("{}"===a.substr(o.head.ch-1,2))c+="\n"+l,d=!0;else if("{"!==a.substr(o.head.ch-1,1))return CodeMirror.Pass;if(r>0&&n!==d)return CodeMirror.Pass;s.push(c),n=d}if(t.replaceSelections(s),!n)return void H.getForCodeMirror(t)._onAutoAppendedSpaces();i=t.listSelections();const r=[];for(let e=0;e<i.length;++e){const s=i[e],n=t.getLine(s.head.line-1),o=new CodeMirror.Pos(s.head.line-1,n.length);r.push({head:o,anchor:o})}t.setSelections(r),H.getForCodeMirror(t)._onAutoAppendedSpaces()},"'}'":function(t){if(t.somethingSelected())return CodeMirror.Pass;let i=t.listSelections(),s=[];for(let n=0;n<i.length;++n){const r=i[n],o=t.getLine(r.head.line);if(o!==e.Utils.lineIndent(o))return CodeMirror.Pass;s.push("}")}t.replaceSelections(s),i=t.listSelections(),s=[];const n=[];for(let r=0;r<i.length;++r){const o=i[r],h=t.findMatchingBracket(o.head);if(!h||!h.match)return;n.push({head:o.head,anchor:new CodeMirror.Pos(o.head.line,0)});const a=t.getLine(h.to.line),l=e.Utils.lineIndent(a);s.push(l+"}")}t.setSelections(n),t.replaceSelections(s)}};class A{constructor(e,t){this._textEditor=e,this._codeMirror=t,this._highlightDescriptor}highlightSearchResults(e,t){const i=this._highlightRegex;this._highlightRegex=e,this._highlightRange=t,this._searchResultMarker&&(this._searchResultMarker.clear(),delete this._searchResultMarker),this._highlightDescriptor&&this._highlightDescriptor.selectionStart&&this._codeMirror.removeLineClass(this._highlightDescriptor.selectionStart.line,"wrap","cm-line-with-selection");const s=this._highlightRange?new CodeMirror.Pos(this._highlightRange.startLine,this._highlightRange.startColumn):null;if(s&&this._codeMirror.addLineClass(s.line,"wrap","cm-line-with-selection"),i&&this._highlightRegex.toString()===i.toString()?this._highlightDescriptor&&(this._highlightDescriptor.selectionStart=s):(this._removeHighlight(),this._setHighlighter(this._searchHighlighter.bind(this,this._highlightRegex),s)),this._highlightRange){const e=M.toPos(this._highlightRange);this._searchResultMarker=this._codeMirror.markText(e.start,e.end,{className:"cm-column-with-selection"})}}highlightedRegex(){return this._highlightRegex}highlightSelectedTokens(){delete this._highlightRegex,delete this._highlightRange,this._highlightDescriptor&&this._highlightDescriptor.selectionStart&&this._codeMirror.removeLineClass(this._highlightDescriptor.selectionStart.line,"wrap","cm-line-with-selection"),this._removeHighlight();const e=this._codeMirror.getCursor("start"),t=this._codeMirror.getCursor("end");if(e.line!==t.line)return;if(e.ch===t.ch)return;const i=this._codeMirror.getSelections();if(i.length>1)return;const s=i[0];this._isWord(s,e.line,e.ch,t.ch)&&(e&&this._codeMirror.addLineClass(e.line,"wrap","cm-line-with-selection"),this._setHighlighter(this._tokenHighlighter.bind(this,s,e),e))}_isWord(t,i,s,n){const r=this._codeMirror.getLine(i),o=0===s||!e.Utils.isWordChar(r.charAt(s-1)),h=n===r.length||!e.Utils.isWordChar(r.charAt(n));return o&&h&&e.Utils.isWord(t)}_removeHighlight(){this._highlightDescriptor&&(this._codeMirror.removeOverlay(this._highlightDescriptor.overlay),delete this._highlightDescriptor)}_searchHighlighter(e,t){if(0===t.column()&&delete this._searchMatchLength,this._searchMatchLength){if(this._searchMatchLength>2){for(let e=0;e<this._searchMatchLength-2;++e)t.next();return this._searchMatchLength=1,"search-highlight"}return t.next(),delete this._searchMatchLength,"search-highlight search-highlight-end"}const i=t.string.slice(t.pos).match(e);if(i){if(0===i.index){t.next();const e=i[0].length;return 1===e?"search-highlight search-highlight-full":(this._searchMatchLength=e,"search-highlight search-highlight-start")}t.pos+=i.index}else t.skipToEnd();return null}_tokenHighlighter(t,i,s){const n=t.charAt(0);if(s.match(t)&&(s.eol()||!e.Utils.isWordChar(s.peek())))return s.column()===i.ch?"token-highlight column-with-selection":"token-highlight";let r;do{r=s.next()}while(r&&(e.Utils.isWordChar(r)||s.peek()!==n));return null}_setHighlighter(e,t){const i={token:e};this._codeMirror.addOverlay(i),this._highlightDescriptor={overlay:i,selectionStart:t}}}const D=1e3,V=16,U="CodeMirror-linenumbers";var j=Object.freeze({__proto__:null,SourcesTextEditor:H,Events:N,SourcesTextEditorDelegate:class{populateLineGutterContextMenu(e,t){throw new Error("Not implemented")}populateTextAreaContextMenu(e,t,i){throw new Error("Not implemented")}},_BlockIndentController:k,TokenHighlighter:A,lineNumbersGutterType:U,GutterClickEventData:undefined});const B={source:"Source",prettyPrint:"Pretty print",loading:"Loading…",dSelectionRegions:"{PH1} selection regions",bytecodePositionXs:"Bytecode position `0x`{PH1}",lineSColumnS:"Line {PH1}, Column {PH2}",dCharactersSelected:"{PH1} characters selected",dLinesDCharactersSelected:"{PH1} lines, {PH2} characters selected"},W=n.registerUIStrings("source_frame/SourceFrame.js",B),z=n.getLocalizedString.bind(void 0,W);class G extends o.SimpleView{constructor(e,t){super(z(B.source)),this._lazyContent=e,this._pretty=!1,this._rawContent=null,this._formattedContentPromise=null,this._formattedMap=null,this._prettyToggle=new h.ToolbarToggle(z(B.prettyPrint),"largeicon-pretty-print"),this._prettyToggle.addEventListener(h.ToolbarButton.Events.Click,(()=>{this._setPretty(!this._prettyToggle.toggled())})),this._shouldAutoPrettyPrint=!1,this._prettyToggle.setVisible(!1),this._progressToolbarItem=new h.ToolbarItem(document.createElement("div")),this._textEditor=new H(this,t),this._textEditor.show(this.element),this._prettyCleanGeneration=null,this._cleanGeneration=0,this._searchConfig=null,this._delayedFindSearchMatches=null,this._currentSearchResultIndex=-1,this._searchResults=[],this._searchRegex=null,this._loadError=!1,this._textEditor.addEventListener(N.EditorFocused,this._resetCurrentSearchResultIndex,this),this._textEditor.addEventListener(N.SelectionChanged,this._updateSourcePosition,this),this._textEditor.addEventListener(a.Events.TextChanged,(e=>{this._muteChangeEventsForSetContent||this.onTextChanged(e.data.oldRange,e.data.newRange)})),this._muteChangeEventsForSetContent=!1,this._sourcePosition=new h.ToolbarText,this._searchableView=null,this._editable=!1,this._textEditor.setReadOnly(!0),this._positionToReveal=null,this._lineToScrollTo=null,this._selectionToSet=null,this._loaded=!1,this._contentRequested=!1,this._highlighterType="",this._wasmDisassembly=null}get wasmDisassembly(){return this._wasmDisassembly}editorLocationToUILocation(e,t){return this._wasmDisassembly?(t=this._wasmDisassembly.lineNumberToBytecodeOffset(e),e=0):this._pretty&&([e,t]=this._prettyToRawLocation(e,t)),{lineNumber:e,columnNumber:t}}uiLocationToEditorLocation(e,t=0){return this._wasmDisassembly?(e=this._wasmDisassembly.bytecodeOffsetToLineNumber(t),t=0):this._pretty&&([e,t]=this._rawToPrettyLocation(e,t)),{lineNumber:e,columnNumber:t}}setCanPrettyPrint(e,t){this._shouldAutoPrettyPrint=e&&Boolean(t),this._prettyToggle.setVisible(e)}async _setPretty(e){this._pretty=e,this._prettyToggle.setEnabled(!1);const i=this.loaded,s=this.selection();let n;if(this._pretty){const e=await this._requestFormattedContent();this._formattedMap=e.map,this.setContent(e.content,null),this._prettyCleanGeneration=this._textEditor.markClean();const i=this._rawToPrettyLocation(s.startLine,s.startColumn),r=this._rawToPrettyLocation(s.endLine,s.endColumn);n=new t.TextRange(i[0],i[1],r[0],r[1])}else{this.setContent(this._rawContent,null),this._cleanGeneration=this._textEditor.markClean();const e=this._prettyToRawLocation(s.startLine,s.startColumn),i=this._prettyToRawLocation(s.endLine,s.endColumn);n=new t.TextRange(e[0],e[1],i[0],i[1])}i&&(this.textEditor.revealPosition(n.endLine,n.endColumn,this._editable),this.textEditor.setSelection(n)),this._prettyToggle.setEnabled(!0),this._updatePrettyPrintState()}_updateLineNumberFormatter(){if(this._wasmDisassembly){const e=this._wasmDisassembly,t=e.lineNumberToBytecodeOffset(e.lineNumbers-1).toString(16).length+1;this._textEditor.setLineNumberFormatter((i=>"0x"+e.lineNumberToBytecodeOffset(i-1).toString(16).padStart(t,"0")))}else this._pretty?this._textEditor.setLineNumberFormatter((e=>{const t=this._prettyToRawLocation(e-1,0)[0]+1;return 1===e||t!==this._prettyToRawLocation(e-2,0)[0]+1?String(t):"-"})):this._textEditor.setLineNumberFormatter((e=>String(e)))}_updatePrettyPrintState(){this._prettyToggle.setToggled(this._pretty),this._textEditor.element.classList.toggle("pretty-printed",this._pretty),this._updateLineNumberFormatter()}_prettyToRawLocation(e,t=0){return this._formattedMap?this._formattedMap.formattedToOriginal(e,t):[e,t]}_rawToPrettyLocation(e,t){return this._formattedMap?this._formattedMap.originalToFormatted(e,t):[e,t]}setEditable(e){this._editable=e,this._loaded&&this._textEditor.setReadOnly(!e)}hasLoadError(){return this._loadError}wasShown(){this._ensureContentLoaded(),this._wasShownOrLoaded()}willHide(){super.willHide(),this._clearPositionToReveal()}async toolbarItems(){return[this._prettyToggle,this._sourcePosition,this._progressToolbarItem]}get loaded(){return this._loaded}get textEditor(){return this._textEditor}get pretty(){return this._pretty}async _ensureContentLoaded(){if(!this._contentRequested){this._contentRequested=!0;const t=new l.ProgressIndicator;t.setTitle(z(B.loading)),t.setTotalWork(100),this._progressToolbarItem.element.appendChild(t.element);const i=await this._lazyContent();let s,n;if(null===i.content?(s=i.error,this._rawContent=i.error):(n=i.content,this._rawContent=i.content),t.setWorked(1),!s&&"application/wasm"===this._highlighterType){const e=f.WorkerWrapper.fromURL(new URL("../wasmparser_worker/wasmparser_worker-entrypoint.js",import.meta.url)),i=new Promise(((i,s)=>{e.onmessage=({data:e})=>{if("event"in e)switch(e.event){case"progress":t.setWorked(e.params.percentage)}else if("method"in e)switch(e.method){case"disassemble":"error"in e?s(e.error):"result"in e&&i(e.result)}},e.onerror=s}));e.postMessage({method:"disassemble",params:{content:n}});try{const{source:t,offsets:s,functionBodyOffsets:r}=await i;this._rawContent=n=t,this._wasmDisassembly=new x.WasmDisassembly(s,r)}catch(e){this._rawContent=n=s=e.message}finally{e.terminate()}}t.setWorked(100),t.done(),this._formattedContentPromise=null,this._formattedMap=null,this._prettyToggle.setEnabled(!0),s?(this.setContent(null,s),this._prettyToggle.setEnabled(!1),setTimeout((()=>this.setHighlighterType("text/plain")),50)):this._shouldAutoPrettyPrint&&e.isMinified(n)?await this._setPretty(!0):this.setContent(this._rawContent,null)}}_requestFormattedContent(){if(this._formattedContentPromise)return this._formattedContentPromise;let e;return this._formattedContentPromise=new Promise((t=>{e=t})),new y.ScriptFormatter(this._highlighterType,this._rawContent||"",(async(t,i)=>{e({content:t,map:i})})),this._formattedContentPromise}revealPosition(e,t,i){this._lineToScrollTo=null,this._selectionToSet=null,this._positionToReveal={line:e,column:t,shouldHighlight:i},this._innerRevealPositionIfNeeded()}_innerRevealPositionIfNeeded(){if(!this._positionToReveal)return;if(!this.loaded||!this.isShowing())return;const{lineNumber:e,columnNumber:t}=this.uiLocationToEditorLocation(this._positionToReveal.line,this._positionToReveal.column);this._textEditor.revealPosition(e,t,this._positionToReveal.shouldHighlight),this._positionToReveal=null}_clearPositionToReveal(){this._textEditor.clearPositionHighlight(),this._positionToReveal=null}scrollToLine(e){this._clearPositionToReveal(),this._lineToScrollTo=e,this._innerScrollToLineIfNeeded()}_innerScrollToLineIfNeeded(){null!==this._lineToScrollTo&&this.loaded&&this.isShowing()&&(this._textEditor.scrollToLine(this._lineToScrollTo),this._lineToScrollTo=null)}selection(){return this.textEditor.selection()}setSelection(e){this._selectionToSet=e,this._innerSetSelectionIfNeeded()}_innerSetSelectionIfNeeded(){this._selectionToSet&&this.loaded&&this.isShowing()&&(this._textEditor.setSelection(this._selectionToSet,!0),this._selectionToSet=null)}_wasShownOrLoaded(){this._innerRevealPositionIfNeeded(),this._innerSetSelectionIfNeeded(),this._innerScrollToLineIfNeeded()}onTextChanged(e,t){const i=this.pretty;this._pretty=null!==this._prettyCleanGeneration&&this.textEditor.isClean(this._prettyCleanGeneration),this._pretty!==i&&this._updatePrettyPrintState(),this._prettyToggle.setEnabled(this.isClean()),this._searchConfig&&this._searchableView&&this.performSearch(this._searchConfig,!1,!1)}isClean(){return this.textEditor.isClean(this._cleanGeneration)||null!==this._prettyCleanGeneration&&this.textEditor.isClean(this._prettyCleanGeneration)}contentCommitted(){this._cleanGeneration=this._textEditor.markClean(),this._prettyCleanGeneration=null,this._rawContent=this.textEditor.text(),this._formattedMap=null,this._formattedContentPromise=null,this._pretty&&(this._pretty=!1,this._updatePrettyPrintState()),this._prettyToggle.setEnabled(!0)}_simplifyMimeType(e,t){return t?t.indexOf("typescript")>=0?"text/typescript-jsx":t.indexOf("javascript")>=0||t.indexOf("jscript")>=0||t.indexOf("ecmascript")>=0?"text/jsx":"text/x-php"===t&&e.match(/\<\?.*\?\>/g)?"application/x-httpd-php":"application/wasm"===t?"text/webassembly":t:""}setHighlighterType(e){this._highlighterType=e,this._updateHighlighterType("")}highlighterType(){return this._highlighterType}_updateHighlighterType(e){this._textEditor.setMimeType(this._simplifyMimeType(e,this._highlighterType))}setContent(e,t){if(this._muteChangeEventsForSetContent=!0,this._loaded){const t=this._textEditor.scrollTop(),i=this._textEditor.selection();this._textEditor.setText(e||""),this._textEditor.setScrollTop(t),this._textEditor.setSelection(i)}else this._loaded=!0,t?(this._textEditor.setText(t||""),this._highlighterType="text/plain",this._textEditor.setReadOnly(!0),this._loadError=!0):(this._textEditor.setText(e||""),this._cleanGeneration=this._textEditor.markClean(),this._textEditor.setReadOnly(!this._editable),this._loadError=!1);if(this._wasmDisassembly)for(const e of this._wasmDisassembly.nonBreakableLineNumbers())this._textEditor.toggleLineClass(e,"cm-non-breakable-line",!0);this._updateLineNumberFormatter(),this._updateHighlighterType(e||""),this._wasShownOrLoaded(),this._delayedFindSearchMatches&&(this._delayedFindSearchMatches(),this._delayedFindSearchMatches=null),this._muteChangeEventsForSetContent=!1}setSearchableView(e){this._searchableView=e}_doFindSearchMatches(e,t,i){this._currentSearchResultIndex=-1,this._searchResults=[];const s=e.toSearchRegex();this._searchRegex=s,this._searchResults=this._collectRegexMatches(s),this._searchableView&&this._searchableView.updateSearchMatchesCount(this._searchResults.length),this._searchResults.length?t&&i?this.jumpToPreviousSearchResult():t?this.jumpToNextSearchResult():this._textEditor.highlightSearchResults(s,null):this._textEditor.cancelSearchResultsHighlight()}performSearch(e,t,i){this._searchableView&&this._searchableView.updateSearchMatchesCount(0),this._resetSearch(),this._searchConfig=e,this.loaded?this._doFindSearchMatches(e,t,Boolean(i)):this._delayedFindSearchMatches=this._doFindSearchMatches.bind(this,e,t,Boolean(i)),this._ensureContentLoaded()}_resetCurrentSearchResultIndex(){this._searchResults.length&&(this._currentSearchResultIndex=-1,this._searchableView&&this._searchableView.updateCurrentMatchIndex(this._currentSearchResultIndex),this._textEditor.highlightSearchResults(this._searchRegex,null))}_resetSearch(){this._searchConfig=null,this._delayedFindSearchMatches=null,this._currentSearchResultIndex=-1,this._searchResults=[],this._searchRegex=null}searchCanceled(){const e=-1!==this._currentSearchResultIndex?this._searchResults[this._currentSearchResultIndex]:null;this._resetSearch(),this.loaded&&(this._textEditor.cancelSearchResultsHighlight(),e&&this.setSelection(e))}jumpToLastSearchResult(){this.jumpToSearchResult(this._searchResults.length-1)}_searchResultIndexForCurrentSelection(){return T.lowerBound(this._searchResults,this._textEditor.selection().collapseToEnd(),t.TextRange.comparator)}jumpToNextSearchResult(){const e=this._searchResultIndexForCurrentSelection(),t=-1===this._currentSearchResultIndex?e:e+1;this.jumpToSearchResult(t)}jumpToPreviousSearchResult(){const e=this._searchResultIndexForCurrentSelection();this.jumpToSearchResult(e-1)}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!0}jumpToSearchResult(e){this.loaded&&this._searchResults.length&&(this._currentSearchResultIndex=(e+this._searchResults.length)%this._searchResults.length,this._searchableView&&this._searchableView.updateCurrentMatchIndex(this._currentSearchResultIndex),this._textEditor.highlightSearchResults(this._searchRegex,this._searchResults[this._currentSearchResultIndex]))}replaceSelectionWith(e,t){const i=this._searchResults[this._currentSearchResultIndex];if(!i)return;this._textEditor.highlightSearchResults(this._searchRegex,null);const s=this._textEditor.text(i),n=e.toSearchRegex();let r;r=n.__fromRegExpQuery?s.replace(n,t):s.replace(n,(function(){return t}));const o=this._textEditor.editRange(i,r);this._textEditor.setSelection(o.collapseToEnd())}replaceAllWith(e,i){this._resetCurrentSearchResultIndex();let s=this._textEditor.text();const n=this._textEditor.fullRange(),r=e.toSearchRegex(!0);s=r.__fromRegExpQuery?s.replace(r,i):s.replace(r,(function(){return i}));const o=this._collectRegexMatches(r);if(!o.length)return;const h=T.lowerBound(o,this._textEditor.selection(),t.TextRange.comparator),a=o[E.mod(h-1,o.length)],l=b.findLineEndingIndexes(i),c=l.length,d=a.startLine+l.length-1;let u=a.startColumn;l.length>1&&(u=l[c-1]-l[c-2]-1),this._textEditor.editRange(n,s),this._textEditor.revealPosition(d,u),this._textEditor.setSelection(t.TextRange.createFromLocation(d,u))}_collectRegexMatches(e){const i=[];for(let s=0;s<this._textEditor.linesCount;++s){let n,r=this._textEditor.line(s),o=0;do{if(n=e.exec(r),n){const e=n.index+Math.max(n[0].length,1);n[0].length&&i.push(new t.TextRange(s,o+n.index,s,o+e)),o+=e,r=r.substring(e)}}while(n&&r)}return i}populateLineGutterContextMenu(e,t){return Promise.resolve()}populateTextAreaContextMenu(e,t,i){return Promise.resolve()}canEditSource(){return this._editable}_updateSourcePosition(){const e=this._textEditor.selections();if(!e.length)return;if(e.length>1)return void this._sourcePosition.setText(z(B.dSelectionRegions,{PH1:e.length}));let t=e[0];if(t.isEmpty()){const e=this._prettyToRawLocation(t.endLine,t.endColumn);if(this._wasmDisassembly){const t=this._wasmDisassembly,i=t.lineNumberToBytecodeOffset(t.lineNumbers-1).toString(16).length,s=t.lineNumberToBytecodeOffset(e[0]);this._sourcePosition.setText(z(B.bytecodePositionXs,{PH1:s.toString(16).padStart(i,"0")}))}else this._textEditor.revealPosition(e[0],e[1],!this.canEditSource()),this._sourcePosition.setText(z(B.lineSColumnS,{PH1:e[0]+1,PH2:e[1]+1}));return}t=t.normalize();const i=this._textEditor.text(t);t.startLine===t.endLine?this._sourcePosition.setText(z(B.dCharactersSelected,{PH1:i.length})):this._sourcePosition.setText(z(B.dLinesDCharactersSelected,{PH1:t.endLine-t.startLine+1,PH2:i.length}))}}const J=[];var q=Object.freeze({__proto__:null,UIStrings:B,SourceFrameImpl:G,LineDecorator:class{decorate(e,t,i){}},Transformer:class{editorLocationToUILocation(e,t){throw new Error("Not implemented")}uiLocationToEditorLocation(e,t){throw new Error("Not implemented")}},registerLineDecorator:function(e){J.push(e)},getRegisteredLineDecorators:function(){return J},DecoratorType:{PERFORMANCE:"performance",MEMORY:"memory",COVERAGE:"coverage"},LineDecoratorRegistration:undefined});const X={find:"Find"},K=n.registerUIStrings("source_frame/ResourceSourceFrame.js",X),Q=n.getLocalizedString.bind(void 0,K);class Y extends G{constructor(e,t,i){super((async()=>{let t=(await e.requestContent()).content||"";return await e.contentEncoded()&&(t=window.atob(t)),{content:t,isEncoded:!1}}),i),this._resource=e,this.setCanPrettyPrint(this._resource.contentType().isDocumentOrScriptOrStyleSheet(),t)}static createSearchableView(e,t,i){return new Z(e,t,i)}get resource(){return this._resource}populateTextAreaContextMenu(e,t,i){return e.appendApplicableItems(this._resource),Promise.resolve()}}class Z extends c.VBox{constructor(e,t,i){super(!0),this.registerRequiredCSS("source_frame/resourceSourceFrame.css",{enableLegacyPatching:!0});const s=new Y(e,i);this._sourceFrame=s,s.setHighlighterType(t);const n=new d.SearchableView(s,s);n.element.classList.add("searchable-view"),n.setPlaceholder(Q(X.find)),s.show(n.element),s.setSearchableView(n),n.show(this.contentElement);const r=new h.Toolbar("toolbar",this.contentElement);s.toolbarItems().then((e=>{e.map((e=>r.appendToolbarItem(e)))}))}async revealPosition(e,t){this._sourceFrame.revealPosition(e,t,!0)}}var $=Object.freeze({__proto__:null,UIStrings:X,ResourceSourceFrame:Y,SearchableContainer:Z});class ee{constructor(e,t,i){this._base64content=e,this._contentUrl=t,this._resourceType=i,this._arrayPromise=null,this._hexPromise=null,this._utf8Promise=null}async _fetchContentAsArray(){return this._arrayPromise||(this._arrayPromise=new Promise((async e=>{const t=await fetch("data:;base64,"+this._base64content);e(new Uint8Array(await t.arrayBuffer()))}))),await this._arrayPromise}async hex(){if(!this._hexPromise){const e=await this._fetchContentAsArray();return{content:ee.uint8ArrayToHexString(e),isEncoded:!1}}return this._hexPromise}async base64(){return{content:this._base64content,isEncoded:!0}}async utf8(){return this._utf8Promise||(this._utf8Promise=new Promise((async e=>{const t=await this._fetchContentAsArray();e({content:new TextDecoder("utf8").decode(t),isEncoded:!1})}))),this._utf8Promise}createBase64View(){return new Y(i.StaticContentProvider.fromString(this._contentUrl,this._resourceType,this._base64content),!1,{lineNumbers:!1,lineWrapping:!0})}createHexView(){const e=new i.StaticContentProvider(this._contentUrl,this._resourceType,(async()=>{const e=await this._fetchContentAsArray();return{content:ee.uint8ArrayToHexViewer(e),isEncoded:!1}}));return new Y(e,!1,{lineNumbers:!1,lineWrapping:!1})}createUtf8View(){const e=this.utf8.bind(this),t=new i.StaticContentProvider(this._contentUrl,this._resourceType,e);return new Y(t,!1,{lineNumbers:!0,lineWrapping:!0})}static uint8ArrayToHexString(e){let t="";for(let i=0;i<e.length;i++)t+=ee.numberToHex(e[i],2);return t}static numberToHex(e,t){let i=e.toString(16);for(;i.length<t;)i="0"+i;return i}static uint8ArrayToHexViewer(e){let t="",i=0;for(;16*i<e.length;){const s=e.slice(16*i,16*(i+1));t+=ee.numberToHex(i,8)+":";let n=0;for(let e=0;e<s.length;e++)e%2==0&&(t+=" ",n++),t+=ee.numberToHex(s[e],2),n+=2;for(;n<42;)t+=" ",n++;for(let e=0;e<s.length;e++){const i=s[e];t+=i>=32&&i<=126?String.fromCharCode(i):"."}t+="\n",i++}return t}}var te=Object.freeze({__proto__:null,BinaryResourceViewFactory:ee});const ie={font:"Font",previewOfFontFromS:"Preview of font from {PH1}"},se=n.registerUIStrings("source_frame/FontView.js",ie),ne=n.getLocalizedString.bind(void 0,se);class re extends o.SimpleView{constructor(e,t){super(ne(ie.font)),this.registerRequiredCSS("source_frame/fontView.css",{enableLegacyPatching:!1}),this.element.classList.add("font-view"),this._url=t.contentURL(),u.setAccessibleName(this.element,ne(ie.previewOfFontFromS,{PH1:this._url})),this._mimeType=e,this._contentProvider=t,this._mimeTypeLabel=new h.ToolbarText(e),this.fontPreviewElement,this._dummyElement,this.fontStyleElement,this._inResize}async toolbarItems(){return[this._mimeTypeLabel]}_onFontContentLoaded(e,t){const{content:i}=t,n=i?s.contentAsDataURL(i,this._mimeType,!0):this._url;this.fontStyleElement&&(this.fontStyleElement.textContent=b.sprintf('@font-face { font-family: "%s"; src: url(%s); }',e,n),this.updateFontPreviewSize())}_createContentIfNeeded(){if(this.fontPreviewElement)return;const e="WebInspectorFontPreview"+ ++oe;this.fontStyleElement=document.createElement("style"),this._contentProvider.requestContent().then((t=>{this._onFontContentLoaded(e,t)})),this.element.appendChild(this.fontStyleElement);const t=document.createElement("div");for(let e=0;e<he.length;++e)e>0&&t.createChild("br"),_.createTextChild(t,he[e]);this.fontPreviewElement=t.cloneNode(!0),this.fontPreviewElement&&(u.markAsHidden(this.fontPreviewElement),this.fontPreviewElement.style.overflow="hidden",this.fontPreviewElement.style.setProperty("font-family",e),this.fontPreviewElement.style.setProperty("visibility","hidden"),this._dummyElement=t,this._dummyElement.style.visibility="hidden",this._dummyElement.style.zIndex="-1",this._dummyElement.style.display="inline",this._dummyElement.style.position="absolute",this._dummyElement.style.setProperty("font-family",e),this._dummyElement.style.setProperty("font-size",ae+"px"),this.element.appendChild(this.fontPreviewElement))}wasShown(){this._createContentIfNeeded(),this.updateFontPreviewSize()}onResize(){if(!this._inResize){this._inResize=!0;try{this.updateFontPreviewSize()}finally{this._inResize=null}}}_measureElement(){if(!this._dummyElement)throw new Error("No font preview loaded");this.element.appendChild(this._dummyElement);const e={width:this._dummyElement.offsetWidth,height:this._dummyElement.offsetHeight};return this.element.removeChild(this._dummyElement),e}updateFontPreviewSize(){if(!this.fontPreviewElement||!this.isShowing())return;this.fontPreviewElement.style.removeProperty("visibility");const e=this._measureElement(),t=e.height,i=e.width,s=this.element.offsetWidth-50,n=this.element.offsetHeight-30;if(!(t&&i&&s&&n))return void this.fontPreviewElement.style.removeProperty("font-size");const r=s/i,o=n/t,h=Math.floor(ae*Math.min(r,o))-2;this.fontPreviewElement.style.setProperty("font-size",h+"px",void 0)}}let oe=0;const he=["ABCDEFGHIJKLM","NOPQRSTUVWXYZ","abcdefghijklm","nopqrstuvwxyz","1234567890"],ae=50;var le=Object.freeze({__proto__:null,UIStrings:ie,FontView:re});const ce={image:"Image",dropImageFileHere:"Drop image file here",imageFromS:"Image from {PH1}",dD:"{PH1} × {PH2}",copyImageUrl:"Copy image URL",copyImageAsDataUri:"Copy image as data URI",openImageInNewTab:"Open image in new tab",saveImageAs:"Save image as...",download:"download"},de=n.registerUIStrings("source_frame/ImageView.js",ce),ue=n.getLocalizedString.bind(void 0,de);class _e extends o.SimpleView{constructor(e,t){super(ue(ce.image)),this.registerRequiredCSS("source_frame/imageView.css",{enableLegacyPatching:!1}),this.element.tabIndex=-1,this.element.classList.add("image-view"),this._url=t.contentURL(),this._parsedURL=new w.ParsedURL(this._url),this._mimeType=e,this._contentProvider=t,this._uiSourceCode=t instanceof R.UISourceCode?t:null,this._uiSourceCode&&(this._uiSourceCode.addEventListener(R.Events.WorkingCopyCommitted,this._workingCopyCommitted,this),new g.DropTarget(this.element,[g.Type.ImageFile,g.Type.URI],ue(ce.dropImageFileHere),this._handleDrop.bind(this))),this._sizeLabel=new h.ToolbarText,this._dimensionsLabel=new h.ToolbarText,this._mimeTypeLabel=new h.ToolbarText(e),this._container=this.element.createChild("div","image"),this._imagePreviewElement=this._container.createChild("img","resource-image-view"),this._imagePreviewElement.addEventListener("contextmenu",this._contextMenu.bind(this),!0)}async toolbarItems(){return await this._updateContentIfNeeded(),[this._sizeLabel,new h.ToolbarSeparator,this._dimensionsLabel,new h.ToolbarSeparator,this._mimeTypeLabel]}wasShown(){this._updateContentIfNeeded()}disposeView(){this._uiSourceCode&&this._uiSourceCode.removeEventListener(R.Events.WorkingCopyCommitted,this._workingCopyCommitted,this)}_workingCopyCommitted(){this._updateContentIfNeeded()}async _updateContentIfNeeded(){const{content:e}=await this._contentProvider.requestContent();if(this._cachedContent===e)return;const t=await this._contentProvider.contentEncoded();this._cachedContent=e;const i=s.contentAsDataURL(e,this._mimeType,t)||this._url,n=new Promise((e=>{this._imagePreviewElement.onload=e}));this._imagePreviewElement.src=i,this._imagePreviewElement.alt=ue(ce.imageFromS,{PH1:this._url});const r=e&&!t?e.length:base64ToSize(e);this._sizeLabel.setText(E.bytesToString(r)),await n,this._dimensionsLabel.setText(ue(ce.dD,{PH1:this._imagePreviewElement.naturalWidth,PH2:this._imagePreviewElement.naturalHeight}))}_contextMenu(e){const t=new r.ContextMenu(e),i=new w.ParsedURL(this._imagePreviewElement.src);this._parsedURL.isDataURL()||t.clipboardSection().appendItem(ue(ce.copyImageUrl),this._copyImageURL.bind(this)),i.isDataURL()&&t.clipboardSection().appendItem(ue(ce.copyImageAsDataUri),this._copyImageAsDataURL.bind(this)),t.clipboardSection().appendItem(ue(ce.openImageInNewTab),this._openInNewTab.bind(this)),t.clipboardSection().appendItem(ue(ce.saveImageAs),(async()=>{await this._saveImage()})),t.show()}_copyImageAsDataURL(){L.InspectorFrontendHostInstance.copyText(this._imagePreviewElement.src)}_copyImageURL(){L.InspectorFrontendHostInstance.copyText(this._url)}async _saveImage(){const e=await this._contentProvider.contentEncoded();if(!this._cachedContent)return;const t=this._cachedContent,i=s.contentAsDataURL(t,this._mimeType,e,"",!1);if(!i)return;const n=document.createElement("a");n.href=i,n.download=this._parsedURL.isDataURL()?ue(ce.download):decodeURIComponent(this._parsedURL.displayName),n.click(),n.remove()}_openInNewTab(){L.InspectorFrontendHostInstance.openInNewTab(this._url)}async _handleDrop(e){const t=e.items;if(!t.length||"file"!==t[0].kind)return;const i=t[0].webkitGetAsEntry(),s=!i.name.endsWith(".svg");i.file((e=>{const t=new FileReader;t.onloadend=()=>{let e;try{e=t.result}catch(t){e=null,console.error("Can't read file: "+t)}"string"==typeof e&&this._uiSourceCode&&this._uiSourceCode.setContent(s?btoa(e):e,s)},s?t.readAsBinaryString(e):t.readAsText(e)}))}}var ge=Object.freeze({__proto__:null,UIStrings:ce,ImageView:_e});const me={find:"Find"},pe=n.registerUIStrings("source_frame/JSONView.js",me),Se=n.getLocalizedString.bind(void 0,pe);class fe extends c.VBox{constructor(e,t){super(),this._initialized=!1,this.registerRequiredCSS("source_frame/jsonView.css",{enableLegacyPatching:!1}),this._parsedJSON=e,this._startCollapsed=Boolean(t),this.element.classList.add("json-view"),this._searchableView,this._treeOutline,this._currentSearchFocusIndex=0,this._currentSearchTreeElements=[],this._searchRegex=null}static async createView(e){const t=await fe._parseJSON(e);if(!t||"object"!=typeof t.data)return null;const i=new fe(t),s=new d.SearchableView(i,null);return s.setPlaceholder(Se(me.find)),i._searchableView=s,i.show(s.element),s}static createViewSync(e){const t=new fe(new xe(e,"","")),i=new d.SearchableView(t,null);return i.setPlaceholder(Se(me.find)),t._searchableView=i,t.show(i.element),t.element.tabIndex=0,i}static _parseJSON(e){let t=null;if(e&&(t=fe._extractJSON(e)),!t)return Promise.resolve(null);try{const e=JSON.parse(t.data);if(!e)return Promise.resolve(null);t.data=e}catch(e){t=null}return Promise.resolve(t)}static _extractJSON(e){if(e.startsWith("<"))return null;let t=fe._findBrackets(e,"{","}");const i=fe._findBrackets(e,"[","]");if(t=i.length>t.length?i:t,-1===t.length||e.length-t.length>80)return null;const s=e.substring(0,t.start),n=e.substring(t.end+1);return e=e.substring(t.start,t.end+1),!n.trim().length||n.trim().startsWith(")")&&s.trim().endsWith("(")?new xe(e,s,n):null}static _findBrackets(e,t,i){const s=e.indexOf(t),n=e.lastIndexOf(i);let r=n-s-1;return(-1===s||-1===n||n<s)&&(r=-1),{start:s,end:n,length:r}}wasShown(){this._initialize()}_initialize(){if(this._initialized)return;this._initialized=!0;const e=I.RemoteObject.fromLocalObject(this._parsedJSON.data),t=this._parsedJSON.prefix+e.description+this._parsedJSON.suffix;this._treeOutline=new P.ObjectPropertiesSection(e,t,void 0,void 0,void 0,void 0,!0),this._treeOutline.enableContextMenu(),this._treeOutline.setEditable(!1),this._startCollapsed||this._treeOutline.expand(),this.element.appendChild(this._treeOutline.element);const i=this._treeOutline.firstChild();i&&i.select(!0,!1)}_jumpToMatch(e){if(!this._searchRegex)return;const t=this._currentSearchTreeElements[this._currentSearchFocusIndex];t&&t.setSearchRegex(this._searchRegex);const i=this._currentSearchTreeElements[e];i?(this._updateSearchIndex(e),i.setSearchRegex(this._searchRegex,_.highlightedCurrentSearchResultClassName),i.reveal()):this._updateSearchIndex(0)}_updateSearchCount(e){this._searchableView&&this._searchableView.updateSearchMatchesCount(e)}_updateSearchIndex(e){this._currentSearchFocusIndex=e,this._searchableView&&this._searchableView.updateCurrentMatchIndex(e)}searchCanceled(){let e;for(this._searchRegex=null,this._currentSearchTreeElements=[],e=this._treeOutline.rootElement();e;e=e.traverseNextTreeElement(!1))e instanceof P.ObjectPropertyTreeElement&&e.revertHighlightChanges();this._updateSearchCount(0),this._updateSearchIndex(0)}performSearch(e,t,i){let s=this._currentSearchFocusIndex;const n=this._currentSearchTreeElements[s];let r;for(this.searchCanceled(),this._searchRegex=e.toSearchRegex(!0),r=this._treeOutline.rootElement();r;r=r.traverseNextTreeElement(!1)){if(!(r instanceof P.ObjectPropertyTreeElement))continue;const e=r.setSearchRegex(this._searchRegex);if(e&&this._currentSearchTreeElements.push(r),n===r){const t=this._currentSearchTreeElements.length-1;s=e||i?t:t+1}}this._updateSearchCount(this._currentSearchTreeElements.length),this._currentSearchTreeElements.length?(s=E.mod(s,this._currentSearchTreeElements.length),this._jumpToMatch(s)):this._updateSearchIndex(-1)}jumpToNextSearchResult(){if(!this._currentSearchTreeElements.length)return;const e=E.mod(this._currentSearchFocusIndex+1,this._currentSearchTreeElements.length);this._jumpToMatch(e)}jumpToPreviousSearchResult(){if(!this._currentSearchTreeElements.length)return;const e=E.mod(this._currentSearchFocusIndex-1,this._currentSearchTreeElements.length);this._jumpToMatch(e)}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!0}}class xe{constructor(e,t,i){this.data=e,this.prefix=t,this.suffix=i}}var we=Object.freeze({__proto__:null,UIStrings:me,JSONView:fe,ParsedJSON:xe});const Ce={find:"Find"},ye=n.registerUIStrings("source_frame/XMLView.js",Ce),Te=n.getLocalizedString.bind(void 0,ye);class Ee extends c.Widget{constructor(e){super(!0),this.registerRequiredCSS("source_frame/xmlView.css",{enableLegacyPatching:!1}),this.contentElement.classList.add("shadow-xml-view","source-code"),this._treeOutline=new m.TreeOutlineInShadow,this._treeOutline.registerRequiredCSS("source_frame/xmlTree.css",{enableLegacyPatching:!0}),this.contentElement.appendChild(this._treeOutline.element),this._searchableView,this._currentSearchFocusIndex=0,this._currentSearchTreeElements=[],this._searchConfig,be.populate(this._treeOutline,e,this);const t=this._treeOutline.firstChild();t&&t.select(!0,!1)}static createSearchableView(e){const t=new Ee(e),i=new d.SearchableView(t,null);return i.setPlaceholder(Te(Ce.find)),t._searchableView=i,t.show(i.element),i}static parseXML(e,t){let i;try{switch(t){case"application/xhtml+xml":case"application/xml":case"image/svg+xml":case"text/html":case"text/xml":i=(new DOMParser).parseFromString(e,t)}}catch(e){return null}return!i||i.body?null:i}_jumpToMatch(e,t){if(!this._searchConfig)return;const i=this._searchConfig.toSearchRegex(!0),s=this._currentSearchTreeElements[this._currentSearchFocusIndex];s&&s.setSearchRegex(i);const n=this._currentSearchTreeElements[e];n?(this._updateSearchIndex(e),t&&n.reveal(!0),n.setSearchRegex(i,_.highlightedCurrentSearchResultClassName)):this._updateSearchIndex(0)}_updateSearchCount(e){this._searchableView&&this._searchableView.updateSearchMatchesCount(e)}_updateSearchIndex(e){this._currentSearchFocusIndex=e,this._searchableView&&this._searchableView.updateCurrentMatchIndex(e)}_innerPerformSearch(e,t){if(!this._searchConfig)return;let i=this._currentSearchFocusIndex;const s=this._currentSearchTreeElements[i];this._innerSearchCanceled(),this._currentSearchTreeElements=[];const n=this._searchConfig.toSearchRegex(!0);for(let e=this._treeOutline.rootElement();e;e=e.traverseNextTreeElement(!1)){if(!(e instanceof be))continue;const r=e.setSearchRegex(n);if(r&&this._currentSearchTreeElements.push(e),s===e){const e=this._currentSearchTreeElements.length-1;i=r||t?e:e+1}}this._updateSearchCount(this._currentSearchTreeElements.length),this._currentSearchTreeElements.length?(i=E.mod(i,this._currentSearchTreeElements.length),this._jumpToMatch(i,e)):this._updateSearchIndex(0)}_innerSearchCanceled(){for(let e=this._treeOutline.rootElement();e;e=e.traverseNextTreeElement(!1))e instanceof be&&e.revertHighlightChanges();this._updateSearchCount(0),this._updateSearchIndex(0)}searchCanceled(){this._searchConfig=null,this._currentSearchTreeElements=[],this._innerSearchCanceled()}performSearch(e,t,i){this._searchConfig=e,this._innerPerformSearch(t,i)}jumpToNextSearchResult(){if(!this._currentSearchTreeElements.length)return;const e=E.mod(this._currentSearchFocusIndex+1,this._currentSearchTreeElements.length);this._jumpToMatch(e,!0)}jumpToPreviousSearchResult(){if(!this._currentSearchTreeElements.length)return;const e=E.mod(this._currentSearchFocusIndex-1,this._currentSearchTreeElements.length);this._jumpToMatch(e,!0)}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!0}}class be extends m.TreeElement{constructor(e,t,i){super("",!t&&"childElementCount"in e&&Boolean(e.childElementCount)),this._node=e,this._closeTag=t,this.selectable=!0,this._highlightChanges=[],this._xmlView=i,this._updateTitle()}static populate(e,t,i){if(!(t instanceof Node))return;let s=t.firstChild;for(;s;){const t=s;s=s.nextSibling;const n=t.nodeType;3===n&&t.nodeValue&&t.nodeValue.match(/\s+/)||(1!==n&&3!==n&&4!==n&&7!==n&&8!==n||e.appendChild(new be(t,!1,i)))}}setSearchRegex(e,i){if(this.revertHighlightChanges(),!e)return!1;if(this._closeTag&&this.parent&&!this.parent.expanded)return!1;e.lastIndex=0;let s=_.highlightedSearchResultClassName;if(i&&(s+=" "+i),!this.listItemElement.textContent)return!1;const n=this.listItemElement.textContent.replace(/\xA0/g," ");let r=e.exec(n);const o=[];for(;r;)o.push(new t.SourceRange(r.index,r[0].length)),r=e.exec(n);return o.length&&_.highlightRangesWithStyleClass(this.listItemElement,o,s,this._highlightChanges),Boolean(this._highlightChanges.length)}revertHighlightChanges(){_.revertDomChanges(this._highlightChanges),this._highlightChanges=[]}_updateTitle(){const e=this._node;if("nodeType"in e)switch(e.nodeType){case 1:if(e instanceof Element){const t=e.tagName;if(this._closeTag)return void this._setTitle(["</"+t+">","shadow-xml-view-tag"]);const i=["<"+t,"shadow-xml-view-tag"],s=e.attributes;for(let e=0;e<s.length;++e){const t=s.item(e);if(!t)return;i.push(" ","shadow-xml-view-tag",t.name,"shadow-xml-view-attribute-name",'="',"shadow-xml-view-tag",t.value,"shadow-xml-view-attribute-value",'"',"shadow-xml-view-tag")}return this.expanded||(e.childElementCount?i.push(">","shadow-xml-view-tag","…","shadow-xml-view-comment","</"+t,"shadow-xml-view-tag"):e.textContent?i.push(">","shadow-xml-view-tag",e.textContent,"shadow-xml-view-text","</"+t,"shadow-xml-view-tag"):i.push(" /","shadow-xml-view-tag")),i.push(">","shadow-xml-view-tag"),void this._setTitle(i)}return;case 3:return void(e.nodeValue&&this._setTitle([e.nodeValue,"shadow-xml-view-text"]));case 4:return void(e.nodeValue&&this._setTitle(["<![CDATA[","shadow-xml-view-cdata",e.nodeValue,"shadow-xml-view-text","]]>","shadow-xml-view-cdata"]));case 7:return void(e.nodeValue&&this._setTitle(["<?"+e.nodeName+" "+e.nodeValue+"?>","shadow-xml-view-processing-instruction"]));case 8:return void this._setTitle(["\x3c!--"+e.nodeValue+"--\x3e","shadow-xml-view-comment"])}}_setTitle(e){const t=document.createDocumentFragment();for(let i=0;i<e.length;i+=2)t.createChild("span",e[i+1]).textContent=e[i];this.title=t,this._xmlView._innerPerformSearch(!1,!1)}onattach(){this.listItemElement.classList.toggle("shadow-xml-view-close-tag",this._closeTag)}onexpand(){this._updateTitle()}oncollapse(){this._updateTitle()}async onpopulate(){be.populate(this,this._node,this._xmlView),this.appendChild(new be(this._node,!0,this._xmlView))}}var ve=Object.freeze({__proto__:null,UIStrings:Ce,XMLView:Ee,XMLViewNode:be});const Me={nothingToPreview:"Nothing to preview"},Le=n.registerUIStrings("source_frame/PreviewFactory.js",Me),Re=n.getLocalizedString.bind(void 0,Le);var Pe=Object.freeze({__proto__:null,UIStrings:Me,PreviewFactory:class{static async createPreview(e,t){let i=C.ResourceType.fromMimeType(t);switch(i===C.resourceTypes.Other&&(i=e.contentType()),i){case C.resourceTypes.Image:return new _e(t,e);case C.resourceTypes.Font:return new re(t,e)}const s=await e.requestContent();if(null===s.content)return new p.EmptyWidget(s.error);if(!s.content)return new p.EmptyWidget(Re(Me.nothingToPreview));let n=s.content;await e.contentEncoded()&&(n=window.atob(n));const r=Ee.parseXML(n,t);if(r)return Ee.createSearchableView(r);const o=await fe.createView(n);if(o)return o;if(i.isTextType()){const i=t.replace(/;.*/,"")||e.contentType().canonicalMimeType();return Y.createSearchableView(e,i,!0)}return null}}});class Ie{constructor(e){this._textEditor=e,this._animatedLines=[],this._animationTimeout=null}highlightModifiedLines(e,t){if("string"!=typeof e||"string"!=typeof t)return;const i=Ie.computeDiff(O.DiffWrapper.lineDiff(e.split("\n"),t.split("\n"))),s=[];for(let e=0;e<i.length;++e){const t=i[e];if(t.type!==Oe.Delete)for(let e=t.from;e<t.to;++e){const t=this._textEditor.textEditorPositionHandle(e,0);t&&s.push(t)}}this._updateHighlightedLines(s),this._animationTimeout=window.setTimeout(this._updateHighlightedLines.bind(this,[]),400)}_updateHighlightedLines(e){function t(e){for(let t=0;t<this._animatedLines.length;++t){const i=this._animatedLines[t].resolve();i&&this._textEditor.toggleLineClass(i.lineNumber,"highlight-line-modification",e)}}this._animationTimeout&&clearTimeout(this._animationTimeout),this._animationTimeout=null,this._textEditor.operation(function(){t.call(this,!1),this._animatedLines=e,t.call(this,!0)}.bind(this))}static computeDiff(e){const t=[];let i=!1,s=!1,n=0,r=0,o=!1;for(let t=0;t<e.length;++t){const a=e[t];a[0]!==O.Operation.Equal?(o||(o=!0,n=r),a[0]===O.Operation.Delete?s=!0:(r+=a[1].length,i=!0)):(o&&h(),r+=a[1].length)}if(o&&h(),t.length>1&&0===t[0].from&&0===t[1].from){const e={type:Oe.Modify,from:0,to:t[1].to};t.splice(0,2,e)}return t;function h(){let e=Oe.Insert,h=n,a=r;i&&s?e=Oe.Modify:!i&&s&&0===h&&0===a?(e=Oe.Modify,a=1):!i&&s&&(e=Oe.Delete,h-=1),t.push({type:e,from:h,to:a}),o=!1,i=!1,s=!1}}}const Oe={Insert:Symbol("Insert"),Delete:Symbol("Delete"),Modify:Symbol("Modify")};var Fe=Object.freeze({__proto__:null,SourceCodeDiff:Ie,EditType:Oe});export{te as BinaryResourceViewFactory,le as FontView,ge as ImageView,we as JSONView,Pe as PreviewFactory,$ as ResourceSourceFrame,Fe as SourceCodeDiff,q as SourceFrame,j as SourcesTextEditor,ve as XMLView};
