import{Console as e,Settings as t,SegmentedRange as s}from"../common/common.js";import{i18n as a}from"../i18n/i18n.js";import{ArrayUtilities as r}from"../platform/platform.js";import{Runtime as n}from"../root/root.js";import{TracingModel as i,SDKModel as o,CPUProfileDataModel as l,LayerTreeBase as d,PaintProfiler as c}from"../sdk/sdk.js";const h={threadS:"Thread {PH1}"},m=a.registerUIStrings("timeline_model/TimelineJSProfile.ts",h),u=a.getLocalizedString.bind(void 0,m);class p{static generateTracingEventsFromCpuProfile(e,t){const s=e.idleNode,a=e.programNode||null,r=e.gcNode,n=e.samples||[],o=e.timestamps,l=[],d=new Map;d.set(a,[]);for(let a=0;a<n.length;++a){let c=e.nodeByIndex(a);if(!c){console.error(`Node with unknown id ${n[a]} at index ${a}`);continue}if(c===r||c===s)continue;let h=d.get(c);if(!h){h=new Array(c.depth+1),d.set(c,h);for(let e=0;c.parent;c=c.parent)h[e++]=c}const m=new i.Event(i.DevToolsTimelineEventCategory,y.JSSample,i.Phase.Instant,o[a],t);m.args.data={stackTrace:h},l.push(m)}return l}static generateJSFrameEvents(e,t){const s=[],a=[],r=[];let n=0,o=!1;const{showAllEvents:l,showRuntimeCallStats:d,showNativeFunctions:c}=t;function h(e,t){if(r.length){const s=r[r.length-1];e<s&&(console.error(`Child stack is shallower (${e}) than the parent stack (${s}) at ${t}`),e=s)}a.length<e&&(console.error("Trying to truncate higher than the current stack size at "+t),e=a.length);for(let e=0;e<a.length;++e)a[e].setEndTime(t);a.length=e}function m(e){const t=e.name===y.JSSample?e.args.data.stackTrace.slice().reverse():a.map((e=>e.args.data));!function(e){if(l)return;let t=null,s=0;for(let r=0;r<e.length;++r){const n=e[r],i=n.url,o=i&&i.startsWith("native ");if(!c&&o)continue;const l=p.isNativeRuntimeFrame(n);if(l&&(a=n.functionName,!d||!Boolean(p.nativeGroup(a))))continue;const h=l?p.nativeGroup(n.functionName):null;t&&t===h||(t=h,e[s++]=n)}var a;e.length=s}(t);const n=e.endTime||e.startTime,o=Math.min(t.length,a.length);let m;for(m=r[r.length-1]||0;m<o;++m){const e=t[m],s=a[m].args.data;if(_=s,(u=e).scriptId!==_.scriptId||u.functionName!==_.functionName||u.lineNumber!==_.lineNumber)break;a[m].setEndTime(Math.max(a[m].endTime,n))}var u,_;for(h(m,e.startTime);m<t.length;++m){const r=t[m],o=new i.Event(i.DevToolsTimelineEventCategory,y.JSFrame,i.Phase.Complete,e.startTime,e.thread);o.ordinal=e.ordinal,o.addArgs({data:r}),o.setEndTime(n),a.push(o),s.push(o)}}const u=e.find(i.TracingModel.isTopLevelEvent),_=u?u.startTime:0;return f.forEachEvent(e,(function(e){o&&(h(r.pop(),e.startTime),o=!1),e.ordinal=++n,m(e),r.push(a.length)}),(function(e){h(r.pop(),e.endTime)}),(function(e,t){if(e.ordinal=++n,t&&function(e){switch(e.name){case y.RunMicrotasks:case y.FunctionCall:case y.EvaluateScript:case y.EvaluateModule:case y.EventDispatch:case y.V8Execute:return!0}return!1}(t)||o)m(e);else if(e.name===y.JSSample&&0===a.length){o=!0;const t=a.length;m(e),r.push(t)}}),_),s}static isNativeRuntimeFrame(e){return"native V8Runtime"===e.url}static nativeGroup(e){return e.startsWith("Parse")?p.NativeGroups.Parse:e.startsWith("Compile")||e.startsWith("Recompile")?p.NativeGroups.Compile:null}static buildTraceProfileFromCpuProfile(e,t,s,a){const r=[];if(s&&T("TracingStartedInPage",{data:{sessionId:"1"}},0,0,"M"),a||(a=u(h.threadS,{PH1:t})),T(i.MetadataEvent.ThreadName,{name:a},0,0,"M","__metadata"),!e)return r;const n=new Map,o=e.nodes;for(let e=0;e<o.length;++e)n.set(o[e].id,o[e]);let l=null,d=null,c=e.startTime,m=0;const p=e.samples,_=e.timeDeltas;for(let e=0;e<p.length;++e){m=c,c+=_[e];const t=n.get(p[e]).callFrame.functionName;"(idle)"!==t?(l||(l=T("MessageLoop::RunTask",{},m,0,"X","toplevel")),"(program)"===t?d&&(d.dur=m-d.ts,d=null):d||(d=T("FunctionCall",{data:{sessionId:"1"}},m))):g()}return g(),T("CpuProfile",{data:{cpuProfile:e}},e.endTime,0,"I"),r;function g(){l&&(l.dur=m-l.ts),d&&(d.dur=m-d.ts),l=null,d=null}function T(e,s,a,n,i,o){const l={cat:o||"disabled-by-default-devtools.timeline",name:e,ph:i||"X",pid:1,tid:t,ts:a,args:s};return n&&(l.dur=n),r.push(l),l}}}!function(e){let t;!function(e){e.Compile="Compile",e.Parse="Parse"}(t=e.NativeGroups||(e.NativeGroups={}))}(p||(p={}));var _=Object.freeze({__proto__:null,UIStrings:h,get TimelineJSProfileProcessor(){return p}});const g={threadS:"Thread {PH1}",workerS:"`Worker` — {PH1}",dedicatedWorker:"Dedicated `Worker`",workerSS:"`Worker`: {PH1} — {PH2}"},T=a.registerUIStrings("timeline_model/TimelineModel.ts",g),v=a.getLocalizedString.bind(void 0,T);class f{constructor(){this._minimumRecordTime=0,this._maximumRecordTime=0,this._totalBlockingTime=0,this._estimatedTotalBlockingTime=0,this._reset(),this._resetProcessingState(),this._currentTaskLayoutAndRecalcEvents=[],this._tracingModel=null}static forEachEvent(e,t,s,a,r,n,o){r=r||0,n=n||1/0;const l=[];for(let d=f._topLevelEventEndingAfter(e,r);d<e.length;++d){const c=e[d];if((c.endTime||c.startTime)<r)continue;if(c.startTime>=n)break;if(i.TracingModel.isAsyncPhase(c.phase)||i.TracingModel.isFlowPhase(c.phase))continue;let h=l[l.length-1];for(;h&&void 0!==h.endTime&&h.endTime<=c.startTime;)l.pop(),s(h),h=l[l.length-1];o&&!o(c)||(c.duration?(t(c),l.push(c)):a&&a(c,l[l.length-1]||null))}for(;l.length;){const e=l.pop();e&&s(e)}}static _topLevelEventEndingAfter(e,t){let s=r.upperBound(e,t,((e,t)=>e-t.startTime))-1;for(;s>0&&!i.TracingModel.isTopLevelEvent(e[s]);)s--;return Math.max(s,0)}isMarkerEvent(e){switch(e.name){case y.TimeStamp:return!0;case y.MarkFirstPaint:case y.MarkFCP:return Boolean(this._mainFrame)&&e.args.frame===this._mainFrame.frameId&&Boolean(e.args.data);case y.MarkDOMContent:case y.MarkLoad:case y.MarkLCPCandidate:case y.MarkLCPInvalidate:return Boolean(e.args.data.isMainFrame);default:return!1}}isInteractiveTimeEvent(e){return e.name===y.InteractiveTime}isLayoutShiftEvent(e){return e.name===y.LayoutShift}isUserTimingEvent(e){return e.categoriesString===f.Category.UserTiming}isParseHTMLEvent(e){return e.name===y.ParseHTML}isLCPCandidateEvent(e){return e.name===y.MarkLCPCandidate&&Boolean(e.args.data.isMainFrame)}isLCPInvalidateEvent(e){return e.name===y.MarkLCPInvalidate&&Boolean(e.args.data.isMainFrame)}isFCPEvent(e){return e.name===y.MarkFCP&&Boolean(this._mainFrame)&&e.args.frame===this._mainFrame.frameId}isLongRunningTask(e){return e.name===y.Task&&P.forEvent(e).warning===f.WarningType.LongTask}isNavigationStartEvent(e){return e.name===y.NavigationStart}isMainFrameNavigationStartEvent(e){return this.isNavigationStartEvent(e)&&e.args.data.isLoadingMainFrame&&e.args.data.documentLoaderURL}static globalEventId(e,t){const s=e.args.data||e.args.beginData,a=s&&s[t];return a?`${e.thread.process().id()}.${a}`:""}static eventFrameId(e){const t=e.args.data||e.args.beginData;return t&&t.frame||""}cpuProfiles(){return this._cpuProfiles}totalBlockingTime(){return-1===this._totalBlockingTime?{time:this._estimatedTotalBlockingTime,estimated:!0}:{time:this._totalBlockingTime,estimated:!1}}targetByEvent(e){const t=this._workerIdByThread.get(e.thread),s=o.TargetManager.instance().mainTarget();return t?o.TargetManager.instance().targetById(t):s}navStartTimes(){return this._tracingModel?this._tracingModel.navStartTimes():new Map}setEvents(e){this._reset(),this._resetProcessingState(),this._tracingModel=e,this._minimumRecordTime=e.minimumRecordTime(),this._maximumRecordTime=e.maximumRecordTime();const t=[];for(const s of e.sortedProcesses())if("Renderer"===s.name())for(const e of s.sortedThreads()){const s=e.removeEventsByName(y.LayoutShift);t.push(...s)}if(this._processSyncBrowserEvents(e),this._browserFrameTracking)this._processThreadsForBrowserFrames(e);else{const t=this._processMetadataEvents(e);this._isGenericTrace=!t,t?this._processMetadataAndThreads(e,t):this._processGenericTrace(e)}this._inspectedTargetEvents.sort(i.Event.compareStartTime),this._processAsyncBrowserEvents(e),this._buildGPUEvents(e),this._buildLoadingEvents(e,t),this._resetProcessingState()}_processGenericTrace(e){let t=i.TracingModel.browserMainThread(e);!t&&e.sortedProcesses().length&&(t=e.sortedProcesses()[0].sortedThreads()[0]);for(const s of e.sortedProcesses())for(const a of s.sortedThreads())this._processThreadEvents(e,[{from:0,to:1/0}],a,a===t,!1,!0,null)}_processMetadataAndThreads(e,t){let s=0;for(let a=0,r=t.page.length;a<r;a++){const n=t.page[a],i=n.thread.process(),o=a+1<r?t.page[a+1].startTime:1/0;if(s!==o){this._legacyCurrentPage=n.args.data&&n.args.data.page;for(const a of i.sortedThreads()){let r=null;if(a.name()===f.WorkerThreadName||a.name()===f.WorkerThreadNameLegacy){const e=t.workers.find((e=>e.args.data.workerThreadId===a.id()&&(e.args.data.sessionId===this._sessionId||Boolean(this._pageFrames.get(f.eventFrameId(e))))));if(!e)continue;const s=e.args.data.workerId;s&&this._workerIdByThread.set(a,s),r=e.args.data.url||""}this._processThreadEvents(e,[{from:s,to:o}],a,a===n.thread,Boolean(r),!0,r)}s=o}}}_processThreadsForBrowserFrames(e){const t=new Map;for(const e of this._pageFrames.values())for(let s=0;s<e.processes.length;s++){const a=e.processes[s].processId;let r=t.get(a);r||(r=[],t.set(a,r));const n=s===e.processes.length-1?e.deletedTime||1/0:e.processes[s+1].time;r.push({from:e.processes[s].time,to:n,main:!e.parent,url:e.processes[s].url})}const s=e.devToolsMetadataEvents();for(const a of e.sortedProcesses()){const r=t.get(a.id());if(!r)continue;r.sort(((e,t)=>e.from-t.from||e.to-t.to));const n=[];let i=null,o=null,l=!1;for(const e of r){const t=n[n.length-1];!t||e.from>t.to?n.push({from:e.from,to:e.to}):t.to=e.to,e.main&&(l=!0),e.url&&(e.main&&(o=e.url),i=e.url)}for(const t of a.sortedThreads())if(t.name()===f.RendererMainThreadName)this._processThreadEvents(e,n,t,!0,!1,l,l?o:i);else if(t.name()===f.WorkerThreadName||t.name()===f.WorkerThreadNameLegacy){const r=s.find((e=>e.name===f.DevToolsMetadataEvent.TracingSessionIdForWorker&&(e.thread.process()===a&&(e.args.data.workerThreadId===t.id()&&Boolean(this._pageFrames.get(f.eventFrameId(e)))))));if(!r)continue;this._workerIdByThread.set(t,r.args.data.workerId||""),this._processThreadEvents(e,n,t,!1,!0,!1,r.args.data.url||"")}else this._processThreadEvents(e,n,t,!1,!1,!1,null)}}_processMetadataEvents(t){const s=t.devToolsMetadataEvents(),a=[],r=[];for(const e of s)if(e.name===f.DevToolsMetadataEvent.TracingStartedInPage){a.push(e),e.args.data&&e.args.data.persistentIds&&(this._persistentIds=!0);(e.args.data&&e.args.data.frames||[]).forEach((t=>this._addPageFrame(e,t))),this._mainFrame=this.rootFrames()[0]}else e.name===f.DevToolsMetadataEvent.TracingSessionIdForWorker?r.push(e):e.name===f.DevToolsMetadataEvent.TracingStartedInBrowser&&(console.assert(!this._mainFrameNodeId,"Multiple sessions in trace"),this._mainFrameNodeId=e.args.frameTreeNodeId);if(!a.length)return null;const n=a[0].args.sessionId||a[0].args.data.sessionId;this._sessionId=n;const o=new Set;const l={page:a.filter((function(e){let t=e.args;t.data&&(t=t.data);const s=t.sessionId;return s===n||(o.add(s),!1)})).sort(i.Event.compareStartTime),workers:r.sort(i.Event.compareStartTime)};return o.size&&e.Console.instance().error("Timeline recording was started in more than one page simultaneously. Session id mismatch: "+this._sessionId+" and "+[...o]+"."),l}_processSyncBrowserEvents(e){const t=i.TracingModel.browserMainThread(e);t&&t.events().forEach(this._processBrowserEvent,this)}_processAsyncBrowserEvents(e){const t=i.TracingModel.browserMainThread(e);t&&this._processAsyncEvents(t,[{from:0,to:1/0}])}_buildGPUEvents(e){const t=e.threadByName("GPU Process","CrGpuMain");if(!t)return;const s=y.GPUTask,a=this._ensureNamedTrack(I.GPU);a.thread=t,a.events=t.events().filter((e=>e.name===s))}_buildLoadingEvents(e,t){const s=e.threadByName("Renderer","CrRendererMain");if(!s)return;const a=this._ensureNamedTrack(I.Experience);a.thread=s,a.events=t;for(const e of a.events)if(e.categoriesString="experience",e.name===y.LayoutShift){const t=e.args.data||e.args.beginData||{};P.forEvent(e).backendNodeId=t.impacted_nodes&&t.impacted_nodes.length>0?t.impacted_nodes[0].node_id:0}}_resetProcessingState(){this._asyncEventTracker=new C,this._invalidationTracker=new E,this._layoutInvalidate={},this._lastScheduleStyleRecalculation={},this._paintImageEventByPixelRefId={},this._lastPaintForLayer={},this._lastRecalculateStylesEvent=null,this._currentScriptEvent=null,this._eventStack=[],this._knownInputEvents=new Set,this._browserFrameTracking=!1,this._persistentIds=!1,this._legacyCurrentPage=null}_extractCpuProfile(t,s){const a=s.events();let r,n=null,i=a[a.length-1];if(i&&i.name===y.CpuProfile){const e=i.args.data;r=e&&e.cpuProfile,n=this.targetByEvent(i)}if(!r){if(i=a.find((e=>e.name===y.Profile)),!i)return null;n=this.targetByEvent(i);const s=t.profileGroup(i);if(!s)return e.Console.instance().error("Invalid CPU profile format."),null;r={startTime:1e3*i.startTime,endTime:0,nodes:[],samples:[],timeDeltas:[],lines:[]};for(const t of s.children){const s=t.args.data;"startTime"in s&&(r.startTime=1e3*t.startTime),"endTime"in s&&(r.endTime=1e3*t.startTime);const a=s.cpuProfile||{},n=a.samples||[],i=s.lines||Array(n.length).fill(0);if(r.nodes.push(...a.nodes||[]),r.lines.push(...i),r.samples&&r.samples.push(...n),r.timeDeltas&&r.timeDeltas.push(...s.timeDeltas||[]),r.samples&&r.timeDeltas&&r.samples.length!==r.timeDeltas.length)return e.Console.instance().error("Failed to parse CPU profile."),null}if(!r.endTime&&r.timeDeltas){const e=r.timeDeltas;r.endTime=e.reduce(((e,t)=>e+t),r.startTime)}}try{const e=r,t=new l.CPUProfileDataModel(e,n);return this._cpuProfiles.push(t),t}catch(t){e.Console.instance().error("Failed to parse CPU profile.")}return null}_injectJSFrameEvents(e,s){const a=this._extractCpuProfile(e,s);let o=s.events();const l=a?p.generateTracingEventsFromCpuProfile(a,s):null;if(l&&l.length&&(o=r.mergeOrdered(o,l,i.Event.orderedCompareStartTime)),l||o.some((e=>e.name===y.JSSample))){const e=p.generateJSFrameEvents(o,{showAllEvents:n.experiments.isEnabled("timelineShowAllEvents"),showRuntimeCallStats:n.experiments.isEnabled("timelineV8RuntimeCallStats"),showNativeFunctions:t.Settings.instance().moduleSetting("showNativeFunctionsInJSProfile").get()});e&&e.length&&(o=r.mergeOrdered(e,o,i.Event.orderedCompareStartTime))}return o}_processThreadEvents(e,t,s,a,n,o,l){const d=new S;d.name=s.name()||v(g.threadS,{PH1:s.id()}),d.type=I.Other,d.thread=s,a?(d.type=I.MainThread,d.url=l||"",d.forMainFrame=o):n?(d.type=I.Worker,d.url=l||"",d.name=d.url?v(g.workerS,{PH1:d.url}):v(g.dedicatedWorker)):s.name().startsWith("CompositorTileWorker")&&(d.type=I.Raster),this._tracks.push(d);const c=this._injectJSFrameEvents(e,s);this._eventStack=[];const h=this._eventStack;if(n){const e=c.find((e=>e.name===y.Profile));if(e){const t=this.targetByEvent(e);t&&(d.name=v(g.workerSS,{PH1:t.name(),PH2:d.url}))}}for(const e of t){let t=r.lowerBound(c,e.from,((e,t)=>e-t.startTime));for(;t<c.length;t++){const s=c[t];if(s.startTime>=e.to)break;this.isInteractiveTimeEvent(s)&&-1===this._totalBlockingTime&&(this._totalBlockingTime=s.args.args.total_blocking_time_ms);const r=s.name===y.Task&&s.duration&&s.duration>50;a&&r&&s.duration&&(this._estimatedTotalBlockingTime+=s.duration-50);let n=h[h.length-1];for(;n&&void 0!==n.endTime&&n.endTime<=s.startTime;)h.pop(),n=h[h.length-1];if(this._processEvent(s)){if(!i.TracingModel.isAsyncPhase(s.phase)&&s.duration){if(h.length){const e=h[h.length-1];e&&(e.selfTime-=s.duration,e.selfTime<0&&this._fixNegativeDuration(e,s))}s.selfTime=s.duration,h.length||d.tasks.push(s),h.push(s)}this.isMarkerEvent(s)&&this._timeMarkerEvents.push(s),d.events.push(s),this._inspectedTargetEvents.push(s)}}}this._processAsyncEvents(s,t)}_fixNegativeDuration(e,t){e.selfTime<-.001&&console.error(`Children are longer than parent at ${e.startTime} (${(t.startTime-this.minimumRecordTime()).toFixed(3)} by ${(-e.selfTime).toFixed(3)}`),e.selfTime=0}_processAsyncEvents(e,t){const s=e.asyncEvents(),a=new Map;function n(e){return a.has(e)||a.set(e,[]),a.get(e)}for(const e of t){let t=r.lowerBound(s,e.from,(function(e,t){return e-t.startTime}));for(;t<s.length;++t){const a=s[t];if(a.startTime>=e.to)break;if(a.hasCategory(f.Category.Console))n(I.Console).push(a);else if(a.hasCategory(f.Category.UserTiming))n(I.Timings).push(a);else if(a.name!==y.Animation)if(a.hasCategory(f.Category.LatencyInfo)||a.name===y.ImplSideFling){const e=a.steps[a.steps.length-1];if(!e)throw new Error("AsyncEvent.steps access is out of bounds.");if(e.phase!==i.Phase.AsyncEnd)continue;const t=e.args.data;if(a.causedFrame=Boolean(t&&t.INPUT_EVENT_LATENCY_RENDERER_SWAP_COMPONENT),a.hasCategory(f.Category.LatencyInfo)){if(e.id&&!this._knownInputEvents.has(e.id))continue;if(a.name===y.InputLatencyMouseMove&&!a.causedFrame)continue;if(t.is_coalesced)continue;const s=t.INPUT_EVENT_LATENCY_RENDERER_MAIN_COMPONENT;if(s){const e=s.time/1e3;P.forEvent(a.steps[0]).timeWaitingForMainThread=e-a.steps[0].startTime}}n(I.Input).push(a)}else;else n(I.Animation).push(a)}}for(const[t,s]of a){const a=this._ensureNamedTrack(t);a.thread=e,a.asyncEvents=r.mergeOrdered(a.asyncEvents,s,i.Event.compareStartTime)}}_processEvent(e){const t=this._eventStack;if(!t.length){if(this._currentTaskLayoutAndRecalcEvents&&this._currentTaskLayoutAndRecalcEvents.length){if(this._currentTaskLayoutAndRecalcEvents.reduce(((e,t)=>void 0===t.duration?e:e+t.duration),0)>f.Thresholds.ForcedLayout)for(const e of this._currentTaskLayoutAndRecalcEvents){P.forEvent(e).warning=e.name===y.Layout?f.WarningType.ForcedLayout:f.WarningType.ForcedStyle}}this._currentTaskLayoutAndRecalcEvents=[]}this._currentScriptEvent&&void 0!==this._currentScriptEvent.endTime&&e.startTime>this._currentScriptEvent.endTime&&(this._currentScriptEvent=null);const s=e.args.data||e.args.beginData||{},a=P.forEvent(e);if(s.stackTrace&&(a.stackTrace=s.stackTrace),a.stackTrace&&e.name!==y.JSSample)for(let e=0;e<a.stackTrace.length;++e)--a.stackTrace[e].lineNumber,--a.stackTrace[e].columnNumber;let r=f.eventFrameId(e);const n=t[t.length-1];switch(!r&&n&&(r=P.forEvent(n).frameId),a.frameId=r||this._mainFrame&&this._mainFrame.frameId||"",this._asyncEventTracker.processEvent(e),this.isMarkerEvent(e)&&this._ensureNamedTrack(I.Timings),e.name){case y.ResourceSendRequest:case y.WebSocketCreate:a.setInitiator(t[t.length-1]||null),a.url=s.url;break;case y.ScheduleStyleRecalculation:this._lastScheduleStyleRecalculation[s.frame]=e;break;case y.UpdateLayoutTree:case y.RecalculateStyles:this._invalidationTracker.didRecalcStyle(e),e.args.beginData&&a.setInitiator(this._lastScheduleStyleRecalculation[e.args.beginData.frame]),this._lastRecalculateStylesEvent=e,this._currentScriptEvent&&this._currentTaskLayoutAndRecalcEvents.push(e);break;case y.ScheduleStyleInvalidationTracking:case y.StyleRecalcInvalidationTracking:case y.StyleInvalidatorInvalidationTracking:case y.LayoutInvalidationTracking:this._invalidationTracker.addInvalidation(new R(e));break;case y.InvalidateLayout:{let t=e;const a=s.frame;!this._layoutInvalidate[a]&&this._lastRecalculateStylesEvent&&void 0!==this._lastRecalculateStylesEvent.endTime&&this._lastRecalculateStylesEvent.endTime>e.startTime&&(t=P.forEvent(this._lastRecalculateStylesEvent).initiator()),this._layoutInvalidate[a]=t;break}case y.Layout:{this._invalidationTracker.didLayout(e);const t=e.args.beginData.frame;a.setInitiator(this._layoutInvalidate[t]),e.args.endData&&(a.backendNodeId=e.args.endData.rootNode),this._layoutInvalidate[t]=null,this._currentScriptEvent&&this._currentTaskLayoutAndRecalcEvents.push(e);break}case y.Task:void 0!==e.duration&&e.duration>f.Thresholds.LongTask&&(a.warning=f.WarningType.LongTask);break;case y.EventDispatch:void 0!==e.duration&&e.duration>f.Thresholds.RecurringHandler&&(a.warning=f.WarningType.LongHandler);break;case y.TimerFire:case y.FireAnimationFrame:void 0!==e.duration&&e.duration>f.Thresholds.RecurringHandler&&(a.warning=f.WarningType.LongRecurringHandler);break;case y.FunctionCall:"string"==typeof s.scriptName&&(s.url=s.scriptName),"number"==typeof s.scriptLine&&(s.lineNumber=s.scriptLine);case y.EvaluateScript:case y.CompileScript:"number"==typeof s.lineNumber&&--s.lineNumber,"number"==typeof s.columnNumber&&--s.columnNumber;case y.RunMicrotasks:this._currentScriptEvent||(this._currentScriptEvent=e);break;case y.SetLayerTreeId:{if(this._sessionId&&s.sessionId&&this._sessionId===s.sessionId){this._mainFrameLayerTreeId=s.layerTreeId;break}const t=f.eventFrameId(e),a=this._pageFrames.get(t);if(!a||a.parent)return!1;this._mainFrameLayerTreeId=s.layerTreeId;break}case y.Paint:{if(this._invalidationTracker.didPaint(e),a.backendNodeId=s.nodeId,!s.layerId)break;const t=s.layerId;this._lastPaintForLayer[t]=e;break}case y.DisplayItemListSnapshot:case y.PictureSnapshot:{const t=this._findAncestorEvent(y.UpdateLayer);if(!t||t.args.layerTreeId!==this._mainFrameLayerTreeId)break;const s=this._lastPaintForLayer[t.args.layerId];s&&(P.forEvent(s).picture=e);break}case y.ScrollLayer:a.backendNodeId=s.nodeId;break;case y.PaintImage:a.backendNodeId=s.nodeId,a.url=s.url;break;case y.DecodeImage:case y.ResizeImage:{let e=this._findAncestorEvent(y.PaintImage);if(!e){const t=this._findAncestorEvent(y.DecodeLazyPixelRef);e=t&&this._paintImageEventByPixelRefId[t.args.LazyPixelRef]}if(!e)break;const t=P.forEvent(e);a.backendNodeId=t.backendNodeId,a.url=t.url;break}case y.DrawLazyPixelRef:{const t=this._findAncestorEvent(y.PaintImage);if(!t)break;this._paintImageEventByPixelRefId[e.args.LazyPixelRef]=t;const s=P.forEvent(t);a.backendNodeId=s.backendNodeId,a.url=s.url;break}case y.FrameStartedLoading:if(a.frameId!==e.args.frame)return!1;break;case y.MarkLCPCandidate:a.backendNodeId=s.nodeId;break;case y.MarkDOMContent:case y.MarkLoad:{const t=f.eventFrameId(e);if(!this._pageFrames.has(t))return!1;break}case y.CommitLoad:{if(this._browserFrameTracking)break;const t=f.eventFrameId(e),a=Boolean(s.isMainFrame),r=this._pageFrames.get(t);if(r)r.update(e.startTime,s);else if(this._persistentIds){if(a)return!1;if(!this._addPageFrame(e,s))return!1}else if(s.page&&s.page!==this._legacyCurrentPage)return!1;if(a){const e=this._pageFrames.get(t);e&&(this._mainFrame=e)}break}case y.FireIdleCallback:void 0!==e.duration&&e.duration>s.allottedMilliseconds+f.Thresholds.IdleCallbackAddon&&(a.warning=f.WarningType.IdleDeadlineExceeded)}return!0}_processBrowserEvent(e){if(e.name!==y.LatencyInfoFlow)if(e.name!==y.ResourceWillSendRequest){if(e.hasCategory(i.DevToolsMetadataEventCategory)&&e.args.data){const t=e.args.data;if(e.name===f.DevToolsMetadataEvent.TracingStartedInBrowser){if(!t.persistentIds)return;this._browserFrameTracking=!0,this._mainFrameNodeId=t.frameTreeNodeId;return void(t.frames||[]).forEach((e=>{const t=e.parent&&this._pageFrames.get(e.parent);if(e.parent&&!t)return;let s=this._pageFrames.get(e.frame);s||(s=new F(e),this._pageFrames.set(s.frameId,s),t?t.addChild(s):this._mainFrame=s),s.update(this._minimumRecordTime,e)}))}if(e.name===f.DevToolsMetadataEvent.FrameCommittedInBrowser&&this._browserFrameTracking){let s=this._pageFrames.get(t.frame);if(!s){const e=t.parent&&this._pageFrames.get(t.parent);if(!e)return;s=new F(t),this._pageFrames.set(s.frameId,s),e.addChild(s)}return void s.update(e.startTime,t)}if(e.name===f.DevToolsMetadataEvent.ProcessReadyInBrowser&&this._browserFrameTracking){const e=this._pageFrames.get(t.frame);return void(e&&e.processReady(t.processPseudoId,t.processId))}if(e.name===f.DevToolsMetadataEvent.FrameDeletedInBrowser&&this._browserFrameTracking){const s=this._pageFrames.get(t.frame);return void(s&&(s.deletedTime=e.startTime))}}}else{const t=e.args.data.requestId;"string"==typeof t&&this._requestsFromBrowser.set(t,e)}else{const t=e.args.frameTreeNodeId;"number"==typeof t&&t===this._mainFrameNodeId&&e.bind_id&&this._knownInputEvents.add(e.bind_id)}}_ensureNamedTrack(e){let t=this._namedTracks.get(e);return t||(t=new S,t.type=e,this._tracks.push(t),this._namedTracks.set(e,t),t)}_findAncestorEvent(e){for(let t=this._eventStack.length-1;t>=0;--t){const s=this._eventStack[t];if(s.name===e)return s}return null}_addPageFrame(e,t){const s=t.parent&&this._pageFrames.get(t.parent);if(t.parent&&!s)return!1;const a=new F(t);return this._pageFrames.set(a.frameId,a),a.update(e.startTime,t),s&&s.addChild(a),!0}_reset(){this._isGenericTrace=!1,this._tracks=[],this._namedTracks=new Map,this._inspectedTargetEvents=[],this._timeMarkerEvents=[],this._sessionId=null,this._mainFrameNodeId=null,this._cpuProfiles=[],this._workerIdByThread=new WeakMap,this._pageFrames=new Map,this._requestsFromBrowser=new Map,this._minimumRecordTime=0,this._maximumRecordTime=0,this._totalBlockingTime=-1,this._estimatedTotalBlockingTime=0}isGenericTrace(){return this._isGenericTrace}tracingModel(){return this._tracingModel}minimumRecordTime(){return this._minimumRecordTime}maximumRecordTime(){return this._maximumRecordTime}inspectedTargetEvents(){return this._inspectedTargetEvents}tracks(){return this._tracks}isEmpty(){return 0===this.minimumRecordTime()&&0===this.maximumRecordTime()}timeMarkerEvents(){return this._timeMarkerEvents}rootFrames(){return Array.from(this._pageFrames.values()).filter((e=>!e.parent))}pageURL(){return this._mainFrame&&this._mainFrame.url||""}pageFrameById(e){return e&&this._pageFrames.get(e)||null}networkRequests(){if(this.isGenericTrace())return[];const e=new Map,t=[],s=[],a=new Set([y.ResourceWillSendRequest,y.ResourceSendRequest,y.ResourceReceiveResponse,y.ResourceReceivedData,y.ResourceFinish,y.ResourceMarkAsCached]),r=this.inspectedTargetEvents();for(let e=0;e<r.length;++e){const t=r[e];if(!a.has(t.name))continue;const s=f.globalEventId(t,"requestId");if(t.name===y.ResourceSendRequest&&this._requestsFromBrowser.has(t.args.data.requestId)){const e=t.args.data.requestId,a=this._requestsFromBrowser.get(e);a&&n(a,s)}n(t,s)}function n(a,r){let n=e.get(r);n?n.addEvent(a):(n=new k(a),e.set(r,n),n.startTime?t.push(n):s.push(n))}return s.concat(t)}}var y,I;!function(e){e.Task="RunTask",e.Program="Program",e.EventDispatch="EventDispatch",e.GPUTask="GPUTask",e.Animation="Animation",e.RequestMainThreadFrame="RequestMainThreadFrame",e.BeginFrame="BeginFrame",e.NeedsBeginFrameChanged="NeedsBeginFrameChanged",e.BeginMainThreadFrame="BeginMainThreadFrame",e.ActivateLayerTree="ActivateLayerTree",e.DrawFrame="DrawFrame",e.DroppedFrame="DroppedFrame",e.HitTest="HitTest",e.ScheduleStyleRecalculation="ScheduleStyleRecalculation",e.RecalculateStyles="RecalculateStyles",e.UpdateLayoutTree="UpdateLayoutTree",e.InvalidateLayout="InvalidateLayout",e.Layout="Layout",e.LayoutShift="LayoutShift",e.UpdateLayer="UpdateLayer",e.UpdateLayerTree="UpdateLayerTree",e.PaintSetup="PaintSetup",e.Paint="Paint",e.PaintImage="PaintImage",e.Rasterize="Rasterize",e.RasterTask="RasterTask",e.ScrollLayer="ScrollLayer",e.CompositeLayers="CompositeLayers",e.InteractiveTime="InteractiveTime",e.ScheduleStyleInvalidationTracking="ScheduleStyleInvalidationTracking",e.StyleRecalcInvalidationTracking="StyleRecalcInvalidationTracking",e.StyleInvalidatorInvalidationTracking="StyleInvalidatorInvalidationTracking",e.LayoutInvalidationTracking="LayoutInvalidationTracking",e.ParseHTML="ParseHTML",e.ParseAuthorStyleSheet="ParseAuthorStyleSheet",e.TimerInstall="TimerInstall",e.TimerRemove="TimerRemove",e.TimerFire="TimerFire",e.XHRReadyStateChange="XHRReadyStateChange",e.XHRLoad="XHRLoad",e.CompileScript="v8.compile",e.EvaluateScript="EvaluateScript",e.CompileModule="v8.compileModule",e.EvaluateModule="v8.evaluateModule",e.WasmStreamFromResponseCallback="v8.wasm.streamFromResponseCallback",e.WasmCompiledModule="v8.wasm.compiledModule",e.WasmCachedModule="v8.wasm.cachedModule",e.WasmModuleCacheHit="v8.wasm.moduleCacheHit",e.WasmModuleCacheInvalid="v8.wasm.moduleCacheInvalid",e.FrameStartedLoading="FrameStartedLoading",e.CommitLoad="CommitLoad",e.MarkLoad="MarkLoad",e.MarkDOMContent="MarkDOMContent",e.MarkFirstPaint="firstPaint",e.MarkFCP="firstContentfulPaint",e.MarkLCPCandidate="largestContentfulPaint::Candidate",e.MarkLCPInvalidate="largestContentfulPaint::Invalidate",e.NavigationStart="navigationStart",e.TimeStamp="TimeStamp",e.ConsoleTime="ConsoleTime",e.UserTiming="UserTiming",e.ResourceWillSendRequest="ResourceWillSendRequest",e.ResourceSendRequest="ResourceSendRequest",e.ResourceReceiveResponse="ResourceReceiveResponse",e.ResourceReceivedData="ResourceReceivedData",e.ResourceFinish="ResourceFinish",e.ResourceMarkAsCached="ResourceMarkAsCached",e.RunMicrotasks="RunMicrotasks",e.FunctionCall="FunctionCall",e.GCEvent="GCEvent",e.MajorGC="MajorGC",e.MinorGC="MinorGC",e.JSFrame="JSFrame",e.JSSample="JSSample",e.V8Sample="V8Sample",e.JitCodeAdded="JitCodeAdded",e.JitCodeMoved="JitCodeMoved",e.StreamingCompileScript="v8.parseOnBackground",e.StreamingCompileScriptWaiting="v8.parseOnBackgroundWaiting",e.StreamingCompileScriptParsing="v8.parseOnBackgroundParsing",e.V8Execute="V8.Execute",e.UpdateCounters="UpdateCounters",e.RequestAnimationFrame="RequestAnimationFrame",e.CancelAnimationFrame="CancelAnimationFrame",e.FireAnimationFrame="FireAnimationFrame",e.RequestIdleCallback="RequestIdleCallback",e.CancelIdleCallback="CancelIdleCallback",e.FireIdleCallback="FireIdleCallback",e.WebSocketCreate="WebSocketCreate",e.WebSocketSendHandshakeRequest="WebSocketSendHandshakeRequest",e.WebSocketReceiveHandshakeResponse="WebSocketReceiveHandshakeResponse",e.WebSocketDestroy="WebSocketDestroy",e.EmbedderCallback="EmbedderCallback",e.SetLayerTreeId="SetLayerTreeId",e.TracingStartedInPage="TracingStartedInPage",e.TracingSessionIdForWorker="TracingSessionIdForWorker",e.DecodeImage="Decode Image",e.ResizeImage="Resize Image",e.DrawLazyPixelRef="Draw LazyPixelRef",e.DecodeLazyPixelRef="Decode LazyPixelRef",e.LazyPixelRef="LazyPixelRef",e.LayerTreeHostImplSnapshot="cc::LayerTreeHostImpl",e.PictureSnapshot="cc::Picture",e.DisplayItemListSnapshot="cc::DisplayItemList",e.LatencyInfo="LatencyInfo",e.LatencyInfoFlow="LatencyInfo.Flow",e.InputLatencyMouseMove="InputLatency::MouseMove",e.InputLatencyMouseWheel="InputLatency::MouseWheel",e.ImplSideFling="InputHandlerProxy::HandleGestureFling::started",e.GCCollectGarbage="BlinkGC.AtomicPhase",e.CryptoDoEncrypt="DoEncrypt",e.CryptoDoEncryptReply="DoEncryptReply",e.CryptoDoDecrypt="DoDecrypt",e.CryptoDoDecryptReply="DoDecryptReply",e.CryptoDoDigest="DoDigest",e.CryptoDoDigestReply="DoDigestReply",e.CryptoDoSign="DoSign",e.CryptoDoSignReply="DoSignReply",e.CryptoDoVerify="DoVerify",e.CryptoDoVerifyReply="DoVerifyReply",e.CpuProfile="CpuProfile",e.Profile="Profile",e.AsyncTask="AsyncTask"}(y||(y={})),function(e){let t;e.Category={Console:"blink.console",UserTiming:"blink.user_timing",LatencyInfo:"latencyInfo",Loading:"loading"},function(e){e.LongTask="LongTask",e.ForcedStyle="ForcedStyle",e.ForcedLayout="ForcedLayout",e.IdleDeadlineExceeded="IdleDeadlineExceeded",e.LongHandler="LongHandler",e.LongRecurringHandler="LongRecurringHandler",e.V8Deopt="V8Deopt"}(t=e.WarningType||(e.WarningType={})),e.WorkerThreadName="DedicatedWorker thread",e.WorkerThreadNameLegacy="DedicatedWorker Thread",e.RendererMainThreadName="CrRendererMain",e.BrowserMainThreadName="CrBrowserMain",e.DevToolsMetadataEvent={TracingStartedInBrowser:"TracingStartedInBrowser",TracingStartedInPage:"TracingStartedInPage",TracingSessionIdForWorker:"TracingSessionIdForWorker",FrameCommittedInBrowser:"FrameCommittedInBrowser",ProcessReadyInBrowser:"ProcessReadyInBrowser",FrameDeletedInBrowser:"FrameDeletedInBrowser"},e.Thresholds={LongTask:50,Handler:150,RecurringHandler:50,ForcedLayout:30,IdleCallbackAddon:5}}(f||(f={}));class S{constructor(){this.name="",this.type=I.Other,this.forMainFrame=!1,this.url="",this.events=[],this.asyncEvents=[],this.tasks=[],this._syncEvents=null,this.thread=null}syncEvents(){if(this.events.length)return this.events;if(this._syncEvents)return this._syncEvents;const e=[];function t(){const t=e[e.length-1];if(void 0!==t){const e=t.endTime;if(void 0!==e)return e}throw new Error("End time does not exist on event.")}this._syncEvents=[];for(const s of this.asyncEvents){const a=s.startTime;let r=s.endTime;for(void 0===r&&(r=a);e.length&&a>=t();)e.pop();if(e.length&&r>t()){this._syncEvents=[];break}const n=new i.Event(s.categoriesString,s.name,i.Phase.Complete,a,s.thread);n.setEndTime(r),n.addArgs(s.args),this._syncEvents.push(n),e.push(n)}return this._syncEvents}}!function(e){e.MainThread="MainThread",e.Worker="Worker",e.Input="Input",e.Animation="Animation",e.Timings="Timings",e.Console="Console",e.Raster="Raster",e.GPU="GPU",e.Experience="Experience",e.Other="Other"}(I||(I={}));class F{constructor(e){this.frameId=e.frame,this.url=e.url||"",this.name=e.name,this.children=[],this.parent=null,this.processes=[],this.deletedTime=null,this.ownerNode=null}update(e,t){this.url=t.url||"",this.name=t.name,t.processId?this.processes.push({time:e,processId:t.processId,processPseudoId:"",url:t.url||""}):this.processes.push({time:e,processId:-1,processPseudoId:t.processPseudoId,url:t.url||""})}processReady(e,t){for(const s of this.processes)s.processPseudoId===e&&(s.processPseudoId="",s.processId=t)}addChild(e){this.children.push(e),e.parent=this}}class k{constructor(e){const t=e.name===y.ResourceSendRequest||e.name===y.ResourceWillSendRequest;this.startTime=t?e.startTime:0,this.endTime=1/0,this.encodedDataLength=0,this.decodedBodyLength=0,this.children=[],this._transferSize=0,this._maybeDiskCached=!1,this._memoryCached=!1,this.addEvent(e)}addEvent(e){this.children.push(e),this.startTime=Math.min(this.startTime,e.startTime);const t=e.args.data;t.mimeType&&(this.mimeType=t.mimeType),"priority"in t&&(this.priority=t.priority),e.name===y.ResourceFinish&&(this.endTime=e.startTime),t.finishTime&&(this.finishTime=1e3*t.finishTime),this.responseTime||e.name!==y.ResourceReceiveResponse&&e.name!==y.ResourceReceivedData||(this.responseTime=e.startTime);const s=t.encodedDataLength||0;e.name===y.ResourceMarkAsCached&&(this._memoryCached=!0),e.name===y.ResourceReceiveResponse&&(t.fromCache&&(this._maybeDiskCached=!0),t.fromServiceWorker&&(this.fromServiceWorker=!0),t.hasCachedResource&&(this.hasCachedResource=!0),this.encodedDataLength=s),e.name===y.ResourceReceivedData&&(this.encodedDataLength+=s),e.name===y.ResourceFinish&&s&&(this.encodedDataLength=s,this._transferSize=s);const a=t.decodedBodyLength;e.name===y.ResourceFinish&&a&&(this.decodedBodyLength=a),this.url||(this.url=t.url),this.requestMethod||(this.requestMethod=t.requestMethod),this.timing||(this.timing=t.timing),t.fromServiceWorker&&(this.fromServiceWorker=!0)}cached(){return Boolean(this._memoryCached)||Boolean(this._maybeDiskCached)&&!this._transferSize&&!this.fromServiceWorker}memoryCached(){return this._memoryCached}getSendReceiveTiming(){if(this.cached()||!this.timing)return{sendStartTime:this.startTime,headersEndTime:this.startTime};const e=1e3*this.timing.requestTime;return{sendStartTime:e+this.timing.sendStart,headersEndTime:e+this.timing.receiveHeadersEnd}}getStartTime(){return Math.min(this.startTime,!this.cached()&&this.timing&&1e3*this.timing.requestTime||1/0)}beginTime(){return Math.min(this.getStartTime(),!this.cached()&&this.timing&&1e3*this.timing.pushStart||1/0)}}class R{constructor(e){this.type=e.name,this.startTime=e.startTime,this._tracingEvent=e;const t=e.args.data;this.frame=t.frame,this.nodeId=t.nodeId,this.nodeName=t.nodeName,this.invalidationSet=t.invalidationSet,this.invalidatedSelectorId=t.invalidatedSelectorId,this.changedId=t.changedId,this.changedClass=t.changedClass,this.changedAttribute=t.changedAttribute,this.changedPseudo=t.changedPseudo,this.selectorPart=t.selectorPart,this.extraData=t.extraData,this.invalidationList=t.invalidationList,this.cause={reason:t.reason,stackTrace:t.stackTrace},this.linkedRecalcStyleEvent=!1,this.linkedLayoutEvent=!1,!this.cause.reason&&this.cause.stackTrace&&this.type===y.LayoutInvalidationTracking&&(this.cause.reason="Layout forced")}}class E{constructor(){this._lastRecalcStyle=null,this._lastPaintWithLayer=null,this._didPaint=!1,this._initializePerFrameState(),this._invalidations={},this._invalidationsByNodeId={}}static invalidationEventsFor(e){return w.get(e)||null}addInvalidation(e){if(this._startNewFrameIfNeeded(),!e.nodeId)return console.error("Invalidation lacks node information."),void console.error(e);if(e.type===y.StyleRecalcInvalidationTracking&&"StyleInvalidator"===e.cause.reason)return;if(e.type===y.ScheduleStyleInvalidationTracking||e.type===y.StyleInvalidatorInvalidationTracking||e.type===y.StyleRecalcInvalidationTracking){e.startTime&&this._lastRecalcStyle&&void 0!==this._lastRecalcStyle.endTime&&e.startTime>=this._lastRecalcStyle.startTime&&e.startTime<=this._lastRecalcStyle.endTime&&this._associateWithLastRecalcStyleEvent(e)}this._invalidations[e.type]?this._invalidations[e.type].push(e):this._invalidations[e.type]=[e],e.nodeId&&(this._invalidationsByNodeId[e.nodeId]?this._invalidationsByNodeId[e.nodeId].push(e):this._invalidationsByNodeId[e.nodeId]=[e])}didRecalcStyle(e){this._lastRecalcStyle=e;const t=[y.ScheduleStyleInvalidationTracking,y.StyleInvalidatorInvalidationTracking,y.StyleRecalcInvalidationTracking];for(const e of this._invalidationsOfTypes(t))this._associateWithLastRecalcStyleEvent(e)}_associateWithLastRecalcStyleEvent(e){if(e.linkedRecalcStyleEvent)return;if(!this._lastRecalcStyle)throw new Error("Last recalculate style event not set.");const t=this._lastRecalcStyle.args.beginData.frame;e.type===y.StyleInvalidatorInvalidationTracking?this._addSyntheticStyleRecalcInvalidations(this._lastRecalcStyle,t,e):e.type===y.ScheduleStyleInvalidationTracking||this._addInvalidationToEvent(this._lastRecalcStyle,t,e),e.linkedRecalcStyleEvent=!0}_addSyntheticStyleRecalcInvalidations(e,t,s){if(s.invalidationList){if(!s.nodeId)return console.error("Invalidation lacks node information."),void console.error(s);for(let e=0;e<s.invalidationList.length;e++){const a=s.invalidationList[e].id;let r;const n=this._invalidationsByNodeId[s.nodeId]||[];for(let e=0;e<n.length;e++){const s=n[e];s.frame===t&&s.invalidationSet===a&&s.type===y.ScheduleStyleInvalidationTracking&&(r=s)}r?this._addSyntheticStyleRecalcInvalidation(r._tracingEvent,s):console.error("Failed to lookup the event that scheduled a style invalidator invalidation.")}}else this._addSyntheticStyleRecalcInvalidation(s._tracingEvent,s)}_addSyntheticStyleRecalcInvalidation(e,t){const s=new R(e);s.type=y.StyleRecalcInvalidationTracking,t.cause.reason&&(s.cause.reason=t.cause.reason),t.selectorPart&&(s.selectorPart=t.selectorPart),this.addInvalidation(s),s.linkedRecalcStyleEvent||this._associateWithLastRecalcStyleEvent(s)}didLayout(e){const t=e.args.beginData.frame;for(const s of this._invalidationsOfTypes([y.LayoutInvalidationTracking]))s.linkedLayoutEvent||(this._addInvalidationToEvent(e,t,s),s.linkedLayoutEvent=!0)}didPaint(e){this._didPaint=!0}_addInvalidationToEvent(e,t,s){if(t!==s.frame)return;const a=w.get(e);a?a.push(s):w.set(e,[s])}_invalidationsOfTypes(e){const t=this._invalidations;return e||(e=Object.keys(t)),function*(){if(e)for(let s=0;s<e.length;++s){const a=t[e[s]]||[];for(let e=0;e<a.length;++e)yield a[e]}}()}_startNewFrameIfNeeded(){this._didPaint&&this._initializePerFrameState()}_initializePerFrameState(){this._invalidations={},this._invalidationsByNodeId={},this._lastRecalcStyle=null,this._lastPaintWithLayer=null,this._didPaint=!1}}class C{constructor(){if(C._initialize(),this._initiatorByType=new Map,C._asyncEvents)for(const e of C._asyncEvents.keys())this._initiatorByType.set(e,new Map)}static _initialize(){if(C._asyncEvents)return;const e=new Map;e.set(y.TimerInstall,{causes:[y.TimerFire],joinBy:"timerId"}),e.set(y.ResourceSendRequest,{causes:[y.ResourceMarkAsCached,y.ResourceReceiveResponse,y.ResourceReceivedData,y.ResourceFinish],joinBy:"requestId"}),e.set(y.RequestAnimationFrame,{causes:[y.FireAnimationFrame],joinBy:"id"}),e.set(y.RequestIdleCallback,{causes:[y.FireIdleCallback],joinBy:"id"}),e.set(y.WebSocketCreate,{causes:[y.WebSocketSendHandshakeRequest,y.WebSocketReceiveHandshakeResponse,y.WebSocketDestroy],joinBy:"identifier"}),C._asyncEvents=e,C._typeToInitiator=new Map;for(const t of e){const e=t[1].causes;for(const s of e)C._typeToInitiator.set(s,t[0])}}processEvent(e){if(!C._typeToInitiator||!C._asyncEvents)return;let t=C._typeToInitiator.get(e.name);const s=!t;t||(t=e.name);const a=C._asyncEvents.get(t);if(!a)return;const r=f.globalEventId(e,a.joinBy);if(!r)return;const n=this._initiatorByType.get(t);if(n){if(s)return void n.set(r,e);const t=n.get(r),a=P.forEvent(e);a.setInitiator(t||null),!a.frameId&&t&&(a.frameId=f.eventFrameId(t))}}}C._asyncEvents=null,C._typeToInitiator=null;class P{constructor(){this.warning=null,this.previewElement=null,this.url=null,this.backendNodeId=0,this.stackTrace=null,this.picture=null,this._initiator=null,this.frameId=""}setInitiator(e){if(this._initiator=e,!e||this.url)return;const t=P.forEvent(e).url;t&&(this.url=t)}initiator(){return this._initiator}topFrame(){const e=this.stackTraceForSelfOrInitiator();return e&&e[0]||null}stackTraceForSelfOrInitiator(){return this.stackTrace||this._initiator&&P.forEvent(this._initiator).stackTrace}static forEvent(e){let t=M.get(e);return t||(t=new P,M.set(e,t)),t}}const M=new WeakMap,w=new WeakMap;var L=Object.freeze({__proto__:null,UIStrings:g,get TimelineModelImpl(){return f},get RecordType(){return y},Track:S,get TrackType(){return I},PageFrame:F,NetworkRequest:k,InvalidationTrackingEvent:R,InvalidationTracker:E,TimelineAsyncEventTracker:C,TimelineData:P});class b{accept(e){return!0}}class N extends b{constructor(e){super(),this._visibleTypes=new Set(e)}accept(e){return this._visibleTypes.has(N._eventType(e))}static _eventType(e){return e.hasCategory(f.Category.Console)?y.ConsoleTime:e.hasCategory(f.Category.UserTiming)?y.UserTiming:e.hasCategory(f.Category.LatencyInfo)?y.LatencyInfo:e.name}}var B=Object.freeze({__proto__:null,TimelineModelFilter:b,TimelineVisibleEventsFilter:N,TimelineInvisibleEventsFilter:class extends b{constructor(e){super(),this._invisibleTypes=new Set(e)}accept(e){return!this._invisibleTypes.has(N._eventType(e))}},ExclusiveNameFilter:class extends b{constructor(e){super(),this._excludeNames=new Set(e)}accept(e){return!this._excludeNames.has(e.name)}}});class D extends d.LayerTreeBase{constructor(e){super(e),this._tileById=new Map,this._paintProfilerModel=e&&e.model(c.PaintProfilerModel)}async setLayers(e,t,s){const a=new Set;if(e)this._extractNodeIdsToResolve(a,{},e);else if(t)for(let e=0;e<t.length;++e)this._extractNodeIdsToResolve(a,{},t[e]);await this.resolveBackendNodeIds(a);const r=this.layersById;if(this.layersById=new Map,this.setContentRoot(null),e){const t=this._innerSetLayers(r,e);this.setRoot(t)}else if(t){const e=t.map(this._innerSetLayers.bind(this,r)),s=this.contentRoot();if(!s)throw new Error("Content root is not set.");this.setRoot(s);for(let t=0;t<e.length;++t)e[t].id()!==s.id()&&s.addChild(e[t])}this._setPaints(s)}setTiles(e){this._tileById=new Map;for(const t of e)this._tileById.set(t.id,t)}pictureForRasterTile(t){const s=this._tileById.get("cc::Tile/"+t);if(!s)return e.Console.instance().error(`Tile ${t} is missing`),Promise.resolve(null);const a=this.layerById(s.layer_id);return a?a._pictureForRect(s.content_rect):(e.Console.instance().error(`Layer ${s.layer_id} for tile ${t} is not found`),Promise.resolve(null))}_setPaints(e){for(let t=0;t<e.length;++t){const s=this.layersById.get(e[t].layerId());s&&s._addPaintEvent(e[t])}}_innerSetLayers(e,t){let s=e.get(t.layer_id);s?s._reset(t):s=new A(this._paintProfilerModel,t),this.layersById.set(t.layer_id,s),t.owner_node&&s._setNode(this.backendNodeIdToNode().get(t.owner_node)||null),!this.contentRoot()&&s.drawsContent()&&this.setContentRoot(s);for(let a=0;t.children&&a<t.children.length;++a)s.addChild(this._innerSetLayers(e,t.children[a]));return s}_extractNodeIdsToResolve(e,t,s){const a=s.owner_node;a&&!this.backendNodeIdToNode().has(a)&&e.add(a);for(let a=0;s.children&&a<s.children.length;++a)this._extractNodeIdsToResolve(e,t,s.children[a])}}class A{constructor(e,t){this._parentLayerId=null,this._parent=null,this._layerId="",this._node=null,this._offsetX=-1,this._offsetY=-1,this._width=-1,this._height=-1,this._children=[],this._quad=[],this._scrollRects=[],this._gpuMemoryUsage=-1,this._paints=[],this._compositingReasonIds=[],this._drawsContent=!1,this._paintProfilerModel=e,this._reset(t)}_reset(e){this._node=null,this._layerId=String(e.layer_id),this._offsetX=e.position[0],this._offsetY=e.position[1],this._width=e.bounds.width,this._height=e.bounds.height,this._children=[],this._parentLayerId=null,this._parent=null,this._quad=e.layer_quad||[],this._createScrollRects(e),this._compositingReasonIds=e.compositing_reason_ids||e.debug_info&&e.debug_info.compositing_reason_ids||[],this._drawsContent=Boolean(e.draws_content),this._gpuMemoryUsage=e.gpu_memory_usage,this._paints=[]}id(){return this._layerId}parentId(){return this._parentLayerId}parent(){return this._parent}isRoot(){return!this.parentId()}children(){return this._children}addChild(e){const t=e;t._parent&&console.assert(!1,"Child already has a parent"),this._children.push(t),t._parent=this,t._parentLayerId=this._layerId}_setNode(e){this._node=e}node(){return this._node}nodeForSelfOrAncestor(){let e=this;for(;e;e=e.parent())if(e.node())return e.node();return null}offsetX(){return this._offsetX}offsetY(){return this._offsetY}width(){return this._width}height(){return this._height}transform(){return null}quad(){return this._quad}anchorPoint(){return[.5,.5,0]}invisible(){return!1}paintCount(){return 0}lastPaintRect(){return null}scrollRects(){return this._scrollRects}stickyPositionConstraint(){return null}gpuMemoryUsage(){return this._gpuMemoryUsage}snapshots(){return this._paints.map((e=>e.snapshotPromise().then((e=>{if(!e)return null;return{rect:{x:e.rect[0],y:e.rect[1],width:e.rect[2],height:e.rect[3]},snapshot:e.snapshot}}))))}_pictureForRect(e){return Promise.all(this._paints.map((e=>e.picturePromise()))).then((s=>{const a=s.filter((s=>{return s&&(a=s.rect,r=e,t(a[0],a[0]+a[2],r[0],r[0]+r[2])&&t(a[1],a[1]+a[3],r[1],r[1]+r[3]));var a,r})).map((e=>({x:e.rect[0],y:e.rect[1],picture:e.serializedPicture})));if(!a.length||!this._paintProfilerModel)return null;const r=a.reduce(((e,t)=>Math.min(e,t.x)),1/0),n=a.reduce(((e,t)=>Math.min(e,t.y)),1/0),i={x:e[0]-r,y:e[1]-n,width:e[2],height:e[3]};return this._paintProfilerModel.loadSnapshotFromFragments(a).then((e=>e?{rect:i,snapshot:e}:null))}));function t(e,t,s,a){return console.assert(e<=t&&s<=a,"segments should be specified as ordered pairs"),t>s&&e<a}}_scrollRectsFromParams(e,t){return{rect:{x:e[0],y:e[1],width:e[2],height:e[3]},type:t}}_createScrollRects(e){const t=[];e.non_fast_scrollable_region&&t.push(this._scrollRectsFromParams(e.non_fast_scrollable_region,d.Layer.ScrollRectType.NonFastScrollable)),e.touch_event_handler_region&&t.push(this._scrollRectsFromParams(e.touch_event_handler_region,d.Layer.ScrollRectType.TouchEventHandler)),e.wheel_event_handler_region&&t.push(this._scrollRectsFromParams(e.wheel_event_handler_region,d.Layer.ScrollRectType.WheelEventHandler)),e.scroll_event_handler_region&&t.push(this._scrollRectsFromParams(e.scroll_event_handler_region,d.Layer.ScrollRectType.RepaintsOnScroll)),this._scrollRects=t}_addPaintEvent(e){this._paints.push(e)}requestCompositingReasonIds(){return Promise.resolve(this._compositingReasonIds)}drawsContent(){return this._drawsContent}}var W=Object.freeze({__proto__:null,TracingLayerTree:D,TracingLayer:A});const x={twoFlingsAtTheSameTimeSVsS:"Two flings at the same time? {PH1} vs {PH2}",twoTouchesAtTheSameTimeSVsS:"Two touches at the same time? {PH1} vs {PH2}"},U=a.registerUIStrings("timeline_model/TimelineIRModel.ts",x),G=a.getLocalizedString.bind(void 0,U),H=new WeakMap;class q{constructor(){this.reset()}static phaseForEvent(e){return H.get(e)}populate(e,t){if(this.reset(),!e)return;this._processInputLatencies(e),t&&this._processAnimations(t);const a=new s.SegmentedRange;a.appendRange(this._drags),a.appendRange(this._cssAnimations),a.appendRange(this._scrolls),a.appendRange(this._responses),this._segments=a.segments()}_processInputLatencies(t){const s=O,a=z,r=q._mergeThresholdsMs;let n,i,o,l,d,c,h;for(let u=0;u<t.length;++u){const p=t[u];u>0&&t[u].startTime<t[u-1].startTime&&console.assert(!1,"Unordered input events");switch(this._inputEventType(p.name)){case s.ScrollBegin:this._scrolls.append(this._segmentForEvent(p,a.Scroll)),n=p;break;case s.ScrollEnd:n?this._scrolls.append(this._segmentForEventRange(n,p,a.Scroll)):this._scrolls.append(this._segmentForEvent(p,a.Scroll)),n=null;break;case s.ScrollUpdate:o=null,this._scrolls.append(this._segmentForEvent(p,a.Scroll));break;case s.FlingStart:if(i){e.Console.instance().error(G(x.twoFlingsAtTheSameTimeSVsS,{PH1:i.startTime,PH2:p.startTime}));break}i=p;break;case s.FlingCancel:if(!i)break;this._scrolls.append(this._segmentForEventRange(i,p,a.Fling)),i=null;break;case s.ImplSideFling:this._scrolls.append(this._segmentForEvent(p,a.Fling));break;case s.ShowPress:case s.Tap:case s.KeyDown:case s.KeyDownRaw:case s.KeyUp:case s.Char:case s.Click:case s.ContextMenu:this._responses.append(this._segmentForEvent(p,a.Response));break;case s.TouchStart:if(o){e.Console.instance().error(G(x.twoTouchesAtTheSameTimeSVsS,{PH1:o.startTime,PH2:p.startTime}));break}o=p,this._setPhaseForEvent(p,a.Response),l=null;break;case s.TouchCancel:o=null;break;case s.TouchMove:l?this._drags.append(this._segmentForEvent(p,a.Drag)):o&&(l=p,this._responses.append(this._segmentForEventRange(o,p,a.Response)));break;case s.TouchEnd:o=null;break;case s.MouseDown:c=p,h=null;break;case s.MouseMove:c&&!h&&c.startTime+r.mouse>p.startTime?(this._responses.append(this._segmentForEvent(c,a.Response)),this._responses.append(this._segmentForEvent(p,a.Response))):c&&this._drags.append(this._segmentForEvent(p,a.Drag)),h=p;break;case s.MouseUp:this._responses.append(this._segmentForEvent(p,a.Response)),c=null;break;case s.MouseWheel:d&&m(r.mouse,d,p)?this._scrolls.append(this._segmentForEventRange(d,p,a.Scroll)):this._scrolls.append(this._segmentForEvent(p,a.Scroll)),d=p}}function m(e,t,s){return void 0!==t.endTime&&(t.endTime<s.startTime&&s.startTime<t.endTime+e)}}_processAnimations(e){for(let t=0;t<e.length;++t)this._cssAnimations.append(this._segmentForEvent(e[t],z.Animation))}_segmentForEvent(e,t){return this._setPhaseForEvent(e,t),new s.Segment(e.startTime,void 0!==e.endTime?e.endTime:Number.MAX_SAFE_INTEGER,t)}_segmentForEventRange(e,t,a){return this._setPhaseForEvent(e,a),this._setPhaseForEvent(t,a),new s.Segment(e.startTime,void 0!==e.endTime?e.endTime:Number.MAX_SAFE_INTEGER,a)}_setPhaseForEvent(e,t){H.set(e.steps[0],t)}interactionRecords(){return this._segments}reset(){const e=q._mergeThresholdsMs;function t(e,t,s){return t.end+e>=s.begin&&t.data===s.data?t:null}this._segments=[],this._drags=new s.SegmentedRange(t.bind(null,e.mouse)),this._cssAnimations=new s.SegmentedRange(t.bind(null,e.animation)),this._responses=new s.SegmentedRange(t.bind(null,0)),this._scrolls=new s.SegmentedRange(t.bind(null,e.animation))}_inputEventType(e){const t="InputLatency::";if(!e.startsWith(t)){const t=e;return t===O.ImplSideFling?t:(console.error("Unrecognized input latency event: "+e),null)}return e.substr(t.length)}}var z,O;!function(e){e.Idle="Idle",e.Response="Response",e.Scroll="Scroll",e.Fling="Fling",e.Drag="Drag",e.Animation="Animation",e.Uncategorized="Uncategorized"}(z||(z={})),function(e){e.Char="Char",e.Click="GestureClick",e.ContextMenu="ContextMenu",e.FlingCancel="GestureFlingCancel",e.FlingStart="GestureFlingStart",e.ImplSideFling="InputHandlerProxy::HandleGestureFling::started",e.KeyDown="KeyDown",e.KeyDownRaw="RawKeyDown",e.KeyUp="KeyUp",e.LatencyScrollUpdate="ScrollUpdate",e.MouseDown="MouseDown",e.MouseMove="MouseMove",e.MouseUp="MouseUp",e.MouseWheel="MouseWheel",e.PinchBegin="GesturePinchBegin",e.PinchEnd="GesturePinchEnd",e.PinchUpdate="GesturePinchUpdate",e.ScrollBegin="GestureScrollBegin",e.ScrollEnd="GestureScrollEnd",e.ScrollUpdate="GestureScrollUpdate",e.ScrollUpdateRenderer="ScrollUpdate",e.ShowPress="GestureShowPress",e.Tap="GestureTap",e.TapCancel="GestureTapCancel",e.TapDown="GestureTapDown",e.TouchCancel="TouchCancel",e.TouchEnd="TouchEnd",e.TouchMove="TouchMove",e.TouchStart="TouchStart"}(O||(O={})),function(e){e._mergeThresholdsMs={animation:1,mouse:40},e._eventIRPhase=Symbol("eventIRPhase")}(q||(q={}));var j=Object.freeze({__proto__:null,UIStrings:x,get TimelineIRModel(){return q},get Phases(){return z},get InputEvents(){return O}});class J{constructor(e){this._categoryMapper=e,this.reset()}frames(e,t){if(!e&&!t)return this._frames;const s=r.lowerBound(this._frames,e||0,((e,t)=>e-t.endTime)),a=r.lowerBound(this._frames,t||1/0,((e,t)=>e-t.startTime));return this._frames.slice(s,a)}hasRasterTile(e){const t=e.args.tileData;if(!t)return!1;const s=t.sourceFrameNumber,a=s&&this._frameById[s];return!(!a||!a.layerTree)}rasterTilePromise(e){if(!this._target)return Promise.resolve(null);const t=e.args.tileData,s=t.sourceFrameNumber,a=t.tileId&&t.tileId.id_ref,r=s&&this._frameById[s];return r&&r.layerTree&&a?r.layerTree.layerTreePromise().then((e=>e&&e.pictureForRasterTile(a))):Promise.resolve(null)}reset(){this._minimumRecordTime=1/0,this._frames=[],this._frameById={},this._lastFrame=null,this._lastLayerTree=null,this._mainFrameCommitted=!1,this._mainFrameRequested=!1,this._framePendingCommit=null,this._lastBeginFrame=null,this._lastDroppedFrame=null,this._lastNeedsBeginFrame=null,this._framePendingActivation=null,this._lastTaskBeginTime=null,this._target=null,this._layerTreeId=null,this._currentTaskTimeByCategory={}}handleBeginFrame(e){this._lastFrame||this._startFrame(e),this._lastBeginFrame=e}handleDroppedFrame(e){this._lastFrame||this._startFrame(e),this._lastDroppedFrame=e}handleDrawFrame(e){if(this._lastFrame){if(this._mainFrameCommitted||!this._mainFrameRequested){if(this._lastNeedsBeginFrame){const e=this._framePendingActivation?this._framePendingActivation.triggerTime:this._lastBeginFrame||this._lastNeedsBeginFrame;e>this._lastFrame.startTime&&(this._lastFrame.idle=!0,this._startFrame(e),this._framePendingActivation&&this._commitPendingFrame(),this._lastBeginFrame=null),this._lastNeedsBeginFrame=null}this._lastDroppedFrame&&(this._lastFrame.dropped=!0,this._startFrame(this._lastDroppedFrame),this._lastDroppedFrame=null),this._startFrame(e)}this._mainFrameCommitted=!1}else this._startFrame(e)}handleActivateLayerTree(){this._lastFrame&&this._framePendingActivation&&!this._lastNeedsBeginFrame&&this._commitPendingFrame()}handleRequestMainThreadFrame(){this._lastFrame&&(this._mainFrameRequested=!0)}handleCompositeLayers(){this._framePendingCommit&&(this._framePendingActivation=this._framePendingCommit,this._framePendingCommit=null,this._mainFrameRequested=!1,this._mainFrameCommitted=!0)}handleLayerTreeSnapshot(e){this._lastLayerTree=e}handleNeedFrameChanged(e,t){t&&(this._lastNeedsBeginFrame=e)}_startFrame(e){this._lastFrame&&this._flushFrame(this._lastFrame,e),this._lastFrame=new V(e,e-this._minimumRecordTime)}_flushFrame(e,t){e._setLayerTree(this._lastLayerTree),e._setEndTime(t),this._lastLayerTree&&this._lastLayerTree._setPaints(e._paints);const s=this._frames[this._frames.length-1];this._frames.length&&s&&(e.startTime!==s.endTime||e.startTime>e.endTime)&&console.assert(!1,`Inconsistent frame time for frame ${this._frames.length} (${e.startTime} - ${e.endTime})`),this._frames.push(e),"number"==typeof e._mainFrameId&&(this._frameById[e._mainFrameId]=e)}_commitPendingFrame(){this._framePendingActivation&&this._lastFrame&&(this._lastFrame._addTimeForCategories(this._framePendingActivation.timeByCategory),this._lastFrame._paints=this._framePendingActivation.paints,this._lastFrame._mainFrameId=this._framePendingActivation.mainFrameId,this._framePendingActivation=null)}addTraceEvents(e,t,s){this._target=e;let a=0;this._currentProcessMainThread=s.length&&s[0].thread||null;for(let e=0;e<t.length;++e){for(;a+1<s.length&&s[a+1].time<=t[e].startTime;)this._currentProcessMainThread=s[++a].thread;this._addTraceEvent(t[e])}this._currentProcessMainThread=null}_addTraceEvent(e){if(e.startTime&&e.startTime<this._minimumRecordTime&&(this._minimumRecordTime=e.startTime),e.name===y.SetLayerTreeId)this._layerTreeId=e.args.layerTreeId||e.args.data.layerTreeId;else if(e.id&&e.phase===i.Phase.SnapshotObject&&e.name===y.LayerTreeHostImplSnapshot&&Number(e.id)===this._layerTreeId&&this._target){const t=e;this.handleLayerTreeSnapshot(new $(this._target,t))}else this._processCompositorEvents(e),e.thread===this._currentProcessMainThread?this._addMainThreadTraceEvent(e):this._lastFrame&&e.selfTime&&!i.TracingModel.isTopLevelEvent(e)&&this._lastFrame._addTimeForCategory(this._categoryMapper(e),e.selfTime)}_processCompositorEvents(e){if(e.args.layerTreeId!==this._layerTreeId)return;const t=e.startTime;e.name===y.BeginFrame?this.handleBeginFrame(t):e.name===y.DrawFrame?this.handleDrawFrame(t):e.name===y.ActivateLayerTree?this.handleActivateLayerTree():e.name===y.RequestMainThreadFrame?this.handleRequestMainThreadFrame():e.name===y.NeedsBeginFrameChanged?this.handleNeedFrameChanged(t,e.args.data&&e.args.data.needsBeginFrame):e.name===y.DroppedFrame&&this.handleDroppedFrame(t)}_addMainThreadTraceEvent(e){i.TracingModel.isTopLevelEvent(e)&&(this._currentTaskTimeByCategory={},this._lastTaskBeginTime=e.startTime),!this._framePendingCommit&&J._mainFrameMarkers.indexOf(e.name)>=0&&(this._framePendingCommit=new K(this._lastTaskBeginTime||e.startTime,this._currentTaskTimeByCategory)),this._framePendingCommit?(this._addTimeForCategory(this._framePendingCommit.timeByCategory,e),e.name===y.BeginMainThreadFrame&&e.args.data&&e.args.data.frameId&&(this._framePendingCommit.mainFrameId=e.args.data.frameId),e.name===y.Paint&&e.args.data.layerId&&P.forEvent(e).picture&&this._target&&this._framePendingCommit.paints.push(new X(e,this._target)),e.name===y.CompositeLayers&&e.args.layerTreeId===this._layerTreeId&&this.handleCompositeLayers()):this._addTimeForCategory(this._currentTaskTimeByCategory,e)}_addTimeForCategory(e,t){if(!t.selfTime)return;const s=this._categoryMapper(t);e[s]=(e[s]||0)+t.selfTime}}J._mainFrameMarkers=[y.ScheduleStyleRecalculation,y.InvalidateLayout,y.BeginMainThreadFrame,y.ScrollLayer];class ${constructor(e,t){this._target=e,this._snapshot=t}async layerTreePromise(){const e=await this._snapshot.objectPromise();if(!e)return null;const t=e.device_viewport_size,s=e.active_tiles,a=e.active_tree.root_layer,r=e.active_tree.layers,n=new D(this._target);return n.setViewportSize(t),n.setTiles(s),await n.setLayers(a,r,this._paints||[]),n}paints(){return this._paints||[]}_setPaints(e){this._paints=e}}class V{constructor(e,t){this.startTime=e,this.startTimeOffset=t,this.endTime=this.startTime,this.duration=0,this.timeByCategory={},this.cpuTime=0,this.idle=!1,this.dropped=!1,this.layerTree=null,this._paints=[],this._mainFrameId=void 0}hasWarnings(){return!1}_setEndTime(e){this.endTime=e,this.duration=this.endTime-this.startTime}_setLayerTree(e){this.layerTree=e}_addTimeForCategories(e){for(const t in e)this._addTimeForCategory(t,e[t])}_addTimeForCategory(e,t){this.timeByCategory[e]=(this.timeByCategory[e]||0)+t,this.cpuTime+=t}}class X{constructor(e,t){this._event=e,this._target=t}layerId(){return this._event.args.data.layerId}event(){return this._event}picturePromise(){const e=P.forEvent(this._event).picture;return e?e.objectPromise().then((e=>{if(!e)return null;const t=e.params&&e.params.layer_rect,s=e.skp64;return t&&s?{rect:t,serializedPicture:s}:null})):Promise.resolve(null)}async snapshotPromise(){const e=this._target&&this._target.model(c.PaintProfilerModel),t=await this.picturePromise();if(!t||!e)return null;const s=await e.loadSnapshot(t.serializedPicture);return s?{rect:t.rect,snapshot:s}:null}}class K{constructor(e,t){this.timeByCategory=t,this.paints=[],this.mainFrameId=void 0,this.triggerTime=e}}var Y=Object.freeze({__proto__:null,TimelineFrameModel:J,TracingFrameLayerTree:$,TimelineFrame:V,LayerPaintEvent:X,PendingFrame:K});class Q{constructor(e,t){this.totalTime=0,this.selfTime=0,this.id=e,this.event=t,this._groupId="",this._isGroupNode=!1,this._depth=0}isGroupNode(){return this._isGroupNode}hasChildren(){throw"Not implemented"}setHasChildren(e){throw"Not implemented"}children(){throw"Not implemented"}searchTree(e,t){t=t||[],this.event&&e(this.event)&&t.push(this);for(const s of this.children().values())s.searchTree(e,t);return t}}class Z extends Q{constructor(e,t,s){super(e,t),this._root=s&&s._root,this._hasChildren=!1,this._children=null,this.parent=s}hasChildren(){return this._hasChildren}setHasChildren(e){this._hasChildren=e}children(){return this._children||this._buildChildren()}_buildChildren(){const e=[];for(let t=this;t.parent&&!t._isGroupNode;t=t.parent)e.push(t);e.reverse();const t=new Map,s=this,a=this._root;if(!a)return this._children=t,this._children;const r=a._startTime,n=a._endTime,i=a._doNotAggregate?function(t){++d,c===e.length&&d<=e.length+2&&m(t,0);--d}:void 0,o=a._doNotAggregate?void 0:ae,l=a._eventGroupIdCallback;let d=0,c=0,h=null;function m(a,r){if(d===e.length+2){if(!h)return;return h.setHasChildren(!0),void(h.selfTime-=r)}let n,i="";o?(n=o(a),i=l?l(a):"",i&&(n+="/"+i)):n=Symbol("uniqueId");let c=t.get(n);c||(c=new Z(n,a,s),c._groupId=i,t.set(n,c)),c.selfTime+=r,c.totalTime+=r,h=c}return f.forEachEvent(a._events,(function(t){if(++d,d>e.length+2)return;if(!function(t){if(c===e.length)return!0;if(c!==d-1)return!1;if(!t.endTime)return!1;if(!o)return t===e[c].event&&++c,!1;let s=o(t);const a=l?l(t):"";a&&(s+="/"+a);s===e[c].id&&++c;return!1}(t))return;const s=(void 0!==t.endTime?Math.min(t.endTime,n):n)-Math.max(r,t.startTime);s<0&&console.error("Negative event duration");m(t,s)}),(function(e){--d,c>d&&(c=d)}),i,r,n,a._filter),this._children=t,t}}class ee extends Q{constructor(e,t,s){super(e,s),this._children=new Map,this.parent=t,this._isGroupNode=!0}addChild(e,t,s){this._children.set(e.id,e),this.selfTime+=t,this.totalTime+=s,e.parent=this}hasChildren(){return!0}children(){return this._children}}class te extends Q{constructor(e,t,s,a,r){super(t,s),this.parent=r,this._root=e,this._depth=(r._depth||0)+1,this._cachedChildren=null,this._hasChildren=a}hasChildren(){return this._hasChildren}setHasChildren(e){this._hasChildren=e}children(){if(this._cachedChildren)return this._cachedChildren;const e=[0],t=[],s=[],a=new Map,r=this._root._startTime,n=this._root._endTime;let i=r;const o=this;return f.forEachEvent(this._root._events,(function(a){const i=(void 0!==a.endTime?Math.min(a.endTime,n):n)-Math.max(a.startTime,r);i<0&&console.assert(!1,"Negative duration of an event");e[e.length-1]-=i,e.push(i);const o=ae(a);t.push(o),s.push(a)}),(function(r){const l=e.pop(),d=t.pop();let c;for(s.pop(),c=o;c._depth>1;c=c.parent)if(c.id!==t[t.length+1-c._depth])return;if(c.id!==d||t.length<o._depth)return;const h=t[t.length-o._depth];if(c=a.get(h),!c){const e=s[s.length-o._depth],t=s.length>o._depth;c=new te(o._root,h,e,t,o),a.set(h,c)}const m=void 0!==r.endTime?Math.min(r.endTime,n):n,u=m-Math.max(r.startTime,i);c.selfTime+=l||0,c.totalTime+=u,i=m}),void 0,r,n,this._root._filter),this._cachedChildren=this._root._filterChildren(a),this._cachedChildren}searchTree(e,t){return t=t||[],this.event&&e(this.event)&&t.push(this),t}}function se(e){return e.name===y.JSFrame?e.args.data||null:P.forEvent(e).topFrame()}function ae(e){if(e.name===y.TimeStamp)return`${e.name}:${e.args.data.message}`;if(e.name!==y.JSFrame)return e.name;const t=e.args.data,s=t.scriptId||t.url||"",a=t.functionName;return`f:${p.isNativeRuntimeFrame(t)?p.nativeGroup(a)||a:`${a}:${t.lineNumber}:${t.columnNumber}`}@${s}`}var re=Object.freeze({__proto__:null,Node:Q,TopDownNode:Z,TopDownRootNode:class extends Z{constructor(e,t,s,a,r,n){super("",null,null),this._root=this,this._events=e,this._filter=e=>t.every((t=>t.accept(e))),this._startTime=s,this._endTime=a,this._eventGroupIdCallback=n,this._doNotAggregate=r,this.totalTime=a-s,this.selfTime=this.totalTime}children(){return this._children||this._grouppedTopNodes()}_grouppedTopNodes(){const e=super.children();for(const t of e.values())this.selfTime-=t.totalTime;if(!this._eventGroupIdCallback)return e;const t=new Map;for(const s of e.values()){const e=this._eventGroupIdCallback(s.event);let a=t.get(e);a||(a=new ee(e,this,s.event),t.set(e,a)),a.addChild(s,s.selfTime,s.totalTime)}return this._children=t,t}},BottomUpRootNode:class extends Q{constructor(e,t,s,a,r,n){super("",null),this._children=null,this._events=e,this._textFilter=t,this._filter=e=>s.every((t=>t.accept(e))),this._startTime=a,this._endTime=r,this._eventGroupIdCallback=n,this.totalTime=r-a}hasChildren(){return!0}_filterChildren(e){for(const[t,s]of e)s.event&&!this._textFilter.accept(s.event)&&e.delete(t);return e}children(){return this._children||(this._children=this._filterChildren(this._grouppedTopNodes())),this._children}_ungrouppedTopNodes(){const e=this,t=this._startTime,s=this._endTime,a=new Map,r=[s-t],n=[],i=new Map;f.forEachEvent(this._events,(function(e){const a=(void 0!==e.endTime?Math.min(e.endTime,s):s)-Math.max(e.startTime,t);r[r.length-1]-=a,r.push(a);const o=ae(e),l=!i.has(o);l&&i.set(o,a);n.push(l)}),(function(t){const s=ae(t);let o=a.get(s);o||(o=new te(e,s,t,!1,e),a.set(s,o));o.selfTime+=r.pop()||0,n.pop()&&(o.totalTime+=i.get(s)||0,i.delete(s));n.length&&o.setHasChildren(!0)}),void 0,t,s,this._filter),this.selfTime=r.pop()||0;for(const e of a)e[1].selfTime<=0&&a.delete(e[0]);return a}_grouppedTopNodes(){const e=this._ungrouppedTopNodes();if(!this._eventGroupIdCallback)return e;const t=new Map;for(const s of e.values()){const e=this._eventGroupIdCallback(s.event);let a=t.get(e);a||(a=new ee(e,this,s.event),t.set(e,a)),a.addChild(s,s.selfTime,s.selfTime)}return t}},GroupNode:ee,BottomUpNode:te,eventURL:function(e){const t=e.args.data||e.args.beginData;if(t&&t.url)return t.url;let s=se(e);for(;s;){const e=s.url;if(e)return e;s=s.parent}return null},eventStackFrame:se,_eventId:ae});export{Y as TimelineFrameModel,j as TimelineIRModel,_ as TimelineJSProfile,L as TimelineModel,B as TimelineModelFilter,re as TimelineProfileTree,W as TracingLayerTree};
